////////////////////////////////////////////////////////////////////////////////
// TITRE : DWEB - DATAWAREHOUSE ENGINEERING BENCHMARK - VERSION 0.4           //
//----------------------------------------------------------------------------//
// AUTEURS : JOUBERT Bruno / GUESMIA Sofiane                                  //
//           UNIVERSITE LYON 2 - MASTER IIDEE                                 //
//----------------------------------------------------------------------------//
// English translation by J. Darmont                                          //
// - Step 1: Interface (DONE)                                                 //
// - Step 2: Code/comments (TO DO)                                            //
//----------------------------------------------------------------------------//
// ENCADRES PAR : DARMONT Jrome                                              //
//                UNIVERSITE LYON 2 - LABORATOIRE ERIC                        //
//                http://eric.univ-lyon2.fr - - jerome.darmont@univ-lyon2.fr  //
//----------------------------------------------------------------------------//
// DESCRIPTION : Banc d'essai dcisionnel                                     //
//----------------------------------------------------------------------------//
// Cette application a pour but de permettre la cration d'un entrept de     //
// donnes synthtique et des charges associes.                              //
////////////////////////////////////////////////////////////////////////////////

package dweb03;

import java.sql.*;
import java.lang.*;

////////////////////////////////////////////////////////////////////////////////
// CLASSE BaseDonnees                                                         //
//----------------------------------------------------------------------------//
// Cette classe sert  grer les connexions  la base de donnes.             //
////////////////////////////////////////////////////////////////////////////////

public class BaseDonnees {

////////////////////////////////////////////////////////////////////////////////
// ATTRIBUTS                                                                  //
////////////////////////////////////////////////////////////////////////////////
  private Connection connexion ; // Permet de faire la connexion a la base de donnees  //  @jve:decl-index=0:
  private boolean connexionEtablie;

////////////////////////////////////////////////////////////////////////////////
// CONSTRUCTEURS                                                              //
////////////////////////////////////////////////////////////////////////////////

  public BaseDonnees (){
    connexionEtablie = false;
  }

////////////////////////////////////////////////////////////////////////////////
// METHODES                                                                   //
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// FONCTION connexionBD - OK                                                  //
//----------------------------------------------------------------------------//
// E : paramtres de connexion                                                //
// S : boolean | resultat de la tentative de connexion                        //
////////////////////////////////////////////////////////////////////////////////
  public boolean connexionBD (String pHote, String pNomBD, String pNomUtil, String pPassUtil, String[] pMessage) {
    try {
      //////////////////////////////////////////////////////////////////////////
      // code de connexion a BD Oracle                                        //
      //////////////////////////////////////////////////////////////////////////

      String cheminBD = "jdbc:oracle:thin:@" + pHote + ":" + pNomBD;
      Class.forName( "oracle.jdbc.driver.OracleDriver" );
      this.connexion = DriverManager.getConnection( cheminBD, pNomUtil, pPassUtil);

      pMessage[0] = "Connecting to database '" + cheminBD + "' OK";
      connexionEtablie = true;
      return true ;
    }
    catch (ClassNotFoundException e) {
      pMessage[0] = "ClassNotFoundException : " + e;
      return false ;
    }
    catch (SQLException e) {
      pMessage[0] = "SQLException : " + e;
      return false ;
    }
  }

////////////////////////////////////////////////////////////////////////////////
// FONCTION deconnexionBD - OK                                                //
//----------------------------------------------------------------------------//
// E : pMessage | String  | tableau de chaines pour rcupration des messages //
// S : boolean | resultat de la tentative de dconnexion                      //
////////////////////////////////////////////////////////////////////////////////
  public boolean deconnexionBD(String[] pMessage) {
    try {
      this.connexion.close();
      pMessage[0] = "Logout OK";
      connexionEtablie = false;
      return true;
    }
    catch (SQLException e) {
      pMessage[0] = "SQLException : " + e;
      return false ;
    }
  }

////////////////////////////////////////////////////////////////////////////////
// FONCTION estConnectee - OK                                                 //
//----------------------------------------------------------------------------//
// E : \                                                                      //
// S : boolean | tat de la connexion                                         //
////////////////////////////////////////////////////////////////////////////////
  public boolean estConnectee () {
    return this.connexionEtablie;
  }

////////////////////////////////////////////////////////////////////////////////
// FONCTION getConnexion - OK                                                 //
//----------------------------------------------------------------------------//
// E : \                                                                      //
// S : Connection | instance de la connexion                                  //
////////////////////////////////////////////////////////////////////////////////
  public Connection getConnexion () {
    return this.connexion;
  }
////////////////////////////////////////////////////////////////////////////////
}
