////////////////////////////////////////////////////////////////////////////////
// TITRE : DWEB - DATAWAREHOUSE ENGINEERING BENCHMARK - VERSION 0.4           //
//----------------------------------------------------------------------------//
// AUTEURS : JOUBERT Bruno / GUESMIA Sofiane                                  //
//           UNIVERSITE LYON 2 - MASTER IIDEE                                 //
//----------------------------------------------------------------------------//
// English translation by J. Darmont                                          //
// - Step 1: Interface (DONE)                                                 //
// - Step 2: Code/comments (TO DO)                                            //
//----------------------------------------------------------------------------//
// ENCADRES PAR : DARMONT Jrome                                              //
//                UNIVERSITE LYON 2 - LABORATOIRE ERIC                        //
//                http://eric.univ-lyon2.fr - - jerome.darmont@univ-lyon2.fr  //
//----------------------------------------------------------------------------//
// DESCRIPTION : Banc d'essai dcisionnel                                     //
//----------------------------------------------------------------------------//
// Cette application a pour but de permettre la cration d'un entrept de     //
// donnes synthtique et des charges associes.                              //
////////////////////////////////////////////////////////////////////////////////

package dweb03;

import java.awt.*;
import javax.swing.*;
import javax.swing.table.*;
import java.awt.event.*;

public class DLGParametresBN extends JDialog {
  // Dclaration des jTable
  JTable jTableTablesFaits = new JTable();
  JTable jTableDimensions = new JTable();

  // Pour mise en forme des tableaux
  DefaultTableCellRenderer tclRenduCellule = new DefaultTableCellRenderer(){
    public Component getTableCellRendererComponent(JTable table, Object value, boolean isSelected, boolean hasFocus,int row, int column) {
      return super.getTableCellRendererComponent(table, value, isSelected, hasFocus, row, column);
    }
  };

  // Dclaration des modeles des jTable (voir classes associes)
  ModeleTableTF tablesFaits = new ModeleTableTF();
  ModeleTableDimension dimensions = new ModeleTableDimension();

  JPanel contentPanel = new JPanel();
  JPanel jPTablesFaits = new JPanel();
  JPanel jPDimensions = new JPanel();
  JPanel jPTablesFaitsTitre = new JPanel();
  JPanel jPDimensionsTitre = new JPanel();
  JScrollPane jSPTablesFaits = new JScrollPane();
  JScrollPane jSPDimensions = new JScrollPane();
  BorderLayout bLTablesFaitsTitre = new BorderLayout();
  BorderLayout bLTablesFaits = new BorderLayout();
  BorderLayout bLDimensions = new BorderLayout();
  JPanel jPValidation = new JPanel();
  JLabel jLBTablesFaitsTitre = new JLabel();
  JLabel jLBDimensionsTitre = new JLabel();
  BorderLayout bLDimensionsTitre = new BorderLayout();
  JPanel jPTablesFaitsSaisie = new JPanel();
  JPanel jPDimensionsSaisie = new JPanel();
  JLabel jLBTablesFaitsSaisie = new JLabel();
  JTextField jTFTablesFaitsSaisie = new JTextField();
  FlowLayout fLTablesFaitsSaisie = new FlowLayout();
  JButton jBTTablesFaitsSaisie = new JButton();
  JButton jBTDimensionsSaisie = new JButton();
  JLabel jLBDimensionsSaisie = new JLabel();
  JTextField jTFDimensionsSaisie = new JTextField();
  FlowLayout fLDimensionsSaisie = new FlowLayout();
  FlowLayout fLValidation = new FlowLayout();
  JButton jBTValider = new JButton();

  public DLGParametresBN(Frame frame, String title, boolean modal) {
    super(frame, title, modal);
    try {
      jbInit();
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  public DLGParametresBN() {
    this(null, "", false);
  }

  private void jbInit() throws Exception {
    jSPTablesFaits.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
    jSPTablesFaits.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
    jSPTablesFaits.setBorder(BorderFactory.createEtchedBorder());
    jSPDimensions.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
    jSPDimensions.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
    jSPDimensions.setBorder(BorderFactory.createEtchedBorder());

    contentPanel.setLayout(null);
    this.setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
    this.setModal(true);
    this.setResizable(false);
    this.setTitle("Data warehouse low-level parameters");
    contentPanel.setBorder(null);
    contentPanel.setMaximumSize(new Dimension(400, 450));
    contentPanel.setMinimumSize(new Dimension(400, 450));
    contentPanel.setPreferredSize(new Dimension(400, 450));
    jPDimensions.setMaximumSize(new Dimension(0, 180));
    jPDimensions.setMinimumSize(new Dimension(0, 180));
    jPDimensions.setPreferredSize(new Dimension(0, 180));
    jPDimensions.setBounds(new Rectangle(5, 15, 390, 180));
    jPDimensions.setLayout(bLDimensions);
    jPTablesFaits.setMaximumSize(new Dimension(0, 180));
    jPTablesFaits.setMinimumSize(new Dimension(0, 180));
    jPTablesFaits.setPreferredSize(new Dimension(0, 180));
    jPTablesFaits.setBounds(new Rectangle(5, 200, 390, 180));
    jPTablesFaits.setLayout(bLTablesFaits);
    jPTablesFaitsTitre.setLayout(bLTablesFaitsTitre);
    jPTablesFaitsTitre.setBorder(BorderFactory.createEtchedBorder());
    jPTablesFaitsTitre.setMaximumSize(new Dimension(0, 70));
    jPTablesFaitsTitre.setMinimumSize(new Dimension(0, 70));
    jPTablesFaitsTitre.setPreferredSize(new Dimension(0, 70));
    jPDimensionsTitre.setBorder(BorderFactory.createEtchedBorder());
    jPDimensionsTitre.setMaximumSize(new Dimension(0, 70));
    jPDimensionsTitre.setMinimumSize(new Dimension(0, 7));
    jPDimensionsTitre.setPreferredSize(new Dimension(0, 70));
    jPDimensionsTitre.setLayout(bLDimensionsTitre);
    jPValidation.setBorder(BorderFactory.createEtchedBorder());
    jPValidation.setMaximumSize(new Dimension(0, 50));
    jPValidation.setMinimumSize(new Dimension(0, 50));
    jPValidation.setPreferredSize(new Dimension(0, 50));
    jPValidation.setBounds(new Rectangle(5, 385, 390, 50));
    jPValidation.setLayout(fLValidation);
    jLBTablesFaitsTitre.setText("Fact tables");
    jLBTablesFaitsTitre.setHorizontalTextPosition(SwingConstants.CENTER);
    jLBTablesFaitsTitre.setHorizontalAlignment(SwingConstants.CENTER);
    jLBTablesFaitsTitre.setPreferredSize(new Dimension(290, 20));
    jLBTablesFaitsTitre.setMinimumSize(new Dimension(290, 20));
    jLBTablesFaitsTitre.setMaximumSize(new Dimension(290, 20));
    jLBTablesFaitsTitre.setBorder(BorderFactory.createRaisedBevelBorder());
    jLBTablesFaitsTitre.setAlignmentY((float) 0.0);
    jLBTablesFaitsTitre.setAlignmentX((float) 0.0);
    jLBTablesFaitsTitre.setFont(new java.awt.Font("Arial", 1, 12));
    jLBDimensionsTitre.setFont(new java.awt.Font("Arial", 1, 12));
    jLBDimensionsTitre.setAlignmentX((float) 0.0);
    jLBDimensionsTitre.setAlignmentY((float) 0.0);
    jLBDimensionsTitre.setBorder(BorderFactory.createRaisedBevelBorder());
    jLBDimensionsTitre.setMaximumSize(new Dimension(290, 20));
    jLBDimensionsTitre.setMinimumSize(new Dimension(290, 20));
    jLBDimensionsTitre.setPreferredSize(new Dimension(290, 20));
    jLBDimensionsTitre.setHorizontalAlignment(SwingConstants.CENTER);
    jLBDimensionsTitre.setHorizontalTextPosition(SwingConstants.CENTER);
    jLBDimensionsTitre.setText("Dimensions");
    jLBTablesFaitsSaisie.setMaximumSize(new Dimension(140, 20));
    jLBTablesFaitsSaisie.setMinimumSize(new Dimension(140, 20));
    jLBTablesFaitsSaisie.setPreferredSize(new Dimension(140, 20));
    jLBTablesFaitsSaisie.setToolTipText("");
    jLBTablesFaitsSaisie.setText("Number of fact tables (NB_FT):");
    jTFTablesFaitsSaisie.setMaximumSize(new Dimension(50, 20));
    jTFTablesFaitsSaisie.setMinimumSize(new Dimension(50, 20));
    jTFTablesFaitsSaisie.setPreferredSize(new Dimension(50, 20));
    jTFTablesFaitsSaisie.setSelectionStart(0);
    jTFTablesFaitsSaisie.setText("1");
    jTFTablesFaitsSaisie.addActionListener(new DLGParametresBN_jTFTablesFaitsSaisie_actionAdapter(this));
    jPTablesFaitsSaisie.setLayout(fLTablesFaitsSaisie);
    jBTTablesFaitsSaisie.setMaximumSize(new Dimension(50, 20));
    jBTTablesFaitsSaisie.setMinimumSize(new Dimension(50, 20));
    jBTTablesFaitsSaisie.setPreferredSize(new Dimension(50, 20));
    jBTTablesFaitsSaisie.setText("OK");
    jBTTablesFaitsSaisie.addActionListener(new DLGParametresBN_jBTTablesFaitsSaisie_actionAdapter(this));
    fLTablesFaitsSaisie.setAlignment(FlowLayout.LEFT);
    fLTablesFaitsSaisie.setHgap(5);
    fLTablesFaitsSaisie.setVgap(12);
    jBTDimensionsSaisie.setText("OK");
    jBTDimensionsSaisie.addActionListener(new DLGParametresBN_jBTDimensionsSaisie_actionAdapter(this));
    jBTDimensionsSaisie.setPreferredSize(new Dimension(50, 20));
    jBTDimensionsSaisie.setMinimumSize(new Dimension(50, 20));
    jBTDimensionsSaisie.setMaximumSize(new Dimension(50, 20));
    jLBDimensionsSaisie.setText("Total number of dimensions (TOT_NB_DIM):");
    jLBDimensionsSaisie.setToolTipText("");
    jLBDimensionsSaisie.setPreferredSize(new Dimension(140, 20));
    jLBDimensionsSaisie.setMinimumSize(new Dimension(140, 20));
    jLBDimensionsSaisie.setMaximumSize(new Dimension(140, 20));
    jTFDimensionsSaisie.setText("5");
    jTFDimensionsSaisie.addActionListener(new DLGParametresBN_jTFDimensionsSaisie_actionAdapter(this));
    jTFDimensionsSaisie.setSelectionStart(0);
    jTFDimensionsSaisie.setPreferredSize(new Dimension(50, 20));
    jTFDimensionsSaisie.setMinimumSize(new Dimension(50, 20));
    jTFDimensionsSaisie.setMaximumSize(new Dimension(50, 20));
    jPDimensionsSaisie.setLayout(fLDimensionsSaisie);
    fLDimensionsSaisie.setAlignment(FlowLayout.LEFT);
    fLDimensionsSaisie.setHgap(5);
    fLDimensionsSaisie.setVgap(12);
    jPDimensionsSaisie.setBorder(null);
    jBTValider.setMaximumSize(new Dimension(90, 25));
    jBTValider.setMinimumSize(new Dimension(90, 25));
    jBTValider.setPreferredSize(new Dimension(90, 25));
    jBTValider.setActionCommand("Validate");
    jBTValider.setText("Validate");
    jBTValider.addActionListener(new DLGParametresBN_jBTValider_actionAdapter(this));
    fLValidation.setHgap(10);
    fLValidation.setVgap(10);

    getContentPane().add(contentPanel);
    contentPanel.add(jPDimensions, null);
    contentPanel.add(jPTablesFaits, null);
    jPTablesFaits.add(jPTablesFaitsTitre, BorderLayout.NORTH);
    jPTablesFaitsTitre.add(jLBTablesFaitsTitre, BorderLayout.NORTH);
    jPTablesFaitsTitre.add(jPTablesFaitsSaisie, BorderLayout.CENTER);
    jPTablesFaitsSaisie.add(jLBTablesFaitsSaisie, null);
    jPTablesFaitsSaisie.add(jTFTablesFaitsSaisie, null);
    jPTablesFaitsSaisie.add(jBTTablesFaitsSaisie, null);
    jPTablesFaits.add(jSPTablesFaits,  BorderLayout.CENTER);
    jSPTablesFaits.getViewport().add(jTableTablesFaits, null);
    jPDimensionsTitre.add(jLBDimensionsTitre, BorderLayout.NORTH);
    jPDimensionsTitre.add(jPDimensionsSaisie, BorderLayout.CENTER);
    jPDimensionsSaisie.add(jLBDimensionsSaisie, null);
    jPDimensionsSaisie.add(jTFDimensionsSaisie, null);
    jPDimensionsSaisie.add(jBTDimensionsSaisie, null);
    jPDimensions.add(jSPDimensions, BorderLayout.CENTER);
    jPDimensions.add(jPDimensionsTitre, BorderLayout.NORTH);
    jSPDimensions.getViewport().add(jTableDimensions, null);
    contentPanel.add(jPValidation, null);
    jPValidation.add(jBTValider, null);

    // Dfinition des proprits des jTables ///////////////////////////////////
    this.dimensions.ajouterDimensions(Integer.parseInt(jTFDimensionsSaisie.getText()));
    jTableDimensions.setModel(dimensions);
    jTableDimensions.getTableHeader().setReorderingAllowed(false);
    jTableDimensions.setDefaultRenderer(Object.class, tclRenduCellule);
    jTableDimensions.getColumnModel().getColumn(0).setResizable(false);
    jTableDimensions.getColumnModel().getColumn(1).setResizable(false);
    jTableDimensions.getColumnModel().getColumn(2).setResizable(false);
    jTableDimensions.getColumnModel().getColumn(3).setResizable(false);
    jTableDimensions.setRowSelectionAllowed(false);

    this.tablesFaits.ajouterTablesFaits(Integer.parseInt(jTFTablesFaitsSaisie.getText()));
    jTableTablesFaits.setModel(tablesFaits);
    jTableTablesFaits.getTableHeader().setReorderingAllowed(false);
    jTableTablesFaits.setDefaultRenderer(Object.class, tclRenduCellule);
    jTableTablesFaits.getColumnModel().getColumn(0).setResizable(false);
    jTableTablesFaits.getColumnModel().getColumn(1).setResizable(false);
    jTableTablesFaits.getColumnModel().getColumn(2).setResizable(false);
    jTableTablesFaits.getColumnModel().getColumn(3).setResizable(false);
    jTableTablesFaits.setRowSelectionAllowed(false);
    ////////////////////////////////////////////////////////////////////////////
  }

  void jBTValider_actionPerformed(ActionEvent e) {
    if (jTFDimensionsSaisie.getText().length() == 0 || jTFTablesFaitsSaisie.getText().length() == 0)
      JOptionPane.showMessageDialog(null,"Please enter the total number of dimensions and fact tables");
    else
      this.hide();
  }

  void jBTDimensionsSaisie_actionPerformed(ActionEvent e) {
    int nbDimensions = 0;
    try {
      nbDimensions = Integer.parseInt(jTFDimensionsSaisie.getText());
      this.dimensions.ajouterDimensions(nbDimensions);
      this.dimensions.fireTableDataChanged();
    }
    catch (Exception erreurSaisie) {
      JOptionPane.showMessageDialog(null,"Please enter an integer");
      jTFDimensionsSaisie.setText("");
    }
  }

  void jBTTablesFaitsSaisie_actionPerformed(ActionEvent e) {
    int nbTablesFaits = 0;
    try {
      nbTablesFaits = Integer.parseInt(jTFTablesFaitsSaisie.getText());
      this.tablesFaits.ajouterTablesFaits(nbTablesFaits);
      this.tablesFaits.fireTableDataChanged();
    }
    catch (Exception erreurSaisie) {
      JOptionPane.showMessageDialog(null,"Please enter an integer");
      jTFTablesFaitsSaisie.setText("");
    }
  }

  void jTFDimensionsSaisie_actionPerformed(ActionEvent e) {
    jBTDimensionsSaisie_actionPerformed(e);
  }

  void jTFTablesFaitsSaisie_actionPerformed(ActionEvent e) {
    jBTTablesFaitsSaisie_actionPerformed(e);
  }
}

class DLGParametresBN_jBTValider_actionAdapter implements java.awt.event.ActionListener {
  DLGParametresBN adaptee;

  DLGParametresBN_jBTValider_actionAdapter(DLGParametresBN adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jBTValider_actionPerformed(e);
  }
}

class DLGParametresBN_jBTDimensionsSaisie_actionAdapter implements java.awt.event.ActionListener {
  DLGParametresBN adaptee;

  DLGParametresBN_jBTDimensionsSaisie_actionAdapter(DLGParametresBN adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jBTDimensionsSaisie_actionPerformed(e);
  }
}

class DLGParametresBN_jBTTablesFaitsSaisie_actionAdapter implements java.awt.event.ActionListener {
  DLGParametresBN adaptee;

  DLGParametresBN_jBTTablesFaitsSaisie_actionAdapter(DLGParametresBN adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jBTTablesFaitsSaisie_actionPerformed(e);
  }
}

class DLGParametresBN_jTFDimensionsSaisie_actionAdapter implements java.awt.event.ActionListener {
  DLGParametresBN adaptee;

  DLGParametresBN_jTFDimensionsSaisie_actionAdapter(DLGParametresBN adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jTFDimensionsSaisie_actionPerformed(e);
  }
}

class DLGParametresBN_jTFTablesFaitsSaisie_actionAdapter implements java.awt.event.ActionListener {
  DLGParametresBN adaptee;

  DLGParametresBN_jTFTablesFaitsSaisie_actionAdapter(DLGParametresBN adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jTFTablesFaitsSaisie_actionPerformed(e);
  }
}
