////////////////////////////////////////////////////////////////////////////////
// TITRE : DWEB - DATAWAREHOUSE ENGINEERING BENCHMARK - VERSION 0.4           //
//----------------------------------------------------------------------------//
// AUTEURS : JOUBERT Bruno / GUESMIA Sofiane                                  //
//           UNIVERSITE LYON 2 - MASTER IIDEE                                 //
//----------------------------------------------------------------------------//
// English translation by J. Darmont                                          //
// - Step 1: Interface (DONE)                                                 //
// - Step 2: Code/comments (TO DO)                                            //
//----------------------------------------------------------------------------//
// ENCADRES PAR : DARMONT Jrome                                              //
//                UNIVERSITE LYON 2 - LABORATOIRE ERIC                        //
//                http://eric.univ-lyon2.fr - - jerome.darmont@univ-lyon2.fr  //
//----------------------------------------------------------------------------//
// DESCRIPTION : Banc d'essai dcisionnel                                     //
//----------------------------------------------------------------------------//
// Cette application a pour but de permettre la cration d'un entrept de     //
// donnes synthtique et des charges associes.                              //
////////////////////////////////////////////////////////////////////////////////

package dweb03;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

public class DLGParametresCharge extends JDialog {
  BorderLayout borderLayout1 = new BorderLayout();
  JLabel jLBChargeNbRestMoyen = new JLabel();
  JTextField jTFChargeNbRestMoyen = new JTextField();
  FlowLayout fLChargeNbAttMoyen = new FlowLayout();
  FlowLayout fLChargeNbRequetes = new FlowLayout();
  JPanel jPChargeProbOlap = new JPanel();
  JPanel jPCharge = new JPanel();
  JPanel jPChargeNbRestMoyen = new JPanel();
  JPanel jPValidation = new JPanel();
  JLabel jLBChargeNbAttMoyen = new JLabel();
  FlowLayout fLChargeNbRestMoyen = new FlowLayout();
  JLabel jLBChargeNbRequetes = new JLabel();
  JLabel jLBChargeTitre = new JLabel();
  FlowLayout fLChargeProbOlap = new FlowLayout();
  JPanel jPChargeNbAttMoyen = new JPanel();
  JLabel jLBChargeProbOlap = new JLabel();
  JPanel jPChargeNbRequetes = new JPanel();
  JTextField jTFChargeNbRequetes = new JTextField();
  JButton jBTValider = new JButton();
  JTextField jTFChargeNbAttMoyen = new JTextField();
  JTextField jTFChargeProbOlap = new JTextField();
  FlowLayout fLValidation = new FlowLayout();
  JPanel contentPanel = new JPanel();
  JTextField jTFChargeNbAgregMoyen = new JTextField();
  FlowLayout fLChargeNbAgregMoyen = new FlowLayout();
  JLabel jLBChargeNbAgregMoyen = new JLabel();
  JPanel jPChargeNbAgregMoyen = new JPanel();
  FlowLayout fLChargeProbCube = new FlowLayout();
  JPanel jPChargeProbCube = new JPanel();
  JLabel jLBChargeProbCube = new JLabel();
  JTextField jTFChargeProbCube = new JTextField();
  FlowLayout fLChargeProbHaving = new FlowLayout();
  JPanel jPChargeProbHaving = new JPanel();
  JLabel jLBChargeProbHaving = new JLabel();
  JTextField jTFChargeProbHaving = new JTextField();
  FlowLayout fLChargeNbDDMoyen = new FlowLayout();
  JLabel jLBChargeNbDDMoyen = new JLabel();
  JPanel jPChargeNbDDMoyen = new JPanel();
  JTextField jTFChargeNbDDMoyen = new JTextField();

  public DLGParametresCharge(Frame frame, String title, boolean modal) {
    super(frame, title, modal);
    try {
      jbInit();
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  public DLGParametresCharge() {
    this(null, "", false);
  }

  void jbInit() throws Exception {
    jTFChargeNbRestMoyen.setMaximumSize(new Dimension(50, 20));
    jTFChargeNbRestMoyen.setMinimumSize(new Dimension(50, 20));
    jTFChargeNbRestMoyen.setPreferredSize(new Dimension(50, 20));
    jTFChargeNbRestMoyen.setSelectionStart(0);
    jTFChargeNbRestMoyen.setText("3");
    jTFChargeNbRestMoyen.addActionListener(new DLGParametresCharge_jTFChargeNbRestMoyen_actionAdapter(this));
    jLBChargeNbRestMoyen.setMaximumSize(new Dimension(300, 20));
    jLBChargeNbRestMoyen.setMinimumSize(new Dimension(300, 20));
    jLBChargeNbRestMoyen.setPreferredSize(new Dimension(300, 20));
    jLBChargeNbRestMoyen.setToolTipText("");
    jLBChargeNbRestMoyen.setText("Average number of restrictions in a query (AVG_NB_RESTR):");
    this.getContentPane().setLayout(borderLayout1);
    fLChargeNbAttMoyen.setAlignment(FlowLayout.LEFT);
    fLChargeNbAttMoyen.setHgap(5);
    fLChargeNbAttMoyen.setVgap(5);
    fLChargeNbRequetes.setVgap(5);
    fLChargeNbRequetes.setHgap(5);
    fLChargeNbRequetes.setAlignment(FlowLayout.LEFT);
    jPChargeProbOlap.setLayout(fLChargeProbOlap);
    jPChargeProbOlap.setMaximumSize(new Dimension(0, 30));
    jPChargeProbOlap.setMinimumSize(new Dimension(0, 30));
    jPChargeProbOlap.setPreferredSize(new Dimension(0, 30));
    jPChargeProbOlap.setBounds(new Rectangle(2, 112, 386, 30));
    jPCharge.setBorder(BorderFactory.createEtchedBorder());
    jPCharge.setMaximumSize(new Dimension(390, 270));
    jPCharge.setMinimumSize(new Dimension(390, 270));
    jPCharge.setPreferredSize(new Dimension(390, 270));
    jPCharge.setBounds(new Rectangle(5, 12, 390, 270));
    jPCharge.setLayout(null);
    jPChargeNbRestMoyen.setLayout(fLChargeNbRestMoyen);
    jPChargeNbRestMoyen.setMaximumSize(new Dimension(0, 30));
    jPChargeNbRestMoyen.setMinimumSize(new Dimension(0, 30));
    jPChargeNbRestMoyen.setPreferredSize(new Dimension(0, 30));
    jPChargeNbRestMoyen.setBounds(new Rectangle(2, 82, 386, 30));
    jPValidation.setBorder(BorderFactory.createEtchedBorder());
    jPValidation.setMaximumSize(new Dimension(0, 50));
    jPValidation.setMinimumSize(new Dimension(0, 50));
    jPValidation.setPreferredSize(new Dimension(0, 50));
    jPValidation.setBounds(new Rectangle(5, 287, 390, 50));
    jPValidation.setLayout(fLValidation);
    jLBChargeNbAttMoyen.setMaximumSize(new Dimension(300, 20));
    jLBChargeNbAttMoyen.setMinimumSize(new Dimension(300, 20));
    jLBChargeNbAttMoyen.setPreferredSize(new Dimension(300, 20));
    jLBChargeNbAttMoyen.setToolTipText("");
    jLBChargeNbAttMoyen.setText("Average number of selected attributes in a query (AVG_NB_ATT):");
    fLChargeNbRestMoyen.setHgap(5);
    fLChargeNbRestMoyen.setVgap(5);
    fLChargeNbRestMoyen.setAlignment(FlowLayout.LEFT);
    jLBChargeNbRequetes.setText("Approximate number of queries in the workload (NB_Q):");
    jLBChargeNbRequetes.setToolTipText("");
    jLBChargeNbRequetes.setPreferredSize(new Dimension(300, 20));
    jLBChargeNbRequetes.setMinimumSize(new Dimension(300, 20));
    jLBChargeNbRequetes.setMaximumSize(new Dimension(300, 20));
    jLBChargeTitre.setText("Workload parameters");
    jLBChargeTitre.setBounds(new Rectangle(2, 2, 386, 20));
    jLBChargeTitre.setHorizontalTextPosition(SwingConstants.CENTER);
    jLBChargeTitre.setHorizontalAlignment(SwingConstants.CENTER);
    jLBChargeTitre.setPreferredSize(new Dimension(290, 20));
    jLBChargeTitre.setMinimumSize(new Dimension(290, 20));
    jLBChargeTitre.setMaximumSize(new Dimension(290, 20));
    jLBChargeTitre.setBorder(BorderFactory.createRaisedBevelBorder());
    jLBChargeTitre.setAlignmentY((float) 0.0);
    jLBChargeTitre.setAlignmentX((float) 0.0);
    jLBChargeTitre.setFont(new java.awt.Font("Arial", 1, 12));
    fLChargeProbOlap.setHgap(5);
    fLChargeProbOlap.setVgap(5);
    fLChargeProbOlap.setAlignment(FlowLayout.LEFT);
    jPChargeNbAttMoyen.setLayout(fLChargeNbAttMoyen);
    jPChargeNbAttMoyen.setMaximumSize(new Dimension(0, 30));
    jPChargeNbAttMoyen.setMinimumSize(new Dimension(0, 30));
    jPChargeNbAttMoyen.setPreferredSize(new Dimension(0, 30));
    jPChargeNbAttMoyen.setBounds(new Rectangle(2, 52, 386, 30));
    jLBChargeProbOlap.setText("Probability that the query type is OLAP (PROB_OLAP):");
    jLBChargeProbOlap.setToolTipText("");
    jLBChargeProbOlap.setPreferredSize(new Dimension(300, 20));
    jLBChargeProbOlap.setMinimumSize(new Dimension(300, 20));
    jLBChargeProbOlap.setMaximumSize(new Dimension(300, 20));
    jPChargeNbRequetes.setPreferredSize(new Dimension(0, 30));
    jPChargeNbRequetes.setBounds(new Rectangle(2, 22, 386, 30));
    jPChargeNbRequetes.setMinimumSize(new Dimension(0, 30));
    jPChargeNbRequetes.setMaximumSize(new Dimension(0, 30));
    jPChargeNbRequetes.setLayout(fLChargeNbRequetes);
    jTFChargeNbRequetes.addActionListener(new DLGParametresHN_jTFChargeNbRequetes_actionAdapter(this));
    jTFChargeNbRequetes.setText("100");
    jTFChargeNbRequetes.addActionListener(new DLGParametresHN_jTFChargeNbRequetes_actionAdapter(this));
    jTFChargeNbRequetes.addActionListener(new DLGParametresHN_jTFChargeNbRequetes_actionAdapter(this));
    jTFChargeNbRequetes.addActionListener(new DLGParametresHN_jTFChargeNbRequetes_actionAdapter(this));
    jTFChargeNbRequetes.setSelectionStart(0);
    jTFChargeNbRequetes.setPreferredSize(new Dimension(50, 20));
    jTFChargeNbRequetes.setSelectionEnd(1);
    jTFChargeNbRequetes.setMinimumSize(new Dimension(50, 20));
    jTFChargeNbRequetes.setMaximumSize(new Dimension(50, 20));
    jBTValider.setMaximumSize(new Dimension(90, 25));
    jBTValider.setMinimumSize(new Dimension(90, 25));
    jBTValider.setPreferredSize(new Dimension(90, 25));
    jBTValider.setActionCommand("Validate");
    jBTValider.setText("Validate");
    jBTValider.addActionListener(new DLGParametresCharge_jBTValider_actionAdapter(this));
    jTFChargeNbAttMoyen.setMaximumSize(new Dimension(50, 20));
    jTFChargeNbAttMoyen.setMinimumSize(new Dimension(50, 20));
    jTFChargeNbAttMoyen.setPreferredSize(new Dimension(50, 20));
    jTFChargeNbAttMoyen.setSelectionStart(0);
    jTFChargeNbAttMoyen.setText("5");
    jTFChargeNbAttMoyen.addActionListener(new DLGParametresCharge_jTFChargeNbAttMoyen_actionAdapter(this));
    jTFChargeProbOlap.setText("0.9");
    jTFChargeProbOlap.addActionListener(new DLGParametresCharge_jTFChargeProbOlap_actionAdapter(this));
    jTFChargeProbOlap.setSelectionStart(0);
    jTFChargeProbOlap.setPreferredSize(new Dimension(50, 20));
    jTFChargeProbOlap.setMinimumSize(new Dimension(50, 20));
    jTFChargeProbOlap.setMaximumSize(new Dimension(50, 20));
    fLValidation.setHgap(10);
    fLValidation.setVgap(10);
    contentPanel.setLayout(null);
    contentPanel.setBorder(null);
    contentPanel.setMaximumSize(new Dimension(400, 350));
    contentPanel.setMinimumSize(new Dimension(400, 350));
    contentPanel.setPreferredSize(new Dimension(400, 350));
    this.setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
    this.setModal(true);
    this.setResizable(false);
    this.setTitle("Workload parameters");
    jTFChargeNbAgregMoyen.setText("3");
    jTFChargeNbAgregMoyen.addActionListener(new DLGParametresCharge_jTFChargeNbAgregMoyen_actionAdapter(this));
    jTFChargeNbAgregMoyen.setSelectionStart(0);
    jTFChargeNbAgregMoyen.setPreferredSize(new Dimension(50, 20));
    jTFChargeNbAgregMoyen.setMinimumSize(new Dimension(50, 20));
    jTFChargeNbAgregMoyen.setMaximumSize(new Dimension(50, 20));
    fLChargeNbAgregMoyen.setAlignment(FlowLayout.LEFT);
    fLChargeNbAgregMoyen.setVgap(5);
    fLChargeNbAgregMoyen.setHgap(5);
    jLBChargeNbAgregMoyen.setText("Average number of aggregations in an OLAP query (AVG_NB_AGGREG):");
    jLBChargeNbAgregMoyen.setToolTipText("");
    jLBChargeNbAgregMoyen.setPreferredSize(new Dimension(300, 20));
    jLBChargeNbAgregMoyen.setMinimumSize(new Dimension(300, 20));
    jLBChargeNbAgregMoyen.setMaximumSize(new Dimension(300, 20));
    jPChargeNbAgregMoyen.setPreferredSize(new Dimension(0, 30));
    jPChargeNbAgregMoyen.setBounds(new Rectangle(2, 142, 386, 30));
    jPChargeNbAgregMoyen.setMinimumSize(new Dimension(0, 30));
    jPChargeNbAgregMoyen.setMaximumSize(new Dimension(0, 30));
    jPChargeNbAgregMoyen.setLayout(fLChargeNbAgregMoyen);
    fLChargeProbCube.setAlignment(FlowLayout.LEFT);
    fLChargeProbCube.setVgap(5);
    fLChargeProbCube.setHgap(5);
    jPChargeProbCube.setPreferredSize(new Dimension(0, 30));
    jPChargeProbCube.setBounds(new Rectangle(2, 172, 386, 30));
    jPChargeProbCube.setMinimumSize(new Dimension(0, 30));
    jPChargeProbCube.setMaximumSize(new Dimension(0, 30));
    jPChargeProbCube.setLayout(fLChargeProbCube);
    jLBChargeProbCube.setText("Probability of an OLAP query to use the Cube operator (PROB_CUBE):");
    jLBChargeProbCube.setToolTipText("");
    jLBChargeProbCube.setPreferredSize(new Dimension(300, 20));
    jLBChargeProbCube.setMinimumSize(new Dimension(300, 20));
    jLBChargeProbCube.setMaximumSize(new Dimension(300, 20));
    jTFChargeProbCube.setText("0.3");
    jTFChargeProbCube.addActionListener(new DLGParametresCharge_jTFChargeProbCube_actionAdapter(this));
    jTFChargeProbCube.setSelectionStart(0);
    jTFChargeProbCube.setPreferredSize(new Dimension(50, 20));
    jTFChargeProbCube.setMinimumSize(new Dimension(50, 20));
    jTFChargeProbCube.setMaximumSize(new Dimension(50, 20));
    fLChargeProbHaving.setAlignment(FlowLayout.LEFT);
    fLChargeProbHaving.setVgap(5);
    fLChargeProbHaving.setHgap(5);
    jPChargeProbHaving.setPreferredSize(new Dimension(0, 30));
    jPChargeProbHaving.setBounds(new Rectangle(2, 202, 386, 30));
    jPChargeProbHaving.setMinimumSize(new Dimension(0, 30));
    jPChargeProbHaving.setMaximumSize(new Dimension(0, 30));
    jPChargeProbHaving.setLayout(fLChargeProbHaving);
    jLBChargeProbHaving.setText("Probability of an OLAP query to include an Having clause (PROB_HAVING):");
    jLBChargeProbHaving.setToolTipText("");
    jLBChargeProbHaving.setPreferredSize(new Dimension(300, 20));
    jLBChargeProbHaving.setMinimumSize(new Dimension(300, 20));
    jLBChargeProbHaving.setMaximumSize(new Dimension(300, 20));
    jTFChargeProbHaving.setText("0.2");
    jTFChargeProbHaving.addActionListener(new DLGParametresCharge_jTFChargeProbHaving_actionAdapter(this));
    jTFChargeProbHaving.setSelectionStart(0);
    jTFChargeProbHaving.setPreferredSize(new Dimension(50, 20));
    jTFChargeProbHaving.setMinimumSize(new Dimension(50, 20));
    jTFChargeProbHaving.setMaximumSize(new Dimension(50, 20));
    fLChargeNbDDMoyen.setHgap(5);
    fLChargeNbDDMoyen.setVgap(5);
    fLChargeNbDDMoyen.setAlignment(FlowLayout.LEFT);
    jLBChargeNbDDMoyen.setMaximumSize(new Dimension(300, 20));
    jLBChargeNbDDMoyen.setMinimumSize(new Dimension(300, 20));
    jLBChargeNbDDMoyen.setPreferredSize(new Dimension(300, 20));
    jLBChargeNbDDMoyen.setToolTipText("");
    jLBChargeNbDDMoyen.setText("Average number of drill downs after an OLAP query (AVG_NB_DD):");
    jPChargeNbDDMoyen.setLayout(fLChargeNbDDMoyen);
    jPChargeNbDDMoyen.setMaximumSize(new Dimension(0, 30));
    jPChargeNbDDMoyen.setMinimumSize(new Dimension(0, 30));
    jPChargeNbDDMoyen.setPreferredSize(new Dimension(0, 30));
    jPChargeNbDDMoyen.setBounds(new Rectangle(2, 232, 386, 30));
    jTFChargeNbDDMoyen.setText("3");
    jTFChargeNbDDMoyen.addActionListener(new DLGParametresCharge_jTFChargeNbDDMoyen_actionAdapter(this));
    jTFChargeNbDDMoyen.setSelectionStart(0);
    jTFChargeNbDDMoyen.setPreferredSize(new Dimension(50, 20));
    jTFChargeNbDDMoyen.setMinimumSize(new Dimension(50, 20));
    jTFChargeNbDDMoyen.setMaximumSize(new Dimension(50, 20));
    jPChargeNbRequetes.add(jLBChargeNbRequetes, null);
    jPChargeNbRequetes.add(jTFChargeNbRequetes, null);
    jPChargeNbAttMoyen.add(jLBChargeNbAttMoyen, null);
    jPChargeNbAttMoyen.add(jTFChargeNbAttMoyen, null);
    jPChargeNbRestMoyen.add(jLBChargeNbRestMoyen, null);
    jPChargeNbRestMoyen.add(jTFChargeNbRestMoyen, null);
    jPChargeProbOlap.add(jLBChargeProbOlap, null);
    jPChargeProbOlap.add(jTFChargeProbOlap, null);
    jPChargeProbCube.add(jLBChargeProbCube, null);
    jPChargeProbCube.add(jTFChargeProbCube, null);
    jPChargeProbHaving.add(jLBChargeProbHaving, null);
    jPChargeProbHaving.add(jTFChargeProbHaving, null);
    jPChargeNbDDMoyen.add(jLBChargeNbDDMoyen, null);
    jPChargeNbDDMoyen.add(jTFChargeNbDDMoyen, null);
    jPCharge.add(jLBChargeTitre, null);
    jPCharge.add(jPChargeNbRequetes, null);
    jPCharge.add(jPChargeNbAttMoyen, null);
    jPCharge.add(jPChargeNbRestMoyen, null);
    jPCharge.add(jPChargeProbOlap, null);
    jPCharge.add(jPChargeNbAgregMoyen, null);
    jPCharge.add(jPChargeProbCube, null);
    jPCharge.add(jPChargeProbHaving, null);
    jPCharge.add(jPChargeNbDDMoyen, null);
    jPChargeNbAgregMoyen.add(jLBChargeNbAgregMoyen, null);
    jPChargeNbAgregMoyen.add(jTFChargeNbAgregMoyen, null);
    contentPanel.add(jPCharge, null);
    contentPanel.add(jPValidation, null);
    jPValidation.add(jBTValider, null);
    this.getContentPane().add(contentPanel, BorderLayout.NORTH);
  }

  void jTFChargeNbRequetes_actionPerformed(ActionEvent e) {
    try {
      Integer.parseInt(jTFChargeNbRequetes.getText());
    }
    catch (Exception erreurSaisie) {
      JOptionPane.showMessageDialog(null,"Please enter an integer");
      jTFChargeNbRequetes.setText("100");
    }
  }

  void jTFChargeNbAttMoyen_actionPerformed(ActionEvent e) {
    try {
      Integer.parseInt(jTFChargeNbAttMoyen.getText());
    }
    catch (Exception erreurSaisie) {
      JOptionPane.showMessageDialog(null,"Please enter an integer");
      jTFChargeNbAttMoyen.setText("5");
    }
  }

  void jTFChargeNbRestMoyen_actionPerformed(ActionEvent e) {
    try {
      Integer.parseInt(jTFChargeNbRestMoyen.getText());
    }
    catch (Exception erreurSaisie) {
      JOptionPane.showMessageDialog(null,"Please enter an integer");
      jTFChargeNbRestMoyen.setText("3");
    }
  }

  void jTFChargeNbAgregMoyen_actionPerformed(ActionEvent e) {
    try {
      Integer.parseInt(jTFChargeNbAgregMoyen.getText());
    }
    catch (Exception erreurSaisie) {
      JOptionPane.showMessageDialog(null,"Please enter an integer");
      jTFChargeNbAgregMoyen.setText("3");
    }
  }

  void jTFChargeNbDDMoyen_actionPerformed(ActionEvent e) {
    try {
      Integer.parseInt(jTFChargeNbDDMoyen.getText());
    }
    catch (Exception erreurSaisie) {
      JOptionPane.showMessageDialog(null,"Please enter an integer");
      jTFChargeNbDDMoyen.setText("3");
    }
  }

  void jTFChargeProbOlap_actionPerformed(ActionEvent e) {
    try {
      if (Double.parseDouble(jTFChargeProbOlap.getText()) < 0.0 || Double.parseDouble(jTFChargeProbOlap.getText()) > 1.0) {
        JOptionPane.showMessageDialog(null,"Please enter a value between 0.0 and 1.0");
        jTFChargeProbOlap.setText("0.9");
      }
    }
    catch (Exception erreurSaisie) {
      JOptionPane.showMessageDialog(null,"Please enter a value between 0.0 and 1.0");
      jTFChargeProbOlap.setText("0.9");
    }
  }

  void jTFChargeProbCube_actionPerformed(ActionEvent e) {
    try {
      if (Double.parseDouble(jTFChargeProbCube.getText()) < 0.0 || Double.parseDouble(jTFChargeProbCube.getText()) > 1.0) {
        JOptionPane.showMessageDialog(null,"Please enter a value between 0.0 and 1.0");
        jTFChargeProbCube.setText("0.3");
      }
    }
    catch (Exception erreurSaisie) {
      JOptionPane.showMessageDialog(null,"Please enter a value between 0.0 and 1.0");
      jTFChargeProbCube.setText("0.3");
    }
  }

  void jTFChargeProbHaving_actionPerformed(ActionEvent e) {
    try {
      if (Double.parseDouble(jTFChargeProbHaving.getText()) < 0.0 || Double.parseDouble(jTFChargeProbHaving.getText()) > 1.0) {
        JOptionPane.showMessageDialog(null,"Please enter a value between 0.0 and 1.0");
        jTFChargeProbHaving.setText("0.2");
      }
    }
    catch (Exception erreurSaisie) {
      JOptionPane.showMessageDialog(null,"Please enter a value between 0.0 and 1.0");
      jTFChargeProbHaving.setText("0.2");
    }
  }

  void jBTValider_actionPerformed(ActionEvent e) {
    this.hide();
  }
}

class DLGParametresHN_jTFChargeNbRequetes_actionAdapter implements java.awt.event.ActionListener {
  DLGParametresCharge adaptee;

  DLGParametresHN_jTFChargeNbRequetes_actionAdapter(DLGParametresCharge adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jTFChargeNbRequetes_actionPerformed(e);
  }
}

class DLGParametresCharge_jTFChargeNbAttMoyen_actionAdapter implements java.awt.event.ActionListener {
  DLGParametresCharge adaptee;

  DLGParametresCharge_jTFChargeNbAttMoyen_actionAdapter(DLGParametresCharge adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jTFChargeNbAttMoyen_actionPerformed(e);
  }
}

class DLGParametresCharge_jTFChargeNbRestMoyen_actionAdapter implements java.awt.event.ActionListener {
  DLGParametresCharge adaptee;

  DLGParametresCharge_jTFChargeNbRestMoyen_actionAdapter(DLGParametresCharge adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jTFChargeNbRestMoyen_actionPerformed(e);
  }
}

class DLGParametresCharge_jTFChargeNbAgregMoyen_actionAdapter implements java.awt.event.ActionListener {
  DLGParametresCharge adaptee;

  DLGParametresCharge_jTFChargeNbAgregMoyen_actionAdapter(DLGParametresCharge adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jTFChargeNbAgregMoyen_actionPerformed(e);
  }
}

class DLGParametresCharge_jTFChargeNbDDMoyen_actionAdapter implements java.awt.event.ActionListener {
  DLGParametresCharge adaptee;

  DLGParametresCharge_jTFChargeNbDDMoyen_actionAdapter(DLGParametresCharge adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jTFChargeNbDDMoyen_actionPerformed(e);
  }
}

class DLGParametresCharge_jTFChargeProbOlap_actionAdapter implements java.awt.event.ActionListener {
  DLGParametresCharge adaptee;

  DLGParametresCharge_jTFChargeProbOlap_actionAdapter(DLGParametresCharge adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jTFChargeProbOlap_actionPerformed(e);
  }
}

class DLGParametresCharge_jTFChargeProbCube_actionAdapter implements java.awt.event.ActionListener {
  DLGParametresCharge adaptee;

  DLGParametresCharge_jTFChargeProbCube_actionAdapter(DLGParametresCharge adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jTFChargeProbCube_actionPerformed(e);
  }
}

class DLGParametresCharge_jTFChargeProbHaving_actionAdapter implements java.awt.event.ActionListener {
  DLGParametresCharge adaptee;

  DLGParametresCharge_jTFChargeProbHaving_actionAdapter(DLGParametresCharge adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jTFChargeProbHaving_actionPerformed(e);
  }
}

class DLGParametresCharge_jBTValider_actionAdapter implements java.awt.event.ActionListener {
  DLGParametresCharge adaptee;

  DLGParametresCharge_jBTValider_actionAdapter(DLGParametresCharge adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jBTValider_actionPerformed(e);
  }
}
