////////////////////////////////////////////////////////////////////////////////
// TITRE : DWEB - DATAWAREHOUSE ENGINEERING BENCHMARK - VERSION 0.4           //
//----------------------------------------------------------------------------//
// AUTEURS : JOUBERT Bruno / GUESMIA Sofiane                                  //
//           UNIVERSITE LYON 2 - MASTER IIDEE                                 //
//----------------------------------------------------------------------------//
// English translation by J. Darmont                                          //
// - Step 1: Interface (DONE)                                                 //
// - Step 2: Code/comments (TO DO)                                            //
//----------------------------------------------------------------------------//
// ENCADRES PAR : DARMONT Jrome                                              //
//                UNIVERSITE LYON 2 - LABORATOIRE ERIC                        //
//                http://eric.univ-lyon2.fr - - jerome.darmont@univ-lyon2.fr  //
//----------------------------------------------------------------------------//
// DESCRIPTION : Banc d'essai dcisionnel                                     //
//----------------------------------------------------------------------------//
// Cette application a pour but de permettre la cration d'un entrept de     //
// donnes synthtique et des charges associes.                              //
////////////////////////////////////////////////////////////////////////////////

package dweb03;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

public class DLGParametresHN extends JDialog {
  JPanel contentPanel = new JPanel();
  JPanel jPTableFaits = new JPanel();
  JPanel jPDimensions = new JPanel();
  JPanel jPValidation = new JPanel();
  JLabel jLBTablesFaitsTitre = new JLabel();
  JLabel jLBDimensionsTitre = new JLabel();
  JPanel jPTFNbDimensions = new JPanel();
  JPanel jPDimNbNiveaux = new JPanel();
  JLabel jLBTFNbDimensions = new JLabel();
  JTextField jTFTFNbDimensions = new JTextField();
  FlowLayout fLTFNbDimensions = new FlowLayout();
  JLabel jLBDimNbNiveaux = new JLabel();
  JTextField jTFDimNbNiveaux = new JTextField();
  FlowLayout fLDimNbNiveaux = new FlowLayout();
  FlowLayout fLValidation = new FlowLayout();
  JButton jBTValider = new JButton();
  FlowLayout fLTFDensit = new FlowLayout();
  JTextField jTFTFDensit = new JTextField();
  JLabel jLBTFDensit = new JLabel();
  JPanel jPTFDensit = new JPanel();
  FlowLayout fLTFNbMesures = new FlowLayout();
  JTextField jTFTFNbMesures = new JTextField();
  JLabel jLBTFNbMesures = new JLabel();
  JPanel jPTFNbMesures = new JPanel();
  JTextField jTFDimFacteurEchelle = new JTextField();
  FlowLayout fLDimFacteurEchelle = new FlowLayout();
  JPanel jPDimFacteurEchelle = new JPanel();
  JLabel jLBDimFacteurEchelle = new JLabel();
  JTextField jTFDimNbEnrHN = new JTextField();
  FlowLayout fLDimNbEnrHN = new FlowLayout();
  JPanel jPDimNbEnrHN = new JPanel();
  JLabel jLBDimNbEnrHN = new JLabel();
  JTextField jTFDimNbAttributs = new JTextField();
  FlowLayout fLDimNbAttributs = new FlowLayout();
  JPanel jPDimNbAttributs = new JPanel();
  JLabel jLBDimNbAttributs = new JLabel();
  JTextField jTFDimNbDimensions = new JTextField();
  FlowLayout fLDimNbDimensions = new FlowLayout();
  JPanel jPDimNbDimensions = new JPanel();
  JLabel jLBDimNbDimensions = new JLabel();
  FlowLayout fLTFNbTablesFaits = new FlowLayout();
  JTextField jTFTFNbTablesFaits = new JTextField();
  JLabel jLBTFNbTablesFaits = new JLabel();
  JPanel jPTFNbTablesFaits = new JPanel();

  public DLGParametresHN(Frame frame, String title, boolean modal) {
    super(frame, title, modal);
    try {
      jbInit();
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  public DLGParametresHN() {
    this(null, "", false);
  }

  private void jbInit() throws Exception {

    contentPanel.setLayout(null);
    this.setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
    this.setModal(true);
    this.setResizable(false);
    this.setTitle("Data warehouse high-level parameters");
    contentPanel.setBorder(null);
    contentPanel.setMaximumSize(new Dimension(400, 410));
    contentPanel.setMinimumSize(new Dimension(400, 410));
    contentPanel.setPreferredSize(new Dimension(400, 410));
    jPDimensions.setBorder(BorderFactory.createEtchedBorder());
    jPDimensions.setMaximumSize(new Dimension(0, 180));
    jPDimensions.setMinimumSize(new Dimension(0, 180));
    jPDimensions.setPreferredSize(new Dimension(0, 180));
    jPDimensions.setBounds(new Rectangle(5, 165, 390, 180));
    jPDimensions.setLayout(null);
    jPTableFaits.setBorder(BorderFactory.createEtchedBorder());
    jPTableFaits.setMaximumSize(new Dimension(0, 150));
    jPTableFaits.setMinimumSize(new Dimension(0, 150));
    jPTableFaits.setPreferredSize(new Dimension(0, 150));
    jPTableFaits.setBounds(new Rectangle(5, 10, 390, 150));
    jPTableFaits.setLayout(null);
    jPValidation.setBorder(BorderFactory.createEtchedBorder());
    jPValidation.setMaximumSize(new Dimension(0, 50));
    jPValidation.setMinimumSize(new Dimension(0, 50));
    jPValidation.setPreferredSize(new Dimension(0, 50));
    jPValidation.setBounds(new Rectangle(5, 350, 390, 50));
    jPValidation.setLayout(fLValidation);
    jLBTablesFaitsTitre.setText("Fact tables");
    jLBTablesFaitsTitre.setBounds(new Rectangle(2, 2, 386, 20));
    jLBTablesFaitsTitre.setHorizontalTextPosition(SwingConstants.CENTER);
    jLBTablesFaitsTitre.setHorizontalAlignment(SwingConstants.CENTER);
    jLBTablesFaitsTitre.setPreferredSize(new Dimension(290, 20));
    jLBTablesFaitsTitre.setMinimumSize(new Dimension(290, 20));
    jLBTablesFaitsTitre.setMaximumSize(new Dimension(290, 20));
    jLBTablesFaitsTitre.setBorder(BorderFactory.createRaisedBevelBorder());
    jLBTablesFaitsTitre.setAlignmentY((float) 0.0);
    jLBTablesFaitsTitre.setAlignmentX((float) 0.0);
    jLBTablesFaitsTitre.setFont(new java.awt.Font("Arial", 1, 12));
    jLBDimensionsTitre.setFont(new java.awt.Font("Arial", 1, 12));
    jLBDimensionsTitre.setAlignmentX((float) 0.0);
    jLBDimensionsTitre.setAlignmentY((float) 0.0);
    jLBDimensionsTitre.setBorder(BorderFactory.createRaisedBevelBorder());
    jLBDimensionsTitre.setMaximumSize(new Dimension(290, 20));
    jLBDimensionsTitre.setMinimumSize(new Dimension(290, 20));
    jLBDimensionsTitre.setPreferredSize(new Dimension(290, 20));
    jLBDimensionsTitre.setHorizontalAlignment(SwingConstants.CENTER);
    jLBDimensionsTitre.setHorizontalTextPosition(SwingConstants.CENTER);
    jLBDimensionsTitre.setText("Dimensions");
    jLBDimensionsTitre.setBounds(new Rectangle(2, 2, 386, 20));
    jLBTFNbDimensions.setMaximumSize(new Dimension(300, 20));
    jLBTFNbDimensions.setMinimumSize(new Dimension(300, 20));
    jLBTFNbDimensions.setPreferredSize(new Dimension(300, 20));
    jLBTFNbDimensions.setToolTipText("");
    jLBTFNbDimensions.setText("Average number of dimensions per fact table (AVG_NB_DIM):");
    jTFTFNbDimensions.setMaximumSize(new Dimension(50, 20));
    jTFTFNbDimensions.setMinimumSize(new Dimension(50, 20));
    jTFTFNbDimensions.setPreferredSize(new Dimension(50, 20));
    jTFTFNbDimensions.setSelectionStart(0);
    jTFTFNbDimensions.setText("5");
    jTFTFNbDimensions.addActionListener(new DLGParametresHN_jTFTFNbDimensions_actionAdapter(this));
    jPTFNbDimensions.setLayout(fLTFNbDimensions);
    fLTFNbDimensions.setAlignment(FlowLayout.LEFT);
    fLTFNbDimensions.setHgap(5);
    fLTFNbDimensions.setVgap(5);
    jLBDimNbNiveaux.setText("Average number of hierarchy levels in dimensions (AVG_NB_LEVELS):");
    jLBDimNbNiveaux.setToolTipText("");
    jLBDimNbNiveaux.setPreferredSize(new Dimension(300, 20));
    jLBDimNbNiveaux.setMinimumSize(new Dimension(300, 20));
    jLBDimNbNiveaux.setMaximumSize(new Dimension(300, 20));
    jTFDimNbNiveaux.setText("3");
    jTFDimNbNiveaux.addActionListener(new DLGParametresHN_jTFDimNbNiveaux_actionAdapter(this));
    jTFDimNbNiveaux.setSelectionStart(0);
    jTFDimNbNiveaux.setPreferredSize(new Dimension(50, 20));
    jTFDimNbNiveaux.setMinimumSize(new Dimension(50, 20));
    jTFDimNbNiveaux.setMaximumSize(new Dimension(50, 20));
    jPDimNbNiveaux.setLayout(fLDimNbNiveaux);
    fLDimNbNiveaux.setAlignment(FlowLayout.LEFT);
    fLDimNbNiveaux.setHgap(5);
    fLDimNbNiveaux.setVgap(5);
    jPDimNbNiveaux.setBorder(null);
    jPDimNbNiveaux.setBounds(new Rectangle(2, 52, 386, 30));
    jBTValider.setMaximumSize(new Dimension(90, 25));
    jBTValider.setMinimumSize(new Dimension(90, 25));
    jBTValider.setPreferredSize(new Dimension(90, 25));
    jBTValider.setActionCommand("Validate");
    jBTValider.setText("Validate");
    jBTValider.addActionListener(new DLGParametresHN_jBTValider_actionAdapter(this));
    fLValidation.setHgap(10);
    fLValidation.setVgap(10);

    fLTFDensit.setHgap(5);
    fLTFDensit.setVgap(5);
    fLTFDensit.setAlignment(FlowLayout.LEFT);
    jTFTFDensit.addActionListener(new DLGParametresHN_jTFTFDensit_actionAdapter(this));
    jTFTFDensit.setText("0.6");
    jTFTFDensit.addActionListener(new DLGParametresHN_jTFTFDensit_actionAdapter(this));
    jTFTFDensit.setSelectionStart(0);
    jTFTFDensit.setPreferredSize(new Dimension(50, 20));
    jTFTFDensit.setMinimumSize(new Dimension(50, 20));
    jTFTFDensit.setMaximumSize(new Dimension(50, 20));
    jLBTFDensit.setText("Average density rate in fact tables (AVG_DENSITY):");
    jLBTFDensit.setToolTipText("");
    jLBTFDensit.setPreferredSize(new Dimension(300, 20));
    jLBTFDensit.setMinimumSize(new Dimension(300, 20));
    jLBTFDensit.setMaximumSize(new Dimension(300, 20));
    jPTFDensit.setLayout(fLTFDensit);
    fLTFNbMesures.setHgap(5);
    fLTFNbMesures.setVgap(5);
    fLTFNbMesures.setAlignment(FlowLayout.LEFT);
    jTFTFNbMesures.addActionListener(new DLGParametresHN_jTFTFNbMesures_actionAdapter(this));
    jTFTFNbMesures.setText("5");
    jTFTFNbMesures.addActionListener(new DLGParametresHN_jTFTFNbMesures_actionAdapter(this));
    jTFTFNbMesures.setSelectionStart(0);
    jTFTFNbMesures.setPreferredSize(new Dimension(50, 20));
    jTFTFNbMesures.setMinimumSize(new Dimension(50, 20));
    jTFTFNbMesures.setMaximumSize(new Dimension(50, 20));
    jLBTFNbMesures.setText("Average number of measures in fact tables (AVG_NB_MEAS):");
    jLBTFNbMesures.setToolTipText("");
    jLBTFNbMesures.setPreferredSize(new Dimension(300, 20));
    jLBTFNbMesures.setMinimumSize(new Dimension(300, 20));
    jLBTFNbMesures.setMaximumSize(new Dimension(300, 20));
    jPTFNbMesures.setLayout(fLTFNbMesures);
    jPTFNbDimensions.setMaximumSize(new Dimension(0, 30));
    jPTFNbDimensions.setMinimumSize(new Dimension(0, 30));
    jPTFNbDimensions.setPreferredSize(new Dimension(0, 30));
    jPTFNbDimensions.setBounds(new Rectangle(2, 52, 386, 30));
    jPTFNbMesures.setMaximumSize(new Dimension(0, 30));
    jPTFNbMesures.setMinimumSize(new Dimension(0, 30));
    jPTFNbMesures.setPreferredSize(new Dimension(0, 30));
    jPTFNbMesures.setBounds(new Rectangle(2, 82, 386, 30));
    jPTFDensit.setMaximumSize(new Dimension(0, 30));
    jPTFDensit.setMinimumSize(new Dimension(0, 30));
    jPTFDensit.setPreferredSize(new Dimension(0, 30));
    jPTFDensit.setBounds(new Rectangle(2, 112, 386, 30));
    jTFDimFacteurEchelle.setMaximumSize(new Dimension(50, 20));
    jTFDimFacteurEchelle.setMinimumSize(new Dimension(50, 20));
    jTFDimFacteurEchelle.setPreferredSize(new Dimension(50, 20));
    jTFDimFacteurEchelle.setSelectionStart(0);
    jTFDimFacteurEchelle.addActionListener(new DLGParametresHN_jTFDimFacteurEchelle_actionAdapter(this));
    jTFDimFacteurEchelle.setText("10");
    jTFDimFacteurEchelle.addActionListener(new DLGParametresHN_jTFDimFacteurEchelle_actionAdapter(this));
    fLDimFacteurEchelle.setVgap(5);
    fLDimFacteurEchelle.setHgap(5);
    fLDimFacteurEchelle.setAlignment(FlowLayout.LEFT);
    jPDimFacteurEchelle.setBorder(null);
    jPDimFacteurEchelle.setBounds(new Rectangle(2, 142, 386, 30));
    jPDimFacteurEchelle.setLayout(fLDimFacteurEchelle);
    jLBDimFacteurEchelle.setText("Average size scale factor within hierarchy levels (DIM_SFACTOR):");
    jLBDimFacteurEchelle.setToolTipText("");
    jLBDimFacteurEchelle.setPreferredSize(new Dimension(300, 20));
    jLBDimFacteurEchelle.setMinimumSize(new Dimension(300, 20));
    jLBDimFacteurEchelle.setMaximumSize(new Dimension(300, 20));
    jTFDimNbEnrHN.setMaximumSize(new Dimension(50, 20));
    jTFDimNbEnrHN.setMinimumSize(new Dimension(50, 20));
    jTFDimNbEnrHN.setPreferredSize(new Dimension(50, 20));
    jTFDimNbEnrHN.setSelectionStart(0);
    jTFDimNbEnrHN.addActionListener(new DLGParametresHN_jTFDimNbEnrHN_actionAdapter(this));
    jTFDimNbEnrHN.setText("10");
    jTFDimNbEnrHN.addActionListener(new DLGParametresHN_jTFDimNbEnrHN_actionAdapter(this));
    fLDimNbEnrHN.setVgap(5);
    fLDimNbEnrHN.setHgap(5);
    fLDimNbEnrHN.setAlignment(FlowLayout.LEFT);
    jPDimNbEnrHN.setBorder(null);
    jPDimNbEnrHN.setBounds(new Rectangle(2, 112, 386, 30));
    jPDimNbEnrHN.setLayout(fLDimNbEnrHN);
    jLBDimNbEnrHN.setText("Average number of tuples in highest hierarchy levels (AVG_HHLEVEL_SIZE):");
    jLBDimNbEnrHN.setToolTipText("");
    jLBDimNbEnrHN.setPreferredSize(new Dimension(300, 20));
    jLBDimNbEnrHN.setMinimumSize(new Dimension(300, 20));
    jLBDimNbEnrHN.setMaximumSize(new Dimension(300, 20));
    jTFDimNbAttributs.setMaximumSize(new Dimension(50, 20));
    jTFDimNbAttributs.setMinimumSize(new Dimension(50, 20));
    jTFDimNbAttributs.setPreferredSize(new Dimension(50, 20));
    jTFDimNbAttributs.setSelectionStart(0);
    jTFDimNbAttributs.addActionListener(new DLGParametresHN_jTFDimNbAttributs_actionAdapter(this));
    jTFDimNbAttributs.setText("5");
    jTFDimNbAttributs.addActionListener(new DLGParametresHN_jTFDimNbAttributs_actionAdapter(this));
    fLDimNbAttributs.setVgap(5);
    fLDimNbAttributs.setHgap(5);
    fLDimNbAttributs.setAlignment(FlowLayout.LEFT);
    jPDimNbAttributs.setBorder(null);
    jPDimNbAttributs.setBounds(new Rectangle(2, 82, 386, 30));
    jPDimNbAttributs.setLayout(fLDimNbAttributs);
    jLBDimNbAttributs.setText("Average number of attributes in hierarchy levels (AVG_NB_ATT):");
    jLBDimNbAttributs.setToolTipText("");
    jLBDimNbAttributs.setPreferredSize(new Dimension(300, 20));
    jLBDimNbAttributs.setMinimumSize(new Dimension(300, 20));
    jLBDimNbAttributs.setMaximumSize(new Dimension(300, 20));
    jTFDimNbDimensions.setMaximumSize(new Dimension(50, 20));
    jTFDimNbDimensions.setMinimumSize(new Dimension(50, 20));
    jTFDimNbDimensions.setPreferredSize(new Dimension(50, 20));
    jTFDimNbDimensions.setSelectionStart(0);
    jTFDimNbDimensions.addActionListener(new DLGParametresHN_jTFDimNbDimensions_actionAdapter(this));
    jTFDimNbDimensions.setText("5");
    jTFDimNbDimensions.addActionListener(new DLGParametresHN_jTFDimNbDimensions_actionAdapter(this));
    fLDimNbDimensions.setVgap(5);
    fLDimNbDimensions.setHgap(5);
    fLDimNbDimensions.setAlignment(FlowLayout.LEFT);
    jPDimNbDimensions.setBorder(null);
    jPDimNbDimensions.setBounds(new Rectangle(2, 22, 386, 30));
    jPDimNbDimensions.setLayout(fLDimNbDimensions);
    jLBDimNbDimensions.setText("Total number of dimensions (TOT_NB_DIM):");
    jLBDimNbDimensions.setToolTipText("");
    jLBDimNbDimensions.setPreferredSize(new Dimension(300, 20));
    jLBDimNbDimensions.setMinimumSize(new Dimension(300, 20));
    jLBDimNbDimensions.setMaximumSize(new Dimension(300, 20));
    fLTFNbTablesFaits.setVgap(5);
    fLTFNbTablesFaits.setHgap(5);
    fLTFNbTablesFaits.setAlignment(FlowLayout.LEFT);
    jTFTFNbTablesFaits.addActionListener(new DLGParametresHN_jTFTFNbTablesFaits_actionAdapter(this));
    jTFTFNbTablesFaits.setText("1");
    jTFTFNbTablesFaits.addActionListener(new DLGParametresHN_jTFTFNbTablesFaits_actionAdapter(this));
    jTFTFNbTablesFaits.setSelectionStart(0);
    jTFTFNbTablesFaits.setPreferredSize(new Dimension(50, 20));
    jTFTFNbTablesFaits.setSelectionEnd(1);
    jTFTFNbTablesFaits.setMinimumSize(new Dimension(50, 20));
    jTFTFNbTablesFaits.setMaximumSize(new Dimension(50, 20));
    jLBTFNbTablesFaits.setText("Number of fact tables (NB_FT):");
    jLBTFNbTablesFaits.setToolTipText("");
    jLBTFNbTablesFaits.setPreferredSize(new Dimension(300, 20));
    jLBTFNbTablesFaits.setMinimumSize(new Dimension(300, 20));
    jLBTFNbTablesFaits.setMaximumSize(new Dimension(300, 20));
    jPTFNbTablesFaits.setPreferredSize(new Dimension(0, 30));
    jPTFNbTablesFaits.setBounds(new Rectangle(2, 22, 386, 30));
    jPTFNbTablesFaits.setMinimumSize(new Dimension(0, 30));
    jPTFNbTablesFaits.setMaximumSize(new Dimension(0, 30));
    jPTFNbTablesFaits.setLayout(fLTFNbTablesFaits);
    jPDimNbNiveaux.add(jLBDimNbNiveaux, null);
    jPDimNbNiveaux.add(jTFDimNbNiveaux, null);
    jPDimNbEnrHN.add(jLBDimNbEnrHN, null);
    jPDimNbEnrHN.add(jTFDimNbEnrHN, null);
    jPDimNbAttributs.add(jLBDimNbAttributs, null);
    jPDimNbAttributs.add(jTFDimNbAttributs, null);
    jPDimNbDimensions.add(jLBDimNbDimensions, null);
    jPDimNbDimensions.add(jTFDimNbDimensions, null);
    jPDimensions.add(jLBDimensionsTitre, null);
    jPDimensions.add(jPDimNbDimensions, null);
    jPDimensions.add(jPDimNbNiveaux, null);
    jPDimensions.add(jPDimNbAttributs, null);
    jPDimensions.add(jPDimNbEnrHN, null);
    jPDimensions.add(jPDimFacteurEchelle, null);
    jPDimFacteurEchelle.add(jLBDimFacteurEchelle, null);
    jPDimFacteurEchelle.add(jTFDimFacteurEchelle, null);
    jPTFNbDimensions.add(jLBTFNbDimensions, null);
    jPTFNbDimensions.add(jTFTFNbDimensions, null);
    jPTFDensit.add(jLBTFDensit, null);
    jPTFDensit.add(jTFTFDensit, null);
    jPTFNbMesures.add(jLBTFNbMesures, null);
    jPTFNbMesures.add(jTFTFNbMesures, null);
    jPTFNbTablesFaits.add(jLBTFNbTablesFaits, null);
    jPTFNbTablesFaits.add(jTFTFNbTablesFaits, null);
    jPTableFaits.add(jLBTablesFaitsTitre, null);
    jPTableFaits.add(jPTFNbTablesFaits, null);
    jPTableFaits.add(jPTFNbDimensions, null);
    jPTableFaits.add(jPTFNbMesures, null);
    jPTableFaits.add(jPTFDensit, null);
    getContentPane().add(contentPanel);
    contentPanel.add(jPTableFaits, null);
    contentPanel.add(jPDimensions, null);
    contentPanel.add(jPValidation, null);
    jPValidation.add(jBTValider, null);

    ////////////////////////////////////////////////////////////////////////////
  }

  void jBTValider_actionPerformed(ActionEvent e) {
    if (jTFDimNbNiveaux.getText().length() == 0 || jTFTFNbDimensions.getText().length() == 0)
      JOptionPane.showMessageDialog(null,"Please enter the total number of dimensions and fact tables");
    else
      this.hide();
  }

  void jTFTFNbDimensions_actionPerformed(ActionEvent e) {
    try {
      Integer.parseInt(jTFTFNbDimensions.getText());
    }
    catch (Exception erreurSaisie) {
      JOptionPane.showMessageDialog(null,"Please enter an integer");
      jTFTFNbDimensions.setText("5");
    }
  }

  void jTFTFNbMesures_actionPerformed(ActionEvent e) {
    try {
      Integer.parseInt(jTFTFNbMesures.getText());
    }
    catch (Exception erreurSaisie) {
      JOptionPane.showMessageDialog(null,"Please enter an integer");
      jTFTFNbMesures.setText("5");
    }
  }

  void jTFTFDensit_actionPerformed(ActionEvent e) {
    try {
      if (Double.parseDouble(jTFTFDensit.getText()) < 0.0 || Double.parseDouble(jTFTFDensit.getText()) > 1.0) {
        JOptionPane.showMessageDialog(null,"Please enter a value between 0.0 and 1.0");
        jTFTFDensit.setText("0.6");
      }
    }
    catch (Exception erreurSaisie) {
      JOptionPane.showMessageDialog(null,"Please enter a value between 0.0 and 1.0");
      jTFTFDensit.setText("0.6");
    }
  }

  void jTFDimNbNiveaux_actionPerformed(ActionEvent e) {
    try {
      Integer.parseInt(jTFDimNbNiveaux.getText());
    }
    catch (Exception erreurSaisie) {
      JOptionPane.showMessageDialog(null,"Please enter an integer");
      jTFDimNbNiveaux.setText("3");
    }
  }

  void jTFDimNbAttributs_actionPerformed(ActionEvent e) {
    try {
      Integer.parseInt(jTFDimNbAttributs.getText());
    }
    catch (Exception erreurSaisie) {
      JOptionPane.showMessageDialog(null,"Please enter an integer");
      jTFDimNbAttributs.setText("5");
    }
  }

  void jTFDimNbEnrHN_actionPerformed(ActionEvent e) {
    try {
      Integer.parseInt(jTFDimNbEnrHN.getText());
    }
    catch (Exception erreurSaisie) {
      JOptionPane.showMessageDialog(null,"Please enter an integer");
      jTFDimNbEnrHN.setText("10");
    }
  }

  void jTFDimFacteurEchelle_actionPerformed(ActionEvent e) {
    try {
      Integer.parseInt(jTFDimFacteurEchelle.getText());
    }
    catch (Exception erreurSaisie) {
      JOptionPane.showMessageDialog(null,"Please enter an integer");
      jTFDimFacteurEchelle.setText("10");
    }
  }

  void jTFTFNbTablesFaits_actionPerformed(ActionEvent e) {
    try {
      Integer.parseInt(jTFTFNbTablesFaits.getText());
    }
    catch (Exception erreurSaisie) {
      JOptionPane.showMessageDialog(null,"Please enter an integer");
      jTFTFNbTablesFaits.setText("1");
    }
  }

  void jTFDimNbDimensions_actionPerformed(ActionEvent e) {
    try {
      Integer.parseInt(jTFDimNbDimensions.getText());
    }
    catch (Exception erreurSaisie) {
      JOptionPane.showMessageDialog(null,"Please enter an integer");
      jTFDimNbDimensions.setText("5");
    }
  }
}

class DLGParametresHN_jBTValider_actionAdapter implements java.awt.event.ActionListener {
  DLGParametresHN adaptee;

  DLGParametresHN_jBTValider_actionAdapter(DLGParametresHN adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jBTValider_actionPerformed(e);
  }
}

class DLGParametresHN_jTFDimNbNiveaux_actionAdapter implements java.awt.event.ActionListener {
  DLGParametresHN adaptee;

  DLGParametresHN_jTFDimNbNiveaux_actionAdapter(DLGParametresHN adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jTFDimNbNiveaux_actionPerformed(e);
  }
}

class DLGParametresHN_jTFTFNbDimensions_actionAdapter implements java.awt.event.ActionListener {
  DLGParametresHN adaptee;

  DLGParametresHN_jTFTFNbDimensions_actionAdapter(DLGParametresHN adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jTFTFNbDimensions_actionPerformed(e);
  }
}

class DLGParametresHN_jTFTFNbMesures_actionAdapter implements java.awt.event.ActionListener {
  DLGParametresHN adaptee;

  DLGParametresHN_jTFTFNbMesures_actionAdapter(DLGParametresHN adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jTFTFNbMesures_actionPerformed(e);
  }
}

class DLGParametresHN_jTFTFDensit_actionAdapter implements java.awt.event.ActionListener {
  DLGParametresHN adaptee;

  DLGParametresHN_jTFTFDensit_actionAdapter(DLGParametresHN adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jTFTFDensit_actionPerformed(e);
  }
}

class DLGParametresHN_jTFDimNbAttributs_actionAdapter implements java.awt.event.ActionListener {
  DLGParametresHN adaptee;

  DLGParametresHN_jTFDimNbAttributs_actionAdapter(DLGParametresHN adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jTFDimNbAttributs_actionPerformed(e);
  }
}

class DLGParametresHN_jTFDimNbEnrHN_actionAdapter implements java.awt.event.ActionListener {
  DLGParametresHN adaptee;

  DLGParametresHN_jTFDimNbEnrHN_actionAdapter(DLGParametresHN adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jTFDimNbEnrHN_actionPerformed(e);
  }
}

class DLGParametresHN_jTFDimFacteurEchelle_actionAdapter implements java.awt.event.ActionListener {
  DLGParametresHN adaptee;

  DLGParametresHN_jTFDimFacteurEchelle_actionAdapter(DLGParametresHN adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jTFDimFacteurEchelle_actionPerformed(e);
  }
}

class DLGParametresHN_jTFTFNbTablesFaits_actionAdapter implements java.awt.event.ActionListener {
  DLGParametresHN adaptee;

  DLGParametresHN_jTFTFNbTablesFaits_actionAdapter(DLGParametresHN adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jTFTFNbTablesFaits_actionPerformed(e);
  }
}

class DLGParametresHN_jTFDimNbDimensions_actionAdapter implements java.awt.event.ActionListener {
  DLGParametresHN adaptee;

  DLGParametresHN_jTFDimNbDimensions_actionAdapter(DLGParametresHN adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jTFDimNbDimensions_actionPerformed(e);
  }
}
