////////////////////////////////////////////////////////////////////////////////
// TITRE : DWEB - DATAWAREHOUSE ENGINEERING BENCHMARK - VERSION 0.4           //
//----------------------------------------------------------------------------//
// Refresh functionality by A. Gutierrez + B. Variot - 2007                   //
//----------------------------------------------------------------------------//

package dweb03;

import java.awt.*;
import javax.swing.*;

import java.awt.event.*;
import java.awt.Dimension;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.util.Vector;




public class DLGParametresRefresh extends JDialog {

	{
		//Set Look & Feel
		try {
			javax.swing.UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
		} catch(Exception e) {
			e.printStackTrace();
		}
	}


	BaseDonnees maBaseDonnees;
	EntrepotDonnees monEntrepot;
	File monFichierRequetes;  //  @jve:decl-index=0:
	Vector maChargeRequetes = new Vector();  //  @jve:decl-index=0:
	Vector typesRequetes = new Vector();  //  @jve:decl-index=0:
	Vector tempsRequetes = new Vector();  //  @jve:decl-index=0:

       //Panel contenant tout
 JPanel contentPanel = new JPanel();  //  @jve:decl-index=0:visual-constraint="10,50"


       //Panel contenant les paramtres
 JPanel jPParameters = new JPanel();
       //Label de titre
 JLabel JLBTitle = new JLabel();

       //Premier paramtre : le Percentage de rafraichissement
 JPanel jPPercentage = new JPanel();
 JLabel jLBPercentage = new JLabel();
 JTextField jTFPercentage = new JTextField();
 FlowLayout fLPercentage = new FlowLayout();

       //Deuxime paramtre : part des enregistrements rafraichis dans les dimensions
 JPanel jPDimensions = new JPanel();
 JLabel jLBDimensions = new JLabel();
 JTextField jTFDimensions = new JTextField();
 FlowLayout fLDimensions = new FlowLayout();

       //Troisime paramtre : part des enregistrements rafrachis dans la table des faits
 JPanel jPFactTable = new JPanel();
 JLabel jLBFactTable = new JLabel();
 JTextField jTFFactTable = new JTextField();
 FlowLayout fLFactTable = new FlowLayout();


       //Quatrime paramtre : le nombre d'itrations du processus
 JPanel jPIterations = new JPanel();
 JLabel jLBIterations = new JLabel();
 JTextField jTFIterations = new JTextField();
 FlowLayout fLIterations = new FlowLayout();

 //Cinquime paramtre : le pourcentage de modification  effectuer
 JPanel jPModification = new JPanel();
 JLabel jLBModification = new JLabel();
 JTextField jTFModification = new JTextField();
 FlowLayout fLModification = new FlowLayout();

 //Sixime paramtre : le pourcentage d'insertion  effectuer
 JPanel jPInsertion = new JPanel();
 JLabel jLBInsertion = new JLabel();
 JTextField jTFInsertion = new JTextField();
 FlowLayout fLInsertion = new FlowLayout();

       //Panel contenant le bouton validate
 JPanel jPValidation = new JPanel();
 FlowLayout fLValidation = new FlowLayout();
 JButton jBTValider = new JButton();


 public DLGParametresRefresh(Frame frame, String title, boolean modal) {
   super(frame, title, modal);
   try {
     jbInit();
     pack();
     this.setSize(398, 296);
   }
   catch(Exception ex) {
     ex.printStackTrace();
   }
 }

 public DLGParametresRefresh() {
   this(null, "", false);

 }

private void jbInit() throws Exception {

 this.setTitle("Benchmark execution parameters");
 this.setModal(true);
 this.setResizable(false);
 this.setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
 getContentPane().add(contentPanel, BorderLayout.CENTER);

       //Panel contenant tout
 contentPanel.setLayout(null);
 contentPanel.setBorder(null);
 contentPanel.setSize(new Dimension(400, 214));
 contentPanel.setMaximumSize(new Dimension(400, 410));
 contentPanel.setMinimumSize(new Dimension(400, 220));
 contentPanel.setPreferredSize(new java.awt.Dimension(392, 266));


 //ajout des composants
 contentPanel.add(jPParameters, null);


       //Panel contenant les paramtres
 jPParameters.setBorder(BorderFactory.createEtchedBorder());
 jPParameters.setMaximumSize(new Dimension(0, 150));
 jPParameters.setMinimumSize(new Dimension(0, 150));
 jPParameters.setBounds(0, 7, 392, 210);
 jPParameters.setLayout(null);


               //Titre
 jPParameters.add(JLBTitle, null);
 JLBTitle.setText("Refresh and replication parameters");
 JLBTitle.setFont(new java.awt.Font("Arial", 1, 12));
 JLBTitle.setBounds(0, 0, 392, 21);
 JLBTitle.setHorizontalTextPosition(SwingConstants.CENTER);
 JLBTitle.setHorizontalAlignment(SwingConstants.CENTER);
 JLBTitle.setMinimumSize(new Dimension(290, 20));
 JLBTitle.setMaximumSize(new Dimension(290, 20));
 JLBTitle.setBorder(BorderFactory.createRaisedBevelBorder());
 JLBTitle.setAlignmentY((float) 0.0);
 JLBTitle.setAlignmentX((float) 0.0);



               //Paramtre 1 : Pourcentage
 jPParameters.add(jPPercentage, null);
 jPPercentage.add(jLBPercentage, null);
 jPPercentage.add(jTFPercentage, null);
 jLBPercentage.setText("Global refresh rate (GRR):");
 jTFPercentage.setText("0.01");
 fLPercentage.setVgap(5);
 fLPercentage.setHgap(5);
 fLPercentage.setAlignment(FlowLayout.LEFT);
 jTFPercentage.setSelectionStart(0);
 jTFPercentage.setPreferredSize(new Dimension(50, 20));
 jTFPercentage.setSelectionEnd(1);
 jTFPercentage.setMinimumSize(new Dimension(50, 20));
 jTFPercentage.setMaximumSize(new Dimension(50, 20));
 jLBPercentage.setToolTipText("");
 jLBPercentage.setPreferredSize(new Dimension(300, 20));
 jLBPercentage.setMinimumSize(new Dimension(300, 20));
 jLBPercentage.setMaximumSize(new Dimension(300, 20));
 jPPercentage.setPreferredSize(new Dimension(0, 30));
 jPPercentage.setBounds(new Rectangle(2, 22, 386, 30));
 jPPercentage.setMinimumSize(new Dimension(0, 30));
 jPPercentage.setMaximumSize(new Dimension(0, 30));
 jPPercentage.setLayout(fLPercentage);

       //Paramtre 2 : rpartition dimensions
 jPParameters.add(jPDimensions, null);
 jPDimensions.add(jLBDimensions, null);
 jPDimensions.add(jTFDimensions, null);
 jLBDimensions.setText("Dimension refresh rate (DRR):");
 jTFDimensions.setText("0.05");
 jPDimensions.setMaximumSize(new Dimension(0, 30));
 jPDimensions.setMinimumSize(new Dimension(0, 30));
 jPDimensions.setPreferredSize(new Dimension(0, 30));
 jPDimensions.setBounds(new Rectangle(2, 52, 386, 30));
 jLBDimensions.setMaximumSize(new Dimension(300, 20));
 jLBDimensions.setMinimumSize(new Dimension(300, 20));
 jLBDimensions.setPreferredSize(new Dimension(300, 20));
 jLBDimensions.setToolTipText("");
 jTFDimensions.setMaximumSize(new Dimension(50, 20));
 jTFDimensions.setMinimumSize(new Dimension(50, 20));
 jTFDimensions.setPreferredSize(new Dimension(50, 20));
 jTFDimensions.setSelectionStart(0);
jTFDimensions.addKeyListener(new KeyAdapter() {	public void keyReleased(KeyEvent evt) {
				jTFDimensionsKeyReleased(evt);
			}

});
 jPDimensions.setLayout(fLDimensions);
 fLDimensions.setAlignment(FlowLayout.LEFT);
 fLDimensions.setHgap(5);
 fLDimensions.setVgap(5);

       //Paramtre 3 : rpartition dans table des faits
 jPParameters.add(jPFactTable, null);
 jPFactTable.add(jLBFactTable, null);
 jPFactTable.add(jTFFactTable, null);
 jLBFactTable.setText("Fact refresh rate (FRR):");
 jTFFactTable.setText("0.95");
 jPFactTable.setMaximumSize(new Dimension(0, 30));
 jPFactTable.setMinimumSize(new Dimension(0, 30));
 jPFactTable.setBounds(2, 84, 385, 28);
 jLBFactTable.setMaximumSize(new Dimension(300, 20));
 jLBFactTable.setMinimumSize(new Dimension(300, 20));
 jLBFactTable.setPreferredSize(new Dimension(300, 20));
 jLBFactTable.setToolTipText("");
 jTFFactTable.setMaximumSize(new Dimension(50, 20));
 jTFFactTable.setMinimumSize(new Dimension(50, 20));
 jTFFactTable.setPreferredSize(new Dimension(50, 20));
 jTFFactTable.setSelectionStart(0);
jTFFactTable.addKeyListener(new KeyAdapter() {	public void keyReleased(KeyEvent evt) {
				jTFFactTableKeyReleased(evt);
			}

});
 jPFactTable.setLayout(fLFactTable);
 fLFactTable.setAlignment(FlowLayout.LEFT);
 fLFactTable.setHgap(5);
 fLFactTable.setVgap(5);

       //Paramtre 4 : nombre d'iterations du processus
 jPParameters.add(jPIterations, null);
 jPIterations.add(jLBIterations, null);
 jPIterations.add(jTFIterations, null);
 jLBIterations.setText("Number of warm run replications (REPN):");
 jTFIterations.setText("10");
 fLIterations.setHgap(5);
 fLIterations.setVgap(5);
 fLIterations.setAlignment(FlowLayout.LEFT);
 jTFIterations.setSelectionStart(0);
 jTFIterations.setPreferredSize(new Dimension(50, 20));
 jTFIterations.setMinimumSize(new Dimension(50, 20));
 jTFIterations.setMaximumSize(new Dimension(50, 20));
 jLBIterations.setToolTipText("");
 jLBIterations.setPreferredSize(new Dimension(300, 20));
 jLBIterations.setMinimumSize(new Dimension(300, 20));
 jLBIterations.setMaximumSize(new Dimension(300, 20));
 jPIterations.setLayout(fLIterations);
 jPIterations.setMaximumSize(new Dimension(0, 30));
 jPIterations.setMinimumSize(new Dimension(0, 30));
 jPIterations.setPreferredSize(new Dimension(0, 30));
 jPIterations.setBounds(new Rectangle(2, 168, 386, 30));
 jTFIterations.addActionListener(new DLGParametresRefresh_jTFIterations_actionAdapter(this));

 //Paramtre 5 : Pourcentage de modification
 jPParameters.add(jPModification, null);
 jPModification.add(jLBModification, null);
 jPModification.add(jTFModification, null);
 jLBModification.setText("Modification rate (MR):");
 jTFModification.setText("0.05");
 fLModification.setHgap(5);
 fLModification.setVgap(5);
 fLModification.setAlignment(FlowLayout.LEFT);
 jTFModification.setSelectionStart(0);
 jTFModification.setMinimumSize(new Dimension(50, 20));
 jTFModification.setMaximumSize(new Dimension(50, 20));
 jLBModification.setToolTipText("");
 jLBModification.setMinimumSize(new Dimension(300, 20));
 jLBModification.setMaximumSize(new Dimension(300, 20));
 jPModification.setLayout(fLModification);
 jPModification.setMaximumSize(new Dimension(0, 30));
 jPModification.setMinimumSize(new Dimension(0, 30));
 jPModification.setBounds(3, 140, 378, 28);
 jPModification.add(jLBModification);
 jLBModification.setBounds(7, 147, 301, 21);
 jLBModification.setPreferredSize(new java.awt.Dimension(299, 14));
 jPModification.add(jTFModification);
 jTFModification.setBounds(310, 147, 49, 21);
 jTFModification.setPreferredSize(new java.awt.Dimension(50, 21));
jTFModification.addKeyListener(new KeyAdapter() {	public void keyReleased(KeyEvent evt) {
				jTFModificationKeyReleased(evt);
			}

});

 //Paramtre 6 : pourcentage d'insertion
 jPParameters.add(jPInsertion, null);
 jPInsertion.add(jLBInsertion, null);
 jPInsertion.add(jTFInsertion, null);
 jLBInsertion.setText("Insert rate (IR):");
 jTFInsertion.setText("0.95");
 fLInsertion.setHgap(5);
 fLInsertion.setVgap(5);
 fLInsertion.setAlignment(FlowLayout.LEFT);
 jTFInsertion.setSelectionStart(0);
 jTFInsertion.setMinimumSize(new Dimension(50, 20));
 jTFInsertion.setMaximumSize(new Dimension(50, 20));
 jLBInsertion.setToolTipText("");
 jLBInsertion.setMinimumSize(new Dimension(300, 20));
 jLBInsertion.setMaximumSize(new Dimension(300, 20));
 jPInsertion.setLayout(fLInsertion);
 jPInsertion.setMaximumSize(new Dimension(0, 30));
 jPInsertion.setMinimumSize(new Dimension(0, 30));
 jPInsertion.setBounds(2, 112, 378, 28);
 jLBInsertion.setBounds(7, 147, 301, 21);
 jTFInsertion.setBounds(310, 147, 49, 21);
 jTFInsertion.setPreferredSize(new java.awt.Dimension(50, 21));
 jPInsertion.add(jLBInsertion);
 jLBInsertion.setPreferredSize(new java.awt.Dimension(300, 14));
 jPInsertion.add(jTFInsertion);
jTFInsertion.addKeyListener(new KeyAdapter() {	public void keyReleased(KeyEvent evt) {
				jTFInsertionKeyReleased(evt);
			}

});

       //Panel et bouton validate
 contentPanel.add(jPValidation, null);
 jBTValider.setText("Validate");
 jPValidation.setBorder(BorderFactory.createEtchedBorder());
 jPValidation.setMaximumSize(new Dimension(0, 50));
 jPValidation.setMinimumSize(new Dimension(0, 50));
 jPValidation.setBounds(0, 217, 392, 49);
 jPValidation.setLayout(fLValidation);
 jPValidation.add(jBTValider);
 jBTValider.setMinimumSize(new Dimension(90, 25));
 jBTValider.setPreferredSize(new Dimension(90, 25));
 jBTValider.setActionCommand("Validate");
 fLValidation.setHgap(10);
 fLValidation.setVgap(10);
 jBTValider.addActionListener(new DLGParametresRefresh_jBTValider_actionAdapter(this));

 }


 boolean jTFDimensions_actionPerformed(ActionEvent e) {
           try {
             if (Double.parseDouble(jTFDimensions.getText()) < 0.0 || Double.parseDouble(jTFDimensions.getText()) > 1.0) {
               JOptionPane.showMessageDialog(null,"Please enter a value between 0.0 and 1.0");
               jTFDimensions.setText("0.5");
               jTFFactTable.setText("0.5");
               return false;
             }
             return true;
           }
           catch (Exception erreurSaisie) {
             JOptionPane.showMessageDialog(null,"Please enter a value between 0.0 and 1.0");
             jTFDimensions.setText("0.5");
             jTFFactTable.setText("0.5");
             return false;
           }
 }

boolean jTFFactTable_actionPerformed(ActionEvent e) {
         try {
             if (Double.parseDouble(jTFFactTable.getText()) < 0.0 || Double.parseDouble(jTFFactTable.getText()) > 1.0) {
               JOptionPane.showMessageDialog(null,"Please enter a value between 0.0 and 1.0");
               jTFFactTable.setText("0.5");
               jTFDimensions.setText("0.5");
               return false;
             }
             return true;
           }
           catch (Exception erreurSaisie) {
             JOptionPane.showMessageDialog(null,"Please enter a value between 0.0 and 1.0");
             jTFFactTable.setText("0.5");
             jTFDimensions.setText("0.5");
             return false;
           }
 }

boolean jTFInsertions_actionPerformed(ActionEvent e) {
    try {
        if (Double.parseDouble(jTFInsertion.getText()) < 0.0 || Double.parseDouble(jTFInsertion.getText()) > 1.0) {
          JOptionPane.showMessageDialog(null,"Please enter a value between 0.0 and 1.0");
          jTFInsertion.setText("0.5");
          jTFModification.setText("0.5");
          return false;
        }
        return true;
      }
      catch (Exception erreurSaisie) {
        JOptionPane.showMessageDialog(null,"Please enter a value between 0.0 and 1.0");
        jTFInsertion.setText("0.5");
        jTFModification.setText("0.5");
        return false;
      }
}

boolean jTFModification_actionPerformed(ActionEvent e) {
    try {
        if (Double.parseDouble(jTFModification.getText()) < 0.0 || Double.parseDouble(jTFModification.getText()) > 1.0) {
          JOptionPane.showMessageDialog(null,"Please enter a value between 0.0 and 1.0");
          jTFModification.setText("0.5");
          jTFInsertion.setText("0.5");
          return false;
        }
        return true;
      }
      catch (Exception erreurSaisie) {
        JOptionPane.showMessageDialog(null,"Please enter a value between 0.0 and 1.0");
        jTFModification.setText("0.5");
        jTFInsertion.setText("0.5");
        return false;
      }
}

 boolean jTFPercentage_actionPerformed(ActionEvent e) {
         try {
             if (Double.parseDouble(jTFPercentage.getText()) < 0.0 || Double.parseDouble(jTFPercentage.getText()) > 1.0) {
               JOptionPane.showMessageDialog(null,"Please enter a value between 0.0 and 1.0 as percentage");
               jTFPercentage.setText("0.5");
               return false;
             }
             return true;
           }
           catch (Exception erreurSaisie) {
             JOptionPane.showMessageDialog(null,"Please enter a value between 0.0 and 1.0 as percentage");
             jTFPercentage.setText("0.5");
             return false;
           }
         }

 boolean jTFIterations_actionPerformed(ActionEvent e) {

         try {
             Integer.parseInt(jTFIterations.getText());
             return true;
           }
           catch (Exception erreurSaisie) {
             JOptionPane.showMessageDialog(null,"Please enter an integer as number of iterations");
             jTFIterations.setText("1");
             return false;
           }
 }


 void jBTValider_actionPerformed(ActionEvent e) {

         if (this.jTFInsertions_actionPerformed(e) && this.jTFModification_actionPerformed(e) && this.jTFIterations_actionPerformed(e) && this.jTFDimensions_actionPerformed(e) && this.jTFFactTable_actionPerformed(e) && this.jTFPercentage_actionPerformed(e))
             this.hide();
         }

		private void jTFDimensionsKeyReleased(KeyEvent evt) {
			try{
				jTFFactTable.setText(String.valueOf((double)(Math.round(100*(1-Double.parseDouble(jTFDimensions.getText()))))/100));
			}
			catch(Exception e){
				// Rien
			}
		}

		private void jTFFactTableKeyReleased(KeyEvent evt) {
			try{
				jTFDimensions.setText(String.valueOf((double)(Math.round(100*(1-Double.parseDouble(jTFFactTable.getText()))))/100));
			}
			catch(Exception e){

			}
		}

		private void jTFInsertionKeyReleased(KeyEvent evt) {
			try{
				jTFModification.setText(String.valueOf((double)(Math.round(100*(1-Double.parseDouble(jTFInsertion.getText()))))/100));
			}
			catch(Exception e ){}
		}

		private void jTFModificationKeyReleased(KeyEvent evt) {
			try{
				jTFInsertion.setText(String.valueOf((double)(Math.round(100*(1-Double.parseDouble(jTFModification.getText()))))/100));
			}
			catch(Exception e){}
		}

 class DLGParametresRefresh_jBTValider_actionAdapter implements java.awt.event.ActionListener {
         DLGParametresRefresh adaptee;

         DLGParametresRefresh_jBTValider_actionAdapter(DLGParametresRefresh adaptee) {
           this.adaptee = adaptee;
         }
         public void actionPerformed(ActionEvent e) {
           adaptee.jBTValider_actionPerformed(e);
         }
       }


class DLGParametresRefresh_jTFDimensions_actionAdapter implements java.awt.event.ActionListener {
 DLGParametresRefresh adaptee;

 DLGParametresRefresh_jTFDimensions_actionAdapter(DLGParametresRefresh adaptee) {
   this.adaptee = adaptee;
 }
 public void actionPerformed(ActionEvent e) {
   adaptee.jTFDimensions_actionPerformed(e);
 }
}

class DLGParametresRefresh_jTFFactTable_actionAdapter implements java.awt.event.ActionListener {
 DLGParametresRefresh adaptee;

 DLGParametresRefresh_jTFFactTable_actionAdapter(DLGParametresRefresh adaptee) {
   this.adaptee = adaptee;
 }
 public void actionPerformed(ActionEvent e) {
   adaptee.jTFFactTable_actionPerformed(e);
 }
}

class DLGParametresRefresh_jTFIterations_actionAdapter implements java.awt.event.ActionListener {
 DLGParametresRefresh adaptee;

 DLGParametresRefresh_jTFIterations_actionAdapter(DLGParametresRefresh adaptee) {
   this.adaptee = adaptee;
 }
 public void actionPerformed(ActionEvent e) {
   adaptee.jTFIterations_actionPerformed(e);
 }
}
class DLGParametresRefresh_jTFPercentage_actionAdapter implements java.awt.event.ActionListener {
 DLGParametresRefresh adaptee;

 DLGParametresRefresh_jTFPercentage_actionAdapter(DLGParametresRefresh adaptee) {
   this.adaptee = adaptee;
 }
 public void actionPerformed(ActionEvent e) {
   adaptee.jTFPercentage_actionPerformed(e);
 }
}

class DLGParametresRefresh_jTFInsertions_actionAdapter implements java.awt.event.ActionListener {
	 DLGParametresRefresh adaptee;

	 DLGParametresRefresh_jTFInsertions_actionAdapter(DLGParametresRefresh adaptee) {
	   this.adaptee = adaptee;
	 }
	 public void actionPerformed(ActionEvent e) {
	   adaptee.jTFInsertions_actionPerformed(e);
	 }
	}

class DLGParametresRefresh_jTFModification_actionAdapter implements java.awt.event.ActionListener {
	 DLGParametresRefresh adaptee;

	 DLGParametresRefresh_jTFModification_actionAdapter(DLGParametresRefresh adaptee) {
	   this.adaptee = adaptee;
	 }
	 public void actionPerformed(ActionEvent e) {
	   adaptee.jTFModification_actionPerformed(e);
	 }
	}
}
