////////////////////////////////////////////////////////////////////////////////
// TITRE : DWEB - DATAWAREHOUSE ENGINEERING BENCHMARK - VERSION 0.4           //
//----------------------------------------------------------------------------//
// Refresh functionality by A. Gutierrez + B. Variot - 2006                   //
//----------------------------------------------------------------------------//

package dweb03;

import java.io.*;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.* ;
import java.awt.*;
import java.lang.*;

import javax.swing.*;

import java.awt.event.*;
//import java.sql.*;

import dweb03.*;
import dweb03client.Chronometre;


public class DLGRefreshResult extends JDialog implements Runnable {
////////////////////////////////////////////////////////////////////////////////
 BaseDonnees maBaseDonnees;
 EntrepotDonnees monEntrepotDonnees;
 File monFichierRequetes;  //  @jve:decl-index=0:
 Vector maChargeRequetes = new Vector();  //  @jve:decl-index=0:
 Vector typesRequetes = new Vector();  //  @jve:decl-index=0:
 Vector tempsRequetes = new Vector();
 Thread thread = new Thread (this);
 boolean threadActif = true;

 DefaultListModel LResultats = new DefaultListModel();
 JScrollPane jSPListeResultats = new JScrollPane();
 BorderLayout bLResultats = new BorderLayout();
 JLabel jLBResultatsTitre = new JLabel();
 JPanel jPResultats = new JPanel();

 JPanel panel = new JPanel();
 BorderLayout borderLayout = new BorderLayout();

 JPanel jPParam = new JPanel();
 JLabel jLBParamTitre = new JLabel();
 JPanel jPParamInfos = new JPanel();
 BorderLayout bLParam = new BorderLayout();

 //Premier paramtre : le Percentage de rafraichissement
 JPanel jPPercentage = new JPanel();
 JLabel jLBPercentage = new JLabel();
 JLabel jLBPercentageRefresh = new JLabel();
 FlowLayout fLPercentage = new FlowLayout();

 //Deuxime paramtre : la rpatition des changements entre dimensions et table de faits
 JPanel jPDimensions = new JPanel();
 JLabel jLBDimensions = new JLabel();
 JLabel jLBDimensionsRefresh = new JLabel();
 FlowLayout fLDimensions = new FlowLayout();

 //Troisime paramtre : la rpatition des changements entre dimensions et table de faits
 JPanel jPFaits = new JPanel();
 JLabel jLBFaits = new JLabel();
 JLabel jLBFaitsRefresh = new JLabel();
 FlowLayout fLFaits = new FlowLayout();

 //Quatrime paramtre : Nombre d'itrations du processus
 JPanel jPIterations = new JPanel();
 JLabel jLBIterations = new JLabel();
 JLabel jLBIterationsRefresh = new JLabel();
 FlowLayout fLIterations = new FlowLayout();

 //Cinquime paramtre : le Percentage de modification des enregistrements
 JPanel jPModification = new JPanel();
 JLabel jLBModification = new JLabel();
 JLabel jLBModificationRefresh = new JLabel();
 FlowLayout fLModification = new FlowLayout();

 //Sixime paramtre : le Percentage d'insertion des enregistrements
 JPanel jPInsertion = new JPanel();
 JLabel jLBInsertion = new JLabel();
 JLabel jLBInsertionRefresh = new JLabel();
 FlowLayout fLInsertion = new FlowLayout();


 JPanel jPExecuter = new JPanel();
 private JTextArea jTAResultats;
 JButton jBTExecuter = new JButton();
 FlowLayout fLExecuter = new FlowLayout();

 JPanel jPResultatTotal = new JPanel();
 JLabel jLBResultatTotal = new JLabel();
 FlowLayout fLResultatTotal = new FlowLayout();

public DLGRefreshResult(Frame frame, String title, boolean modal) {
   super(frame, title, modal);
   try {
     jbInit();
     pack();
     this.setSize(409, 598);
   }
   catch(Exception ex) {
     ex.printStackTrace();
   }
 }

 public DLGRefreshResult() {
   this(null, "", false);
 }

 private void jbInit() throws Exception {

   this.setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
   this.setModal(true);
   this.setResizable(false);
   this.setTitle("Performance test");
   this.setFocusTraversalKeysEnabled(false);

   //Panel contenant tout
   getContentPane().add(panel);
   panel.setLayout(borderLayout);
   panel.setMaximumSize(new Dimension(400, 500));
   panel.setMinimumSize(new Dimension(400, 500));
   panel.setPreferredSize(new Dimension(400, 500));

   //Panel contenant les parametres
   panel.add(jPParam,  BorderLayout.NORTH);
   jPParam.setBorder(BorderFactory.createEtchedBorder());
   jPParam.setMaximumSize(new Dimension(0, 0));
   jPParam.setMinimumSize(new Dimension(0, 0));
   jPParam.setPreferredSize(new java.awt.Dimension(400, 238));
   jPParam.setLayout(bLParam);
   panel.add(jPResultats, BorderLayout.CENTER);

       //Titre Param
   jPParam.add(jLBParamTitre, BorderLayout.NORTH);
   jLBParamTitre.setText("Parameters");
   jLBParamTitre.setHorizontalTextPosition(SwingConstants.CENTER);
   jLBParamTitre.setHorizontalAlignment(SwingConstants.CENTER);
   jLBParamTitre.setPreferredSize(new Dimension(0, 20));
   jLBParamTitre.setMinimumSize(new Dimension(0, 20));
   jLBParamTitre.setMaximumSize(new Dimension(0, 20));
   jLBParamTitre.setBorder(BorderFactory.createRaisedBevelBorder());
   jLBParamTitre.setAlignmentY((float) 0.0);
   jLBParamTitre.setAlignmentX((float) 0.0);
   jLBParamTitre.setFont(new java.awt.Font("Arial", 1, 12));

       //Parametres
   jPParamInfos.setBorder(BorderFactory.createEtchedBorder());
   jPParamInfos.setMaximumSize(new Dimension(0, 90));
   jPParamInfos.setMinimumSize(new Dimension(0, 90));
   jPParamInfos.setPreferredSize(new Dimension(0, 90));
   jPParamInfos.setLayout(null);
   jPParam.add(jPExecuter, BorderLayout.SOUTH);


   //Paramtre 1 : Pourcentage
   jPParamInfos.add(jPPercentage, null);
   jLBPercentage.setText("Percentage of the refreshed recordings :");
   jLBPercentageRefresh.setText("0");
   fLPercentage.setVgap(5);
   fLPercentage.setHgap(5);
   fLPercentage.setAlignment(FlowLayout.LEFT);
   jLBPercentageRefresh.setMinimumSize(new Dimension(50, 20));
   jLBPercentageRefresh.setMaximumSize(new Dimension(50, 20));
   jLBPercentageRefresh.setBounds(315, 91, 49, 21);
   jLBPercentage.setToolTipText("");
   jLBPercentage.setMinimumSize(new Dimension(300, 20));
   jLBPercentage.setMaximumSize(new Dimension(300, 20));
   jLBPercentage.setBounds(7, 42, 308, 21);
	jPPercentage.setBounds(7, 7, 385, 28);
	jPPercentage.setMinimumSize(new Dimension(0, 30));
	jPPercentage.setMaximumSize(new Dimension(0, 30));
	jPPercentage.setLayout(fLPercentage);
	jPPercentage.add(jLBPercentage);
	jLBPercentage.setPreferredSize(new java.awt.Dimension(297, 21));
	jPPercentage.add(jLBPercentageRefresh);


   //Paramtre 2 : Dimension
   jPParamInfos.add(jPDimensions, null);
   jLBDimensions.setText("Percentage of the changes operated on dimensions :");
   jLBDimensionsRefresh.setText("0");
   fLDimensions.setVgap(5);
   fLDimensions.setHgap(5);
   fLDimensions.setAlignment(FlowLayout.LEFT);
   jLBDimensionsRefresh.setMinimumSize(new Dimension(50, 20));
   jLBDimensionsRefresh.setMaximumSize(new Dimension(50, 20));
   jLBDimensionsRefresh.setBounds(315, 91, 49, 21);
   jLBDimensions.setToolTipText("");
   jLBDimensions.setMinimumSize(new Dimension(300, 20));
   jLBDimensions.setMaximumSize(new Dimension(300, 20));
   jLBDimensions.setBounds(7, 42, 308, 21);
	jPDimensions.setBounds(7, 32, 385, 28);
	jPDimensions.setMinimumSize(new Dimension(0, 30));
	jPDimensions.setMaximumSize(new Dimension(0, 30));
	jPDimensions.setLayout(fLDimensions);
	jPDimensions.add(jLBDimensions);
	jLBDimensions.setPreferredSize(new java.awt.Dimension(297, 21));
	jPDimensions.add(jLBDimensionsRefresh);

   //Paramtre 3 : Faits
   jPParamInfos.add(jPFaits, null);
   jLBFaits.setText("Percentage of the changes operated on the facts  :");
   jLBFaitsRefresh.setText("0");
   fLFaits.setVgap(5);
   fLFaits.setHgap(5);
   fLFaits.setAlignment(FlowLayout.LEFT);
   jLBFaitsRefresh.setMinimumSize(new Dimension(50, 20));
   jLBFaitsRefresh.setMaximumSize(new Dimension(50, 20));
   jLBFaitsRefresh.setBounds(315, 91, 49, 21);
   jLBFaits.setToolTipText("");
   jLBFaits.setMinimumSize(new Dimension(300, 20));
   jLBFaits.setMaximumSize(new Dimension(300, 20));
   jLBFaits.setBounds(7, 42, 308, 21);
	jPFaits.setBounds(7, 57, 385, 28);
	jPFaits.setMinimumSize(new Dimension(0, 30));
	jPFaits.setMaximumSize(new Dimension(0, 30));
	jPFaits.setLayout(fLFaits);
	jPFaits.add(jLBFaits);
	jLBFaits.setPreferredSize(new java.awt.Dimension(297, 21));
	jPFaits.add(jLBFaitsRefresh);

   //Paramtre 4 : Itrations du processus
   jPParamInfos.add(jPIterations, null);
   jLBIterations.setText("Iteration count of the process :");
   jLBIterationsRefresh.setText("0");
   fLIterations.setVgap(5);
   fLIterations.setHgap(5);
   fLIterations.setAlignment(FlowLayout.LEFT);
   jLBIterationsRefresh.setMinimumSize(new Dimension(50, 20));
   jLBIterationsRefresh.setMaximumSize(new Dimension(50, 20));
   jLBIterationsRefresh.setBounds(315, 91, 49, 21);
   jLBIterations.setToolTipText("");
   jLBIterations.setMinimumSize(new Dimension(300, 20));
   jLBIterations.setMaximumSize(new Dimension(300, 20));
   jLBIterations.setBounds(7, 42, 308, 21);
	jPIterations.setBounds(7, 132, 385, 28);
	jPIterations.setMinimumSize(new Dimension(0, 30));
	jPIterations.setMaximumSize(new Dimension(0, 30));
	jPIterations.setLayout(fLIterations);
	jPIterations.add(jLBIterations);
	jLBIterations.setPreferredSize(new java.awt.Dimension(297, 21));
	jPIterations.add(jLBIterationsRefresh);


   //Paramtre 5 : Modification  effectuer
   jPParamInfos.add(jPModification, null);
   jLBModification.setText("Percentage of the modifications operated on the changes :");
   jLBModificationRefresh.setText("0");
   fLModification.setVgap(5);
   fLModification.setHgap(5);
   fLModification.setAlignment(FlowLayout.LEFT);
   jLBModificationRefresh.setMinimumSize(new Dimension(50, 20));
   jLBModificationRefresh.setMaximumSize(new Dimension(50, 20));
   jLBModificationRefresh.setBounds(315, 91, 49, 21);
   jLBModification.setToolTipText("");
   jLBModification.setMinimumSize(new Dimension(300, 20));
   jLBModification.setMaximumSize(new Dimension(300, 20));
   jLBModification.setBounds(7, 42, 308, 21);
	jPModification.setBounds(7, 107, 385, 28);
	jPModification.setMinimumSize(new Dimension(0, 30));
	jPModification.setMaximumSize(new Dimension(0, 30));
	jPModification.setLayout(fLModification);
	jPModification.add(jLBModification);
	jLBModification.setPreferredSize(new java.awt.Dimension(297, 21));
	jPModification.add(jLBModificationRefresh);

	//Paramtre 6 : Insertion  effectuer
   jPParamInfos.add(jPInsertion, null);
   jLBInsertion.setText("Percentage of Insertions operated on the changes  :");
   jLBInsertionRefresh.setText("0");
   fLInsertion.setVgap(5);
   fLInsertion.setHgap(5);
   fLInsertion.setAlignment(FlowLayout.LEFT);
   jLBInsertionRefresh.setMinimumSize(new Dimension(50, 20));
   jLBInsertionRefresh.setMaximumSize(new Dimension(50, 20));
   jLBInsertionRefresh.setBounds(315, 91, 49, 21);
   jLBInsertion.setToolTipText("");
   jLBInsertion.setMinimumSize(new Dimension(300, 20));
   jLBInsertion.setMaximumSize(new Dimension(300, 20));
   jLBInsertion.setBounds(7, 42, 308, 21);
	jPInsertion.setBounds(7, 82, 385, 28);
	jPInsertion.setMinimumSize(new Dimension(0, 30));
	jPInsertion.setMaximumSize(new Dimension(0, 30));
	jPInsertion.setLayout(fLInsertion);
	jPInsertion.add(jLBInsertion);
	jLBInsertion.setPreferredSize(new java.awt.Dimension(297, 21));
	jPInsertion.add(jLBInsertionRefresh);

                       //Bouton Execute
   jPExecuter.add(jBTExecuter, null);
   jBTExecuter.setText("Run benchmark");
   jBTExecuter.addActionListener(new DLGRefreshResult_jBTExecuter_actionAdapter(this));
   jPExecuter.setLayout(fLExecuter);
   jPExecuter.setPreferredSize(new java.awt.Dimension(392, 37));
   jPParam.add(jPParamInfos, BorderLayout.CENTER);

   //Panel contenant les rsultats
   jPResultats.setLayout(bLResultats);
   jPResultats.setBorder(BorderFactory.createEtchedBorder());
   jPResultats.setMaximumSize(new Dimension(0, 0));
   jPResultats.setMinimumSize(new Dimension(0, 0));
   jPResultats.setPreferredSize(new java.awt.Dimension(400, 440));

       //Titre Resultats
   jPResultats.add(jLBResultatsTitre,  BorderLayout.NORTH);
   jLBResultatsTitre.setText("Results");
   jLBResultatsTitre.setHorizontalTextPosition(SwingConstants.CENTER);
   jLBResultatsTitre.setHorizontalAlignment(SwingConstants.CENTER);
   jLBResultatsTitre.setPreferredSize(new java.awt.Dimension(396, 19));
   jLBResultatsTitre.setMinimumSize(new Dimension(290, 20));
   jLBResultatsTitre.setMaximumSize(new Dimension(290, 20));
   jLBResultatsTitre.setBorder(BorderFactory.createRaisedBevelBorder());
   jLBResultatsTitre.setAlignmentY((float) 0.0);
   jLBResultatsTitre.setAlignmentX((float) 0.0);
   jLBResultatsTitre.setFont(new java.awt.Font("Arial", 1, 12));

       //Resultats
   jPResultats.add(jPResultatTotal,  BorderLayout.SOUTH);
   jPResultatTotal.add(jLBResultatTotal, null);
   jPResultatTotal.setLayout(fLResultatTotal);
   fLResultatTotal.setAlignment(FlowLayout.LEFT);

       //Titre
       //Valeur
   jLBResultatTotal.setText("");

       //Liste
   jPResultats.add(jSPListeResultats,  BorderLayout.CENTER);
   jSPListeResultats.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
   jSPListeResultats.setBorder(BorderFactory.createEtchedBorder());
{
	jTAResultats = new JTextArea();
	jSPListeResultats.setViewportView(jTAResultats);
}

 }

 public void executerETL () {
   thread.start ();
 }

 public void run () {
   int i, j;
   long temptotal = 0;
   long msec = 0;
   long sec = 0;
   long min = 0;
   int nbEnrTotal;

   String titreResultat;
   Chronometre chronorequete = new Chronometre();

   // New stats (JD)
   // refresh execution time
   long rsum = 0, rsum2 = 0, rmin = 0, rmax = 0, rsave;
   double rmean, rstddev;
   // workload execution time
   long wsum = 0, wsum2 = 0, wmin = 0, wmax = 0;
   double wmean, wstddev;
   // total execution time
   long tsum = 0, tsum2 = 0, tmin = 0, tmax = 0;
   double tmean, tstddev;

   // New export (JD)
   PrintWriter monFichier;
   String ficname = "output/dweb-results.csv";

   try {

     monFichier = new PrintWriter(new BufferedWriter(new FileWriter(ficname))); // JD

     tempsRequetes.clear();
     jTAResultats.append("---------- COLD RUN ----------\n");
     titreResultat = "Workload #0" ;
     jTAResultats.append(titreResultat + " in process...\n");
     chronorequete.start();
     //  Action

     //  Lancer la charge une fois  froid
 	 lancement_interro();

     chronorequete.stop();
     tempsRequetes.addElement(Long.toString(chronorequete.getMilliSec()));
     jTAResultats.append(titreResultat + ": " + Long.toString(chronorequete.getMilliSec()) + " ms\n");

     // Export (JD)
     monFichier.println("COLD RUN;ms");
     monFichier.println(titreResultat + ";" + Long.toString(chronorequete.getMilliSec()));
     monFichier.println("WARM RUN;ms");

     jTAResultats.append("---------- WARM RUN ----------\n");

     // Calcul du nombre d'enregitrements total dans l'entrepot
     nbEnrTotal = monEntrepotDonnees.nbreEnregistrement(maBaseDonnees.getConnexion());

     for (i=0; i< Integer.parseInt(jLBIterationsRefresh.getText()); i++) {

       // Chargement des nouveaux individus

       titreResultat = "Refresh #" + Integer.toString(i+1) ;
       jTAResultats.append(titreResultat + " in process...\n");
       chronorequete.start();

       lancement_refresh(nbEnrTotal);

       chronorequete.stop();
       tempsRequetes.addElement(Long.toString(chronorequete.getMilliSec()));
       temptotal += chronorequete.getMilliSec();
       jTAResultats.append(titreResultat + ": " + Long.toString(chronorequete.getMilliSec()) + " ms\n");

       // Export (JD)
       monFichier.println(titreResultat + ";" + Long.toString(chronorequete.getMilliSec()));

       // New stats (JD)
       rsum += chronorequete.getMilliSec();
       rsum2 += (chronorequete.getMilliSec() * chronorequete.getMilliSec());
       tsum += chronorequete.getMilliSec();
       tsum2 += (chronorequete.getMilliSec() * chronorequete.getMilliSec());
       rsave = chronorequete.getMilliSec();

       // Execution de la charge

       titreResultat = "Workload #" + Integer.toString(i+1) ;
       jTAResultats.append(titreResultat + " in process...\n");
       chronorequete.start();

       lancement_interro();

       chronorequete.stop();
       tempsRequetes.addElement(Long.toString(chronorequete.getMilliSec()));
       temptotal += chronorequete.getMilliSec();

       jTAResultats.append(titreResultat + ": " + Long.toString(chronorequete.getMilliSec()) + " ms\n");

       // Export (JD)
       monFichier.println(titreResultat + ";" + Long.toString(chronorequete.getMilliSec()));

       if (i < Integer.parseInt(jLBIterationsRefresh.getText())-1) {
         jTAResultats.append("------------------------------\n");
       }

       // New stats (JD)
       wsum += chronorequete.getMilliSec();
       wsum2 += (chronorequete.getMilliSec() * chronorequete.getMilliSec());
       tsum += chronorequete.getMilliSec();
       tsum2 += (chronorequete.getMilliSec() * chronorequete.getMilliSec());
       // Mins & maxs
       if (i >  0) {
         if (rsave < rmin) { rmin = rsave; }
         if (rsave > rmax) { rmax = rsave; }
         if (chronorequete.getMilliSec() < wmin) { wmin = chronorequete.getMilliSec(); }
         if (chronorequete.getMilliSec() > wmax) { wmax = chronorequete.getMilliSec(); }
         if ((rsave + chronorequete.getMilliSec()) < tmin) { tmin = rsave + chronorequete.getMilliSec(); }
         if ((rsave + chronorequete.getMilliSec()) > tmax) { tmax = rsave + chronorequete.getMilliSec(); }
       } else {
         rmin = rsave;
         rmax = rsave;
         wmin = chronorequete.getMilliSec();
         wmax = chronorequete.getMilliSec();
         tmin = rsave + chronorequete.getMilliSec();
         tmax = rsave + chronorequete.getMilliSec();
       }

     }

     // New stats (JD)
     rmean = rsum / Integer.parseInt(jLBIterationsRefresh.getText());
     rstddev = Math.sqrt( (rsum2 / Integer.parseInt(jLBIterationsRefresh.getText())) - (rmean * rmean) );
     jTAResultats.append("------- Refresh results ------\n");
     jTAResultats.append("Total:   " + Long.toString(rsum) + " ms\n");
     jTAResultats.append("Average: " + Double.toString(rmean) + " ms\n");
     jTAResultats.append("Std dev: " + Double.toString(rstddev) + " ms\n");
     jTAResultats.append("Min:     " + Long.toString(rmin) + " ms\n");
     jTAResultats.append("Max:     " + Long.toString(rmax) + " ms\n");
     wmean = wsum / Integer.parseInt(jLBIterationsRefresh.getText());
     wstddev = Math.sqrt( (wsum2 / Integer.parseInt(jLBIterationsRefresh.getText())) - (wmean * wmean) );
     jTAResultats.append("------- Workload results -----\n");
     jTAResultats.append("Total:   " + Long.toString(wsum) + " ms\n");
     jTAResultats.append("Average: " + Double.toString(wmean) + " ms\n");
     jTAResultats.append("Std dev: " + Double.toString(wstddev) + " ms\n");
     jTAResultats.append("Min:     " + Long.toString(wmin) + " ms\n");
     jTAResultats.append("Max:     " + Long.toString(wmax) + " ms\n");
     tmean = tsum / Integer.parseInt(jLBIterationsRefresh.getText());
     tstddev = Math.sqrt( (tsum2 / Integer.parseInt(jLBIterationsRefresh.getText())) - (tmean * tmean) ); // Bug but where?
     jTAResultats.append("------- Global results -------\n");
     jTAResultats.append("Total:   " + Long.toString(tsum) + " ms\n");
     jTAResultats.append("Average: " + Double.toString(tmean) + " ms\n");
     jTAResultats.append("Std dev: " + Double.toString(tstddev) + " ms\n");
     jTAResultats.append("Min:     " + Long.toString(tmin) + " ms\n");
     jTAResultats.append("Max:     " + Long.toString(tmax) + " ms\n");

     msec=temptotal%1000;
     temptotal /= 1000;
     sec=temptotal%60;
     temptotal /= 60;
     min = temptotal;
     jLBResultatTotal.setText("Total execution time: "+Long.toString(min) + "\' " + Long.toString(sec) + "\'\' " + Long.toString(msec));

     // Export (JD)
     monFichier.close();
     JOptionPane.showMessageDialog(null,"Results saved in " + ficname);

/* Old export
     if (JOptionPane.showConfirmDialog(null, "Save the results?", "Execution complete", JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION) {
       PrintWriter monFichier;
       monFichier = new PrintWriter(new BufferedWriter(new FileWriter("dweb-results.csv")));
       for (i=0;i<maChargeRequetes.size();i++) {
         monFichier.println(Integer.toString(i+1) + ";" + tempsRequetes.get(i).toString());
       }
       monFichier.close();
       JOptionPane.showMessageDialog(null,"Results saved");
     } */
   }
   catch (IOException ioe) {
     JOptionPane.showMessageDialog(null,"--> Exception: " + ioe);
   }
 }

 private void lancement_interro(){

		try {
		      Statement statement = maBaseDonnees.getConnexion().createStatement(ResultSet.TYPE_SCROLL_INSENSITIVE, ResultSet.CONCUR_READ_ONLY);
		      ResultSet rs;

		      for (int i=0;i<maChargeRequetes.size();i++){
		    	  // Executer la charge

		    	  rs = statement.executeQuery(maChargeRequetes.get(i).toString());
		    	  rs.close();
		      }
		      statement.close();
		}
		catch (SQLException sqle) {
		      JOptionPane.showMessageDialog(null,"--> Exception : " + sqle);
		}
	}

 private void lancement_refresh(int nbEnrTotal){
	 	int i, j, k;
	 	int nbFaitIns, nbFaitMod, nbDimInsPro=0;
	 	double nbDimIns, nbDimMod;
	 	int nbDimModPro=0;
	 	double nbTotal;
	    int clePrimaire;
	 	String[] message = new String[1];
	 	String cleP, tFait;

	 	// Nombre d'neregistrement  rafraichir
	    nbTotal = nbEnrTotal * Double.parseDouble(this.jLBPercentageRefresh.getText());
	    // Nombre d'insertions
	    nbDimIns = nbTotal * Double.parseDouble(this.jLBDimensionsRefresh.getText()) * Double.parseDouble(this.jLBInsertionRefresh.getText())/monEntrepotDonnees.getNbDimensions();
	    nbFaitIns = (int) Math.ceil(nbTotal * Double.parseDouble(this.jLBFaitsRefresh.getText())* Double.parseDouble(this.jLBInsertionRefresh.getText())/monEntrepotDonnees.getNbTablesFait());

	    // Nombre de modification
	    nbDimMod = nbTotal * Double.parseDouble(this.jLBDimensionsRefresh.getText()) * Double.parseDouble(this.jLBModificationRefresh.getText())/monEntrepotDonnees.getNbDimensions();
	    nbFaitMod = (int) Math.ceil(nbTotal * Double.parseDouble(this.jLBFaitsRefresh.getText())* Double.parseDouble(this.jLBModificationRefresh.getText())/monEntrepotDonnees.getNbTablesFait());

	    //LResultats.addElement("--> param refresh nbEnrtotal "+String.valueOf(nbEnrTotal)+ " nbtotal "+String.valueOf(nbTotal)+" nbDimIns "+ String.valueOf(nbDimIns)+" nbDimMod "+String.valueOf(nbDimMod)+" nbFaitIns "+String.valueOf(nbFaitIns)+" nbFaitMod "+String.valueOf(nbFaitMod));

	    // Insertion et modification des dimensions
	 	rDimension:{
		 	for(i=0;i<monEntrepotDonnees.getNbDimensions();i++){
		 		nbDimInsPro = (int)Math.ceil(nbDimIns/monEntrepotDonnees.getDimensionI(i).getProfondeur());
	 			nbDimModPro = (int)Math.ceil(nbDimMod/monEntrepotDonnees.getDimensionI(i).getProfondeur());

		 		for(j=monEntrepotDonnees.getDimensionI(i).getProfondeur()-1 ; j>=0 ; j--){

		 		    // Insertion dans les dimensions
		 			for(k=0 ; k<nbDimInsPro ; k++){
		 				if(this.threadActif){
		 					this.threadActif &= monEntrepotDonnees.getDimensionI(i).getTableI(j).ajouterEnregistrement(maBaseDonnees.getConnexion(), message);

		 				}
		 				else
		 					break rDimension;
		 			}

		 			// Modification dans les dimensions
		 			for(k=0 ; k<nbDimModPro ; k++){
		 				if(this.threadActif){

		 					 clePrimaire = monEntrepotDonnees.getDimensionI(i).getTableI(j).getEnregistrementAleatoire(maBaseDonnees.getConnexion(), message);
		 					 // Lance la modification
		 					 this.threadActif &= monEntrepotDonnees.getDimensionI(i).getTableI(j).modifierEnregistrement(maBaseDonnees.getConnexion(), clePrimaire, message);
		 				}
		 				else
		 					break rDimension;
		 			}
		 		}
		 	}
	 	}


	    // Insertion et modification dans les tables des faits
	 	rFait:{
	 		for(i=0;i<monEntrepotDonnees.getNbTablesFait();i++){

	 			// Insertion dans les tables des faits
	 			for(j=0 ; j<nbFaitIns ; j++){
	 				if(this.threadActif){
	 					tFait = "fact_table"+Integer.toString(i+1);
	 					this.threadActif &= monEntrepotDonnees.getTableFaitI(i).ajouterFaits(maBaseDonnees.getConnexion(), tFait, message);
	 				}
	 				else
	 					break rFait;
	 			}

	 			// Modification dans les tables des faits
	 			for(j=0 ; j<nbFaitMod ; j++){
	 				if(this.threadActif){
	 					cleP = monEntrepotDonnees.getTableFaitI(i).getClePrimaireAleatoire(maBaseDonnees.getConnexion(), message);
	 					// Lance la modification
	 					this.threadActif &= monEntrepotDonnees.getTableFaitI(i).modifierEnregistrement(maBaseDonnees.getConnexion(), cleP, message);
	 				}
	 				else
	 					break rFait;
	 			}
	 		}
		 }
}

 public void setParametres (BaseDonnees pBaseDonnees, EntrepotDonnees pEntrepotDonnees, File pFichierRequetes, double pourcentage, double pDimensions, double pFaits, int iterations, double pModification, double pInsertion) {
   this.maBaseDonnees = pBaseDonnees;
   this.monFichierRequetes = pFichierRequetes;
   this.monEntrepotDonnees = pEntrepotDonnees;
   maChargeRequetes.clear();

   try {
     String lignetitre;
     String lignerequete;

     BufferedReader reader = new BufferedReader(new FileReader(this.monFichierRequetes));

     lignetitre = reader.readLine();
     lignerequete = reader.readLine();

     while (lignetitre != null && lignerequete != null) {

       maChargeRequetes.addElement(lignerequete);

       lignetitre = reader.readLine();
       lignerequete = reader.readLine();
     }
     reader.close();

     this.jLBIterationsRefresh.setText(Integer.toString(iterations));
     this.jLBPercentageRefresh.setText(Double.toString(pourcentage));
     this.jLBFaitsRefresh.setText(Double.toString(pFaits));
     this.jLBDimensionsRefresh.setText(Double.toString(pDimensions));
     this.jLBModificationRefresh.setText(Double.toString(pModification));
     this.jLBInsertionRefresh.setText(Double.toString(pInsertion));
   }
   catch (Exception exceptfichier){
	   JOptionPane.showMessageDialog(null,"Workload is empty!");
   }
 }

 void jBTExecuter_actionPerformed(ActionEvent e) {
   if (!maChargeRequetes.isEmpty())
     this.executerETL();
   else
     JOptionPane.showMessageDialog(null,"Workload is empty!");
 }

}

class DLGRefreshResult_jBTExecuter_actionAdapter implements java.awt.event.ActionListener {
 DLGRefreshResult adaptee;

 DLGRefreshResult_jBTExecuter_actionAdapter(DLGRefreshResult adaptee) {
   this.adaptee = adaptee;
 }
 public void actionPerformed(ActionEvent e) {
   adaptee.jBTExecuter_actionPerformed(e);
 }

}
