////////////////////////////////////////////////////////////////////////////////
// TITRE : DWEB - DATAWAREHOUSE ENGINEERING BENCHMARK - VERSION 0.4           //
//----------------------------------------------------------------------------//
// AUTEURS : JOUBERT Bruno / GUESMIA Sofiane                                  //
//           UNIVERSITE LYON 2 - MASTER IIDEE                                 //
//----------------------------------------------------------------------------//
// English translation by J. Darmont                                          //
// - Step 1: Interface (DONE)                                                 //
// - Step 2: Code/comments (TO DO)                                            //
//----------------------------------------------------------------------------//
// ENCADRES PAR : DARMONT Jrome                                              //
//                UNIVERSITE LYON 2 - LABORATOIRE ERIC                        //
//                http://eric.univ-lyon2.fr - - jerome.darmont@univ-lyon2.fr  //
//----------------------------------------------------------------------------//
// DESCRIPTION : Banc d'essai dcisionnel                                     //
//----------------------------------------------------------------------------//
// Cette application a pour but de permettre la cration d'un entrept de     //
// donnes synthtique et des charges associes.                              //
////////////////////////////////////////////////////////////////////////////////

package dweb03;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

import dweb03client.Chronometre;

////////////////////////////////////////////////////////////////////////////////
// Cette classe est une fentre qui effectue le remplissage de l'entrept     //
// Afin de ne pas bloquer l'application on effectue le remplissage par        //
// l'intermdiaire d'un thread qui traite les oprations en arrire plan      //
// et met  jour l'affichage dans la boite de dialogue                        //
////////////////////////////////////////////////////////////////////////////////

public class DLGRemplirEntrepot extends JDialog implements Runnable {
////////////////////////////////////////////////////////////////////////////////
  BaseDonnees maBaseDonnees;
  EntrepotDonnees monEntrepot;  //  @jve:decl-index=0:
  Thread thread = new Thread (this);
  boolean threadActif = true;
////////////////////////////////////////////////////////////////////////////////
  JPanel jPProgression = new JPanel();
  JPanel jPInfosEntrepot = new JPanel();
  JPanel jPProgressionGeneral = new JPanel();
  JPanel jPProgressionDetail = new JPanel();
  JPanel jPBoutons = new JPanel();

  FlowLayout fLInfosEntrepot = new FlowLayout();
  FlowLayout fLProgressionGeneral = new FlowLayout();
  FlowLayout fLProgressionDetail = new FlowLayout();
  FlowLayout fLBoutons = new FlowLayout();

  JLabel jLBInfosEntrepot = new JLabel();
  JLabel jLBProgressionGeneral = new JLabel();
  JLabel jLBProgressionDetail = new JLabel();

  JProgressBar jPBProgressionGeneral = new JProgressBar();
  JProgressBar jPBProgressionDetail = new JProgressBar();

  JButton jBTCommencer = new JButton();
  JButton jBTAnnuler = new JButton();

  public DLGRemplirEntrepot (Frame frame, String title, boolean modal) {
    super(frame, title, modal);
    try {
      jbInit();
      pack();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  public DLGRemplirEntrepot() {
    this(null, "", false);
  }

  private void jbInit() throws Exception {
    jPProgression.setLayout(null);
    jPBProgressionGeneral.setMaximumSize(new Dimension(0, 20));
    jPBProgressionGeneral.setMinimumSize(new Dimension(0, 20));
    jPBProgressionGeneral.setPreferredSize(new Dimension(210, 20));
    jPBProgressionGeneral.setValue(0);
    jPBProgressionGeneral.setStringPainted(true);
    jPProgressionGeneral.setMaximumSize(new Dimension(0, 20));
    jPProgressionGeneral.setMinimumSize(new Dimension(0, 20));
    jPProgressionGeneral.setPreferredSize(new Dimension(0, 20));
    jPProgressionGeneral.setBounds(new Rectangle(20, 42, 360, 20));
    jPProgressionGeneral.setLayout(fLProgressionGeneral);
    fLProgressionGeneral.setAlignment(FlowLayout.LEFT);
    fLProgressionGeneral.setHgap(0);
    fLProgressionGeneral.setVgap(0);
    jLBProgressionGeneral.setMaximumSize(new Dimension(150, 20));
    jLBProgressionGeneral.setMinimumSize(new Dimension(150, 20));
    jLBProgressionGeneral.setPreferredSize(new Dimension(150, 20));
    jLBProgressionGeneral.setText("");
    this.setDefaultCloseOperation(javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);
    this.setResizable(false);
    this.setTitle("Please wait...");
    jPProgression.setMaximumSize(new Dimension(400, 140));
    jPProgression.setMinimumSize(new Dimension(400, 140));
    jPProgression.setPreferredSize(new Dimension(400, 140));
    jPBoutons.setMaximumSize(new Dimension(0, 25));
    jPBoutons.setMinimumSize(new Dimension(0, 25));
    jPBoutons.setPreferredSize(new Dimension(0, 25));
    jPBoutons.setBounds(new Rectangle(20, 102, 360, 25));
    jPBoutons.setLayout(fLBoutons);
    jBTAnnuler.setMaximumSize(new Dimension(90, 25));
    jBTAnnuler.setMinimumSize(new Dimension(90, 25));
    jBTAnnuler.setPreferredSize(new Dimension(90, 25));
    jBTAnnuler.setText("Cancel");
    jBTAnnuler.addActionListener(new DLGRemplirEntrepot_jBTAnnuler_actionAdapter(this));
    fLBoutons.setHgap(20);
    fLBoutons.setVgap(0);
    jPProgressionDetail.setLayout(fLProgressionDetail);
    jPProgressionDetail.setPreferredSize(new Dimension(0, 20));
    jPProgressionDetail.setBounds(new Rectangle(20, 72, 360, 20));
    jPProgressionDetail.setMinimumSize(new Dimension(0, 20));
    jPProgressionDetail.setMaximumSize(new Dimension(0, 20));
    jPBProgressionDetail.setMaximumSize(new Dimension(0, 20));
    jPBProgressionDetail.setMinimumSize(new Dimension(0, 20));
    jPBProgressionDetail.setPreferredSize(new Dimension(210, 20));
    jPBProgressionDetail.setValue(0);
    jPBProgressionDetail.setStringPainted(true);
    jLBProgressionDetail.setMaximumSize(new Dimension(150, 20));
    jLBProgressionDetail.setMinimumSize(new Dimension(150, 20));
    jLBProgressionDetail.setPreferredSize(new Dimension(150, 20));
    jLBProgressionDetail.setText("");
    fLProgressionDetail.setAlignment(FlowLayout.LEFT);
    fLProgressionDetail.setHgap(0);
    fLProgressionDetail.setVgap(0);
    jBTCommencer.setMaximumSize(new Dimension(90, 25));
    jBTCommencer.setMinimumSize(new Dimension(90, 25));
    jBTCommencer.setPreferredSize(new Dimension(90, 25));
    jBTCommencer.setText("Start");
    jBTCommencer.addActionListener(new DLGRemplirEntrepot_jBTCommencer_actionAdapter(this));
    jBTCommencer.addActionListener(new java.awt.event.ActionListener() {
    	public void actionPerformed(java.awt.event.ActionEvent e) {
    		System.out.println("actionPerformed()"); // TODO Auto-generated Event stub actionPerformed()
    	}
    });
    jPInfosEntrepot.setBorder(null);
    jPInfosEntrepot.setMaximumSize(new Dimension(0, 20));
    jPInfosEntrepot.setMinimumSize(new Dimension(0, 20));
    jPInfosEntrepot.setPreferredSize(new Dimension(0, 20));
    jPInfosEntrepot.setBounds(new Rectangle(20, 12, 360, 20));
    jPInfosEntrepot.setLayout(fLInfosEntrepot);
    fLInfosEntrepot.setAlignment(FlowLayout.LEFT);
    fLInfosEntrepot.setHgap(0);
    fLInfosEntrepot.setVgap(0);
    jLBInfosEntrepot.setMaximumSize(new Dimension(360, 20));
    jLBInfosEntrepot.setMinimumSize(new Dimension(360, 20));
    jLBInfosEntrepot.setPreferredSize(new Dimension(360, 20));
    jLBInfosEntrepot.setHorizontalAlignment(SwingConstants.CENTER);
    jLBInfosEntrepot.setText("Click \"Start\" to load data warehouse");
    jPProgressionGeneral.add(jLBProgressionGeneral, null);
    jPProgressionGeneral.add(jPBProgressionGeneral, null);
    jPProgression.add(jPInfosEntrepot, null);
    jPProgression.add(jPProgressionGeneral, null);
    jPProgression.add(jPProgressionDetail, null);
    jPProgressionDetail.add(jLBProgressionDetail, null);
    jPProgressionDetail.add(jPBProgressionDetail, null);
    this.getContentPane().add(jPProgression,  BorderLayout.CENTER);
    jPProgression.add(jPBoutons, null);
    jPBoutons.add(jBTCommencer, null);
    jPBoutons.add(jBTAnnuler, null);
    jPInfosEntrepot.add(jLBInfosEntrepot, null);
  }

  public void lanceRemplirEntrepot () {
    thread.start ();
  }

  public void run () {
    String[] message = new String[1];
    int i, j, k;
    int nbEnr;
    Chronometre chronoload = new Chronometre();

    // Top chrono (JD)
    chronoload.start();

    // Remplissage des dimensions

    this.jLBInfosEntrepot.setText("Loading dimensions...");
    this.jPBProgressionGeneral.setMinimum(0);
    this.jPBProgressionGeneral.setMaximum(monEntrepot.getNbDimensions());

    rDimensions : {
      // Boucle sur les dimensions de l'entrepot
      for (i=0; i<monEntrepot.getNbDimensions(); i++) {
        this.jPBProgressionGeneral.setValue(i);
        this.jPBProgressionGeneral.repaint();
        this.jLBProgressionGeneral.setText(Integer.toString(monEntrepot.getNbDimensions()) + " dimension(s)...");
        this.jLBProgressionGeneral.repaint();

        nbEnr = monEntrepot.getDimensionI(i).getNbEnregistrementsHautNiveau();

        // Boucle sur les niveaux de la dimension i
        // On remplit d'abord le plus haut niveau
        for (j=monEntrepot.getDimensionI(i).getProfondeur()-1; j >=0; j--) {
          this.jPBProgressionDetail.setMinimum(0);
          this.jPBProgressionDetail.setMaximum(nbEnr);
          this.jLBProgressionDetail.setText(monEntrepot.getDimensionI(i).getTableI(j).getNom() + " in process...");
          this.jLBProgressionGeneral.repaint();

          // Boucle sur le nombre d'enregistrements  insrer
          for (k=0; k<nbEnr; k++) {
            this.jPBProgressionDetail.setValue(k);
            this.jPBProgressionDetail.repaint();
            if (this.threadActif)
              this.threadActif &= monEntrepot.getDimensionI(i).getTableI(j).ajouterEnregistrement(maBaseDonnees.getConnexion(), message);
            else
              break rDimensions;
          }
          nbEnr *= monEntrepot.getDimensionI(i).getFacteurEchelle();
        }
      }
    }

    // Remplissage des tables de faits
    // Se fait par l'intermdiaire d'une fonction de la classe TableFait

    this.jLBInfosEntrepot.setText("Loading fact tables...");
    this.jPBProgressionGeneral.setMinimum(0);
    this.jPBProgressionGeneral.setMaximum(monEntrepot.getNbTablesFait());
    this.jLBProgressionGeneral.setText(Integer.toString(monEntrepot.getNbTablesFait()) + " fact table(s)...");
    this.jLBProgressionGeneral.repaint();

    rTablesFaits : {
      // On ne boucle ici que sur le nombre de tables de faits
      for (i=0; i<monEntrepot.getNbTablesFait(); i++) {
        this.jPBProgressionGeneral.setValue(i);
        this.jPBProgressionGeneral.repaint();

        this.jLBProgressionDetail.setText(monEntrepot.getTableFaitI(i).getNom() + " in process...");
        this.jLBProgressionGeneral.repaint();

        if (this.threadActif)
          this.threadActif &= monEntrepot.getTableFaitI(i).remplirTable(maBaseDonnees.getConnexion(), this.jPBProgressionDetail, message);
        else
          break rTablesFaits;
      }
    }

    // Top chrono (JD) + display
    chronoload.stop();
    JOptionPane.showMessageDialog(null, "Load test complete\n\nLoading time: " + Long.toString(chronoload.getMilliSec()) + " ms");

    // Si tout s'est bien droul on masque la fentre sinon on la dtruit
    if (this.threadActif)
      this.hide();
    else
      this.dispose();
  }

  public void setParametres (BaseDonnees pBaseDonnees, EntrepotDonnees pEntrepotDonnees) {
    this.maBaseDonnees = pBaseDonnees;
    this.monEntrepot = pEntrepotDonnees;
  }

  void jBTCommencer_actionPerformed(ActionEvent e) {
    // affichage d'une boite de dialogue contenant les infos sur l'entrept pour confirmation
    if (JOptionPane.showConfirmDialog (null, monEntrepot.getInfos(), "Start loading?", JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION) {
      this.jBTCommencer.setEnabled(false);
      this.lanceRemplirEntrepot();
    }
  }

  void jBTAnnuler_actionPerformed(ActionEvent e) {
    this.threadActif = false;
    this.dispose();
  }
}

class DLGRemplirEntrepot_jBTCommencer_actionAdapter implements java.awt.event.ActionListener {
  DLGRemplirEntrepot adaptee;

  DLGRemplirEntrepot_jBTCommencer_actionAdapter(DLGRemplirEntrepot adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jBTCommencer_actionPerformed(e);
  }
}

class DLGRemplirEntrepot_jBTAnnuler_actionAdapter implements java.awt.event.ActionListener {
  DLGRemplirEntrepot adaptee;

  DLGRemplirEntrepot_jBTAnnuler_actionAdapter(DLGRemplirEntrepot adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jBTAnnuler_actionPerformed(e);
  }
}
