////////////////////////////////////////////////////////////////////////////////
// TITRE : DWEB - DATAWAREHOUSE ENGINEERING BENCHMARK - VERSION 0.4           //
//----------------------------------------------------------------------------//
// AUTEURS : JOUBERT Bruno / GUESMIA Sofiane                                  //
//           UNIVERSITE LYON 2 - MASTER IIDEE                                 //
//----------------------------------------------------------------------------//
// English translation by J. Darmont                                          //
// - Step 1: Interface (DONE)                                                 //
// - Step 2: Code/comments (TO DO)                                            //
//----------------------------------------------------------------------------//
// ENCADRES PAR : DARMONT Jrome                                              //
//                UNIVERSITE LYON 2 - LABORATOIRE ERIC                        //
//                http://eric.univ-lyon2.fr -- jerome.darmont@univ-lyon2.fr   //
//----------------------------------------------------------------------------//
// DESCRIPTION : Banc d'essai dcisionnel                                     //
//----------------------------------------------------------------------------//
// Cette application a pour but de permettre la cration d'un entrept de     //
// donnes synthtique et des charges associes.                              //
////////////////////////////////////////////////////////////////////////////////

package dweb03;

import java.awt.*;
import java.awt.event.*;
import java.io.File;

import javax.swing.*;
import javax.swing.border.Border;

class FRFenetrePrincipale extends JFrame {
  // La base de donnes est dfinie comme un attribut de la fentre
  BaseDonnees maBaseDonnees = new BaseDonnees();  //  @jve:decl-index=0:
  EntrepotDonnees monEntrepot;

  // Compossants Graphiques de la fentre
  JPanel jPContentPanel;
    BorderLayout bLContentPanel = new BorderLayout();
    JPanel jPConnexionBD = new JPanel();
      BorderLayout bLConnexionBD = new BorderLayout();
      JLabel jLBConnexionBDTitre = new JLabel();

      JPanel jPConnexionLabels = new JPanel();
        JLabel jLBHote = new JLabel();
        JLabel jLBBase = new JLabel();
        JLabel jLBUser = new JLabel();
        JLabel jLBPassword = new JLabel();

      JPanel jPConnexionTextFields = new JPanel();
        JTextField jTFHote = new JTextField();
        JTextField jTFNomBase = new JTextField();
        JTextField jTFUser = new JTextField();
        JPasswordField jPFPassword = new JPasswordField();

      JPanel jPConnexionBoutons = new JPanel();
        JButton jBTConnexion = new JButton();
        JButton jBTDeconnexion = new JButton();

        JPanel jPStatutConnexion = new JPanel();
          BorderLayout bLStatutConnexion = new BorderLayout();
          JLabel jLBStatutConnexionTitre = new JLabel();
          JLabel jLBStatutConnexion = new JLabel();

    JPanel jPActions = new JPanel();
      BorderLayout bLActions = new BorderLayout();
      JLabel jLBActionsTitre = new JLabel();


      JPanel jPActionsBoutons = new JPanel();
        BorderLayout bLActionsBoutons = new BorderLayout();
          JPanel jPCreerEntrepot = new JPanel();
            ButtonGroup bGChoixNiveau = new ButtonGroup();
              JRadioButton jRBParamBN = new JRadioButton();
              JRadioButton jRBParamHN = new JRadioButton();
            JButton jBTCreerDW = new JButton();
          JPanel jPActionsEntrepot = new JPanel();
            FlowLayout fLActionsEntrepot = new FlowLayout();
            JButton jBTRemplirDW = new JButton();
            JButton jBTInfosDW = new JButton();
            JButton jBTResetDW = new JButton();

          	JPanel jPRequetes = new JPanel();
          		BorderLayout bLRequetes = new BorderLayout();
          		JButton jBTGenRequetes = new JButton();
		        JButton jBTStartRefresh = new JButton();

    JPanel jPInfos = new JPanel();
      BorderLayout bLInfos = new BorderLayout();
      JLabel jLBInfosTitre = new JLabel();
      JScrollPane jSPMessages = new JScrollPane();
        JTextArea jTAMessages = new JTextArea();


  //Construction de la fentre
  public FRFenetrePrincipale() {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  //Initialisation de la fentre
  private void jbInit() throws Exception  {

    jPContentPanel = (JPanel) this.getContentPane();
    jPContentPanel.setLayout(bLContentPanel);
    this.setDefaultCloseOperation(EXIT_ON_CLOSE);
    this.setLocale(java.util.Locale.getDefault());
    this.setResizable(false);
    this.setSize(320, 530);
    this.setTitle("DWEB 0.4");

    jPContentPanel.setEnabled(true);
    jPContentPanel.setFont(new java.awt.Font("Arial", 0, 11));
    jPContentPanel.setForeground(Color.black);
    jPContentPanel.setAlignmentX((float) 0.5);
    jPContentPanel.setBorder(null);
    jPContentPanel.setMaximumSize(new Dimension(300, 470));
    jPContentPanel.setMinimumSize(new Dimension(300, 470));
    jPContentPanel.setPreferredSize(new Dimension(300, 470));
    jPContentPanel.setRequestFocusEnabled(true);
    jPContentPanel.setVerifyInputWhenFocusTarget(true);
    jPConnexionBD.setLayout(bLConnexionBD);
    jPConnexionBD.setBorder(BorderFactory.createEtchedBorder());
    jPConnexionBD.setMaximumSize(new Dimension(0, 130));
    jPConnexionBD.setMinimumSize(new Dimension(0, 130));
    jPConnexionBD.setPreferredSize(new Dimension(0, 130));
    jLBConnexionBDTitre.setFont(new java.awt.Font("Arial", 1, 12));
    jLBConnexionBDTitre.setAlignmentX((float) 0.0);
    jLBConnexionBDTitre.setAlignmentY((float) 0.0);
    jLBConnexionBDTitre.setBorder(BorderFactory.createRaisedBevelBorder());
    jLBConnexionBDTitre.setMaximumSize(new Dimension(290, 20));
    jLBConnexionBDTitre.setMinimumSize(new Dimension(290, 20));
    jLBConnexionBDTitre.setPreferredSize(new Dimension(290, 20));
    jLBConnexionBDTitre.setHorizontalAlignment(SwingConstants.CENTER);
    jLBConnexionBDTitre.setHorizontalTextPosition(SwingConstants.CENTER);
    jLBConnexionBDTitre.setText("Database connection");
    jLBBase.setFont(new java.awt.Font("Arial", 0, 11));
    jLBBase.setMaximumSize(new Dimension(85, 20));
    jLBBase.setMinimumSize(new Dimension(85, 20));
    jLBBase.setPreferredSize(new Dimension(74, 20));
    jLBBase.setText("Database name:");
    jLBBase.setBounds(new Rectangle(5, 30, 85, 20));
    jLBUser.setFont(new java.awt.Font("Arial", 0, 11));
    jLBUser.setMaximumSize(new Dimension(85, 20));
    jLBUser.setMinimumSize(new Dimension(85, 20));
    jLBUser.setPreferredSize(new Dimension(78, 20));
    jLBUser.setText("User name:");
    jLBUser.setBounds(new Rectangle(5, 55, 85, 20));
    jLBPassword.setFont(new java.awt.Font("Arial", 0, 11));
    jLBPassword.setMaximumSize(new Dimension(85, 20));
    jLBPassword.setMinimumSize(new Dimension(85, 20));
    jLBPassword.setPreferredSize(new Dimension(85, 20));
    jLBPassword.setText("Password:");
    jLBPassword.setBounds(new Rectangle(5, 80, 85, 20));
    jTFUser.setBorder(BorderFactory.createLineBorder(Color.black));
    jTFUser.setMinimumSize(new Dimension(85, 20));
    jTFUser.setPreferredSize(new Dimension(85, 20));
    jTFUser.setCaretPosition(0);
    jTFUser.setMargin(new Insets(1, 5, 2, 4));
    jTFUser.setText("");
    jTFUser.setHorizontalAlignment(SwingConstants.CENTER);
    jTFUser.setBounds(new Rectangle(5, 55, 105, 20));

    jBTConnexion.setBounds(new Rectangle(5, 5, 96, 20));
    jBTConnexion.setFont(new java.awt.Font("Arial", 0, 11));
    jBTConnexion.setMaximumSize(new Dimension(96, 20));
    jBTConnexion.setMinimumSize(new Dimension(96, 20));
    jBTConnexion.setPreferredSize(new Dimension(96, 20));
    jBTConnexion.setHorizontalTextPosition(SwingConstants.CENTER);
    jBTConnexion.setText("Log in");
    jBTConnexion.addActionListener(new FRFenetrePrincipale_jBTConnexion_actionAdapter(this));

    jBTDeconnexion.addActionListener(new FRFenetrePrincipale_jBTDeconnexion_actionAdapter(this));
    jBTDeconnexion.setText("Log out");
    jBTDeconnexion.setHorizontalTextPosition(SwingConstants.CENTER);
    jBTDeconnexion.setPreferredSize(new Dimension(90, 20));
    jBTDeconnexion.setMinimumSize(new Dimension(96, 20));
    jBTDeconnexion.setMaximumSize(new Dimension(96, 20));
    jBTDeconnexion.setBounds(new Rectangle(5, 30, 96, 20));
    jBTDeconnexion.setEnabled(false);
    jBTDeconnexion.setFont(new java.awt.Font("Arial", 0, 11));

    jPFPassword.setBorder(BorderFactory.createLineBorder(Color.black));
    jPFPassword.setMinimumSize(new Dimension(85, 20));
    jPFPassword.setPreferredSize(new Dimension(85, 20));
    jPFPassword.setCaretPosition(0);
    jPFPassword.setMargin(new Insets(1, 5, 2, 4));
    jPFPassword.setText("");
    jPFPassword.setHorizontalAlignment(SwingConstants.CENTER);
    jPFPassword.setEchoChar('*');
    jPFPassword.setBounds(new Rectangle(5, 80, 105, 20));
    jTFNomBase.setBorder(BorderFactory.createLineBorder(Color.black));
    jTFNomBase.setMinimumSize(new Dimension(85, 20));
    jTFNomBase.setPreferredSize(new Dimension(85, 20));
    jTFNomBase.setMargin(new Insets(1, 5, 2, 4));
    jTFNomBase.setText("");
    jTFNomBase.setHorizontalAlignment(SwingConstants.CENTER);
    jTFNomBase.setBounds(new Rectangle(5, 30, 105, 20));
    jPStatutConnexion.setBorder(BorderFactory.createEtchedBorder());
    jPStatutConnexion.setMinimumSize(new Dimension(96, 45));
    jPStatutConnexion.setPreferredSize(new Dimension(85, 45));
    jPStatutConnexion.setBounds(new Rectangle(5, 55, 96, 45));
    jPStatutConnexion.setLayout(bLStatutConnexion);
    jLBStatutConnexionTitre.setFont(new java.awt.Font("Arial", 1, 11));
    jLBStatutConnexionTitre.setBorder(BorderFactory.createEtchedBorder());
    jLBStatutConnexionTitre.setMaximumSize(new Dimension(90, 20));
    jLBStatutConnexionTitre.setMinimumSize(new Dimension(90, 20));
    jLBStatutConnexionTitre.setPreferredSize(new Dimension(90, 20));
    jLBStatutConnexionTitre.setHorizontalAlignment(SwingConstants.CENTER);
    jLBStatutConnexionTitre.setHorizontalTextPosition(SwingConstants.CENTER);
    jLBStatutConnexionTitre.setText("Status");
    jLBStatutConnexion.setFont(new java.awt.Font("Arial", 1, 11));
    jLBStatutConnexion.setForeground(Color.red);
    jLBStatutConnexion.setMaximumSize(new Dimension(90, 20));
    jLBStatutConnexion.setMinimumSize(new Dimension(90, 20));
    jLBStatutConnexion.setPreferredSize(new Dimension(90, 20));
    jLBStatutConnexion.setHorizontalAlignment(SwingConstants.CENTER);
    jLBStatutConnexion.setHorizontalTextPosition(SwingConstants.LEFT);
    jLBStatutConnexion.setText("Not connected");
    jLBHote.setText("Server address:");
    jLBHote.setBounds(new Rectangle(5, 5, 85, 20));
    jLBHote.setFont(new java.awt.Font("Arial", 0, 11));
    jLBHote.setMaximumSize(new Dimension(85, 20));
    jLBHote.setMinimumSize(new Dimension(85, 20));
    jLBHote.setPreferredSize(new Dimension(85, 20));
    jTFHote.setText("");
    jTFHote.setHorizontalAlignment(SwingConstants.CENTER);
    jTFHote.setScrollOffset(0);
    jTFHote.setBounds(new Rectangle(5, 5, 105, 20));
    jTFHote.setPreferredSize(new Dimension(85, 20));
    jTFHote.setMargin(new Insets(1, 5, 2, 4));
    jTFHote.setMinimumSize(new Dimension(85, 20));
    jTFHote.setAlignmentX((float) 1.0);
    jTFHote.setBorder(BorderFactory.createLineBorder(Color.black));

    jPConnexionLabels.setLayout(null);
    jPConnexionTextFields.setLayout(null);
    jPConnexionBoutons.setLayout(null);
    jPConnexionTextFields.setMaximumSize(new Dimension(95, 105));
    jPConnexionTextFields.setMinimumSize(new Dimension(95, 105));
    jPConnexionTextFields.setPreferredSize(new Dimension(95, 105));
    jPConnexionBoutons.setMaximumSize(new Dimension(105, 105));
    jPConnexionBoutons.setMinimumSize(new Dimension(105, 105));
    jPConnexionBoutons.setPreferredSize(new Dimension(105, 105));

    jBTDeconnexion.setFont(new java.awt.Font("Arial", 0, 11));

    bLContentPanel.setHgap(0);
    bLContentPanel.setVgap(0);
    jPActions.setLayout(bLActions);
    jPInfos.setBorder(BorderFactory.createEtchedBorder());
    jPInfos.setMaximumSize(new Dimension(0, 130));
    jPInfos.setMinimumSize(new Dimension(0, 130));
    jPInfos.setPreferredSize(new Dimension(0, 130));
    jPInfos.setLayout(bLInfos);
    jPActions.setEnabled(false);
    jPActions.setMaximumSize(new Dimension(0, 300));
    jPActions.setMinimumSize(new Dimension(0, 300));
    jPActions.setPreferredSize(new Dimension(0, 300));
    jLBActionsTitre.setText("Action");
    jLBActionsTitre.setHorizontalTextPosition(SwingConstants.CENTER);
    jLBActionsTitre.setHorizontalAlignment(SwingConstants.CENTER);
    jLBActionsTitre.setPreferredSize(new Dimension(290, 20));
    jLBActionsTitre.setMinimumSize(new Dimension(290, 20));
    jLBActionsTitre.setMaximumSize(new Dimension(290, 20));
    jLBActionsTitre.setBorder(BorderFactory.createRaisedBevelBorder());
    jLBActionsTitre.setAlignmentY((float) 0.0);
    jLBActionsTitre.setAlignmentX((float) 0.0);
    jLBActionsTitre.setFont(new java.awt.Font("Arial", 1, 12));
    jLBInfosTitre.setText("Information");
    jLBInfosTitre.setHorizontalTextPosition(SwingConstants.CENTER);
    jLBInfosTitre.setHorizontalAlignment(SwingConstants.CENTER);
    jLBInfosTitre.setPreferredSize(new Dimension(0, 20));
    jLBInfosTitre.setMinimumSize(new Dimension(0, 20));
    jLBInfosTitre.setMaximumSize(new Dimension(0, 20));
    jLBInfosTitre.setBorder(BorderFactory.createRaisedBevelBorder());
    jLBInfosTitre.setAlignmentY((float) 0.0);
    jLBInfosTitre.setAlignmentX((float) 0.0);
    jLBInfosTitre.setFont(new java.awt.Font("Arial", 1, 12));
    jSPMessages.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
    jSPMessages.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
    jSPMessages.setBorder(null);
    jSPMessages.setMaximumSize(new Dimension(0, 110));
    jSPMessages.setMinimumSize(new Dimension(0, 110));
    jSPMessages.setPreferredSize(new Dimension(0, 110));
    jTAMessages.setBorder(null);
    jTAMessages.setEditable(false);
    jPActionsBoutons.setLayout(bLActionsBoutons);
    jPActionsBoutons.setFont(new java.awt.Font("MS Sans Serif", 0, 11));
    jRBParamBN.setBorder(null);
    jRBParamBN.setMaximumSize(new Dimension(150, 25));
    jRBParamBN.setMinimumSize(new Dimension(150, 25));
    jRBParamBN.setPreferredSize(new Dimension(150, 25));
    jRBParamBN.setText("Low-level parameters");
    jRBParamBN.setBounds(new Rectangle(18, 32, 150, 25));
    jRBParamHN.setBorder(null);
    jRBParamHN.setMaximumSize(new Dimension(150, 25));
    jRBParamHN.setMinimumSize(new Dimension(150, 25));
    jRBParamHN.setPreferredSize(new Dimension(150, 25));
    jRBParamHN.setBorderPainted(false);
    jRBParamHN.setHorizontalAlignment(SwingConstants.LEADING);
    jRBParamHN.setHorizontalTextPosition(SwingConstants.TRAILING);
    jRBParamHN.setSelected(true);
    jRBParamHN.setText("High-level parameters");
    jRBParamHN.setBounds(new Rectangle(18, 2, 150, 25));
    jBTCreerDW.setBounds(new Rectangle(176, 17, 120, 25));
    jBTCreerDW.setEnabled(false);
    jBTCreerDW.setMaximumSize(new Dimension(100, 25));
    jBTCreerDW.setMinimumSize(new Dimension(100, 25));
    jBTCreerDW.setPreferredSize(new Dimension(100, 25));
    jBTCreerDW.setText("Generate DW");
    jBTCreerDW.addActionListener(new FRFenetrePrincipale_jBTCreerDW_actionAdapter(this));
    jPCreerEntrepot.setBorder(BorderFactory.createEtchedBorder());
    jPCreerEntrepot.setMaximumSize(new Dimension(0, 60));
    jPCreerEntrepot.setMinimumSize(new Dimension(0, 60));
    jPCreerEntrepot.setPreferredSize(new Dimension(0, 60));
    jPCreerEntrepot.setLayout(null);
    jPActionsEntrepot.setLayout(fLActionsEntrepot);
    jPActionsEntrepot.setBorder(BorderFactory.createEtchedBorder());
    jPActionsEntrepot.setMaximumSize(new Dimension(0, 60));
    jPActionsEntrepot.setMinimumSize(new Dimension(0, 60));
    jPActionsEntrepot.setPreferredSize(new java.awt.Dimension(312, 61));
    jPRequetes.setBorder(BorderFactory.createEtchedBorder());
    jPRequetes.setMaximumSize(new Dimension(0, 120));
    jPRequetes.setMinimumSize(new Dimension(0, 120));
    jPRequetes.setPreferredSize(new java.awt.Dimension(312, 87));
    jPRequetes.setLayout(bLRequetes);
    jBTRemplirDW.setEnabled(false);
    jBTRemplirDW.setMaximumSize(new Dimension(90, 25));
    jBTRemplirDW.setMinimumSize(new Dimension(90, 25));
    jBTRemplirDW.setPreferredSize(new Dimension(90, 25));
    jBTRemplirDW.setText("Load DW");
    jBTRemplirDW.addActionListener(new FRFenetrePrincipale_jBTRemplirDW_actionAdapter(this));
    jBTInfosDW.setEnabled(false);
    jBTInfosDW.setMaximumSize(new Dimension(90, 25));
    jBTInfosDW.setMinimumSize(new Dimension(90, 25));
    jBTInfosDW.setPreferredSize(new Dimension(90, 25));
    jBTInfosDW.setText("Info DW");
    jBTInfosDW.addActionListener(new FRFenetrePrincipale_jBTInfosDW_actionAdapter(this));
    jBTResetDW.setEnabled(false);
    jBTResetDW.setMaximumSize(new Dimension(90, 25));
    jBTResetDW.setMinimumSize(new Dimension(90, 25));
    jBTResetDW.setPreferredSize(new Dimension(90, 25));
    jBTResetDW.setText("Reset DW");
    jBTResetDW.addActionListener(new FRFenetrePrincipale_jBTResetDW_actionAdapter(this));
    fLActionsEntrepot.setHgap(5);
    fLActionsEntrepot.setVgap(15);
    bLRequetes.setHgap(0);
    jBTGenRequetes.setEnabled(false);
    jBTGenRequetes.setMaximumSize(new Dimension(90, 25));
    jBTGenRequetes.setMinimumSize(new Dimension(90, 25));
    jBTGenRequetes.setPreferredSize(new java.awt.Dimension(308, 31));
    jBTGenRequetes.setText("Generate workload");
    jBTGenRequetes.addActionListener(new FRFenetrePrincipale_jBTGenRequetes_actionAdapter(this));
    jBTStartRefresh.setEnabled(false);
    jBTStartRefresh.setMaximumSize(new Dimension(90, 25));
    jBTStartRefresh.setMinimumSize(new Dimension(90, 25));
    jBTStartRefresh.setPreferredSize(new java.awt.Dimension(308, 30));
    jBTStartRefresh.setText("Start performance test");
    jBTStartRefresh.addActionListener(new FRFenetrePrincipale_jBTStartRefresh_actionAdapter(this));
    jPConnexionLabels.setMaximumSize(new Dimension(90, 105));
    jPConnexionLabels.setMinimumSize(new Dimension(90, 105));
    jPConnexionLabels.setPreferredSize(new Dimension(90, 105));
    bLActionsBoutons.setHgap(0);
    jPCreerEntrepot.add(jBTCreerDW, null);
    jPCreerEntrepot.add(jRBParamHN, null);
    jPCreerEntrepot.add(jRBParamBN, null);
    jPActionsBoutons.add(jPActionsEntrepot,  BorderLayout.CENTER);
    jPConnexionLabels.add(jLBHote, null);
    jPConnexionLabels.add(jLBBase, null);
    jPConnexionLabels.add(jLBUser, null);
    jPConnexionLabels.add(jLBPassword, null);
    jPConnexionBD.add(jPConnexionTextFields, BorderLayout.CENTER);
    jPConnexionBD.add(jPConnexionLabels, BorderLayout.WEST);
    jPStatutConnexion.add(jLBStatutConnexionTitre,  BorderLayout.NORTH);
    jPStatutConnexion.add(jLBStatutConnexion,  BorderLayout.SOUTH);
    jPConnexionBD.add(jLBConnexionBDTitre, BorderLayout.NORTH);
    jPConnexionTextFields.add(jTFHote, null);
    jPConnexionTextFields.add(jTFNomBase, null);
    jPConnexionTextFields.add(jTFUser, null);
    jPConnexionTextFields.add(jPFPassword, null);
    jPConnexionBD.add(jPConnexionBoutons,  BorderLayout.EAST);
    jPConnexionBoutons.add(jBTConnexion, null);
    jPConnexionBoutons.add(jBTDeconnexion, null);
    jPConnexionBoutons.add(jPStatutConnexion, null);
    jPContentPanel.add(jPConnexionBD, BorderLayout.NORTH);
    jPContentPanel.add(jPActions, BorderLayout.CENTER);
    jPContentPanel.add(jPInfos,  BorderLayout.SOUTH);
    jPActions.add(jLBActionsTitre, BorderLayout.NORTH);
    jPActions.add(jPActionsBoutons, BorderLayout.CENTER);
    jPInfos.add(jLBInfosTitre,  BorderLayout.NORTH);
    jPInfos.add(jSPMessages, BorderLayout.CENTER);
    jSPMessages.getViewport().add(jTAMessages, null);
    bGChoixNiveau.add(jRBParamBN);
    bGChoixNiveau.add(jRBParamHN);
    jPActionsEntrepot.add(jBTInfosDW, null);
    jPActionsEntrepot.add(jBTRemplirDW, null);
    jPActionsEntrepot.add(jBTResetDW, null);
    jPActionsBoutons.add(jPRequetes, BorderLayout.SOUTH);
    jPRequetes.add(jBTStartRefresh, BorderLayout.SOUTH);
    jPRequetes.add(jBTGenRequetes, BorderLayout.NORTH);
    jPActionsBoutons.add(jPCreerEntrepot,  BorderLayout.NORTH);
  }

  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
  }

////////////////////////////////////////////////////////////////////////////////
// Action sur le bouton connexion                                             //
////////////////////////////////////////////////////////////////////////////////
  public void jBTConnexion_actionPerformed(ActionEvent e) {
    int i;
    String[] message = new String[1];
    String mdp = "";

    // on rcupre le mot de passe
    for (i=0; i < jPFPassword.getPassword().length; i++) {
      mdp += jPFPassword.getPassword()[i];
    }
    // on vide le champ mot de passe
    jPFPassword.setText("");

    // tentative de connexion
    if (maBaseDonnees.connexionBD(jTFHote.getText(), jTFNomBase.getText(), jTFUser.getText(), mdp, message))
    {
      // si connexion ok
      // on change le statut
      jLBStatutConnexion.setForeground(Color.green);
      jLBStatutConnexion.setText("Connected");
      // on active le bouton deconnexion et on desactive le bouton connexion
      jBTConnexion.setEnabled(false);
      jBTDeconnexion.setEnabled(true);
      // on active le bouton crer l'entrept
      jBTCreerDW.setEnabled(true);



      // affichage du message de confirmation de connexion
      jTAMessages.append("--> " + message[0] + "\n");
    }
    else {
      // si connexion nok
      // affichage du message d'erreur de connexion
      jTAMessages.append("--> " + message[0] + "\n");
    }
  }

////////////////////////////////////////////////////////////////////////////////
// Action sur le bouton connexion                                             //
////////////////////////////////////////////////////////////////////////////////
  public void jBTDeconnexion_actionPerformed(ActionEvent e) {
    String[] message = new String[1];

    if (maBaseDonnees.deconnexionBD(message))
    {
      // si deconnexion ok
      // changement du statut
      jLBStatutConnexion.setForeground(Color.red);
      jLBStatutConnexion.setText("Not connected");
      // activation du bouton connexion
      jBTConnexion.setEnabled(true);
      // desactivation de tous les boutons
      jBTDeconnexion.setEnabled(false);
      jBTCreerDW.setEnabled(false);
      jBTInfosDW.setEnabled(false);
      jBTRemplirDW.setEnabled(false);
      jBTResetDW.setEnabled(false);
      // affichage message de confirmation de deconnexion
      jTAMessages.append("--> " + message[0] + "\n");
    }
    else {
      // affichage message d'erreur de deconnexion
      jTAMessages.append("--> " + message[0] + "\n");
    }
  }

////////////////////////////////////////////////////////////////////////////////
// Action sur le bouton crer entrept                                        //
//----------------------------------------------------------------------------//
// REM : les fentres DLGParametresHN et DLGParametresBN sont modales         //
// --> la fonction est donc interrompue jusqu' ce que la fentre soit ferme //
//     par l'utilisateur                                                      //
// --> si annulation user : appel  "dispose()", la fentre est dtruite et   //
//     on ne peut plus y accder                                              //
// --> si validation des paramtres : appel  "hide()", la fentre est cache //
//     on peut encore accder  ses composants pour rcupration des          //
//     paramtres et on appel "dispose()" apres la fin des traitements        //
////////////////////////////////////////////////////////////////////////////////
  public void jBTCreerDW_actionPerformed(ActionEvent e) {
    String[] message = new String[1];
    if (maBaseDonnees.estConnectee()) {
      // cas du parametrage haut niveau
      if (jRBParamHN.isSelected()) {
        // on ouvre la fenetre parametrage haut niveau fParametresHN de type DLGParametresHN
        DLGParametresHN fParametresHN = new DLGParametresHN();
        fParametresHN.setLocationRelativeTo(this);
        fParametresHN.setVisible(true);

        // a la fermeture de fParametresHN : fParametresHN.isDisplayable() <==> fenetre masque par bouton valider --> il faut crer l'entrepot
        if (fParametresHN.isDisplayable()) {
          // cration de l'entrept
          monEntrepot = new EntrepotDonnees(Integer.parseInt(fParametresHN.jTFTFNbTablesFaits.getText()),
                                            Integer.parseInt(fParametresHN.jTFDimNbDimensions.getText()));
          // gnration de l'entrept dans la base
          if (monEntrepot.genererEntrepotHN(maBaseDonnees.getConnexion(),
                                            Integer.parseInt(fParametresHN.jTFTFNbDimensions.getText()),
                                            Integer.parseInt(fParametresHN.jTFTFNbMesures.getText()),
                                            Double.parseDouble(fParametresHN.jTFTFDensit.getText()),
                                            Integer.parseInt(fParametresHN.jTFDimNbNiveaux.getText()),
                                            Integer.parseInt(fParametresHN.jTFDimNbAttributs.getText()),
                                            Integer.parseInt(fParametresHN.jTFDimNbEnrHN.getText()),
                                            Integer.parseInt(fParametresHN.jTFDimFacteurEchelle.getText()),
                                            message)){
            // dsactivation du bouton de cration d'entrepot
            jBTCreerDW.setEnabled(false);
            // activation des boutons d'actions sur l'entrept
            jBTInfosDW.setEnabled(true);
            jBTRemplirDW.setEnabled(true);
            jBTResetDW.setEnabled(true);
            jBTGenRequetes.setEnabled(true);
            jBTStartRefresh.setEnabled(true);
            jTAMessages.append("--> Data warehouse created\n");
          }
          else {
            // si erreur pendant la cration on supprime les tables cres de la base
            monEntrepot.effacerEntrepotBase(maBaseDonnees.getConnexion(),message);
            // affichage du message + des erreurs
            jTAMessages.append("--> Error when creating the data warehouse\n");
            jTAMessages.append(message[0]);
          }
          // apres la cration de l'entrepot on peut liberer l'objet fenetre fParametresHN
          fParametresHN.dispose();
        }
        else
          jTAMessages.append("--> Data warehouse creation canceled\n");
      }
      // cas du parametrage bas niveau
      else if (jRBParamBN.isSelected()) {
        // on ouvre la fenetre parametrage haut niveau fParametresBN de type DLGParametresBN
        DLGParametresBN fParametresBN = new DLGParametresBN();
        fParametresBN.setLocationRelativeTo(this);
        fParametresBN.setVisible(true);

        // a la fermeture de fParametresBN : fParametresBN.isDisplayable() <==> fenetre masque par bouton valider --> il faut crer l'entrepot
        if (fParametresBN.isDisplayable()) {
          monEntrepot = new EntrepotDonnees(Integer.parseInt(fParametresBN.jTFTablesFaitsSaisie.getText()),
                                            Integer.parseInt(fParametresBN.jTFDimensionsSaisie.getText()));

          if (monEntrepot.genererEntrepotBN(maBaseDonnees.getConnexion(),
                                            fParametresBN.dimensions,
                                            fParametresBN.tablesFaits,
                                            message)){
            // on desactive le bouton de cration d'entrepot
            jBTCreerDW.setEnabled(false);
            // activation des boutons d'actions sur l'entrept
            jBTInfosDW.setEnabled(true);
            jBTRemplirDW.setEnabled(true);
            jBTResetDW.setEnabled(true);
            jBTGenRequetes.setEnabled(true);
            jBTStartRefresh.setEnabled(true);
            jTAMessages.append("--> Data warehouse created\n");
          }
          else {
            // si erreur pendant la cration on supprime les tables cres de la base
            monEntrepot.effacerEntrepotBase(maBaseDonnees.getConnexion(),message);
            jTAMessages.append(message[0]);
            jTAMessages.append("--> Error when creating the data warehouse\n");
          }
          // apres la cration de l'entrepot on peut liberer l'objet fenetre fParametresBN
          fParametresBN.dispose();
        }
        else
          jTAMessages.append("--> Data warehouse creation canceled\n");
      }
    }
    else
      jTAMessages.append("--> Data warehouse creation impossible: not connected to database\n");
  }

////////////////////////////////////////////////////////////////////////////////
// Action sur le bouton infos entrept                                        //
////////////////////////////////////////////////////////////////////////////////
  void jBTInfosDW_actionPerformed(ActionEvent e) {
    // affichage d'une boite de dialogue contenant les infos sur l'entrept
    JOptionPane.showMessageDialog(null,monEntrepot.getInfos());
  }

////////////////////////////////////////////////////////////////////////////////
// Action sur le bouton remplir entrept                                      //
////////////////////////////////////////////////////////////////////////////////
//----------------------------------------------------------------------------//
// REM : les fentres DLGParametresHN et DLGParametresBN sont modales         //
// --> la fonction est donc interrompue jusqu' ce que la fentre soit ferme //
//     par l'utilisateur (annulation) ou l'appli (fin du remplissage)         //
// --> si annulation user : appel  "dispose()", la fentre est dtruite      //
//     on vide les enregistrements des tables                                 //
// --> si fermeture par appli : appel  "hide()", la fentre est cache       //
//     puis appel  "dispose()"                                               //
////////////////////////////////////////////////////////////////////////////////
  void jBTRemplirDW_actionPerformed(ActionEvent e) {
    String[] message = new String[1];
    // on cr la fenetre de remplissage
    DLGRemplirEntrepot dlgRemplirEntrepot = new DLGRemplirEntrepot(this, "", true);
    // on passe les parametres a la fenetre
    dlgRemplirEntrepot.setParametres(maBaseDonnees,monEntrepot);
    // on affiche la fenetre
    dlgRemplirEntrepot.setLocationRelativeTo(this);
    dlgRemplirEntrepot.setVisible(true);

    if (dlgRemplirEntrepot.isDisplayable()) {
      jTAMessages.append("--> Data warehouse loaded\n");
      this.jBTRemplirDW.setEnabled(false);
      dlgRemplirEntrepot.dispose();
    }
    else {
      // si remplissage annul par utilisateur on vide l'entrepot
      monEntrepot.viderEntrepot(maBaseDonnees.getConnexion(), message);
      jTAMessages.append("--> Data warehouse loading canceled\n");
    }
  }

////////////////////////////////////////////////////////////////////////////////
// Action sur le bouton reset entrept                                        //
////////////////////////////////////////////////////////////////////////////////
  void jBTResetDW_actionPerformed(ActionEvent e) {
    String[] message = new String[1];
    monEntrepot.effacerEntrepotBase(maBaseDonnees.getConnexion(), message);
    jBTCreerDW.setEnabled(true);
    jBTInfosDW.setEnabled(false);
    jBTRemplirDW.setEnabled(false);
    jBTResetDW.setEnabled(false);
    jBTGenRequetes.setEnabled(false);
    jBTStartRefresh.setEnabled(false);
    jTAMessages.append("--> Data warehouse deleted\n");
}
////////////////////////////////////////////////////////////////////////////////
// Action sur le bouton gnrer requtes                                      //
////////////////////////////////////////////////////////////////////////////////
  void jBTGenRequetes_actionPerformed(ActionEvent e) {
    DLGParametresCharge fParametresCharge = new DLGParametresCharge();
    fParametresCharge.setLocationRelativeTo(this);
    fParametresCharge.setVisible(true);

    if (fParametresCharge.isDisplayable()) {
      if (monEntrepot.genererRequetes("output/dweb-workload.sql",
                                      Integer.parseInt(fParametresCharge.jTFChargeNbRequetes.getText()),
                                      Integer.parseInt(fParametresCharge.jTFChargeNbAttMoyen.getText()),
                                      Integer.parseInt(fParametresCharge.jTFChargeNbRestMoyen.getText()),
                                      Integer.parseInt(fParametresCharge.jTFChargeNbAgregMoyen.getText()),
                                      Double.parseDouble(fParametresCharge.jTFChargeProbOlap.getText()),
                                      Double.parseDouble(fParametresCharge.jTFChargeProbCube.getText()),
                                      Double.parseDouble(fParametresCharge.jTFChargeProbHaving.getText()),
                                      Integer.parseInt(fParametresCharge.jTFChargeNbDDMoyen.getText())))
        jTAMessages.append("--> Workload file generated\n");
      else
        jTAMessages.append("--> Error when generating workload file\n");
      fParametresCharge.dispose();
    }
    else
      jTAMessages.append("--> Workload file generation canceled\n");
  }



void jBTStartRefresh_actionPerformed(ActionEvent e) {
    File monFichierRequetes = new File("output/dweb-workload.sql");
    if (monFichierRequetes.canRead()) {

      // on cr la fenetre de remplissage
      DLGParametresRefresh dlgParametresRefresh = new DLGParametresRefresh(this, "", true);
      // on affiche la fenetre
      dlgParametresRefresh.setLocationRelativeTo(this);
      dlgParametresRefresh.setVisible(true);

      if (dlgParametresRefresh.isDisplayable()) {
    	  // on cr la fenetre de remplissage
          DLGRefreshResult dlgRefreshResult = new DLGRefreshResult(this, "", true);
          // on passe les parametres a la fenetre
          dlgRefreshResult.setParametres(maBaseDonnees, monEntrepot,
        		  						 monFichierRequetes,
        		  						 Double.parseDouble(dlgParametresRefresh.jTFPercentage.getText()),
        		  						 Double.parseDouble(dlgParametresRefresh.jTFDimensions.getText()),
        		  						 Double.parseDouble(dlgParametresRefresh.jTFFactTable.getText()),
        		  						 Integer.parseInt(dlgParametresRefresh.jTFIterations.getText()),
        		  						 Double.parseDouble(dlgParametresRefresh.jTFModification.getText()),
        		  						 Double.parseDouble(dlgParametresRefresh.jTFInsertion.getText())
        		  						 );

          // on affiche la fenetre
          dlgRefreshResult.setLocationRelativeTo(this);
          dlgRefreshResult.setVisible(true);

    	  dlgParametresRefresh.dispose();
      }
    }
    else
      JOptionPane.showMessageDialog(null,"Please generate workload first!");
  }

}
////////////////////////////////////////////////////////////////////////////////

class FRFenetrePrincipale_jBTConnexion_actionAdapter implements java.awt.event.ActionListener {
  FRFenetrePrincipale adaptee;

  FRFenetrePrincipale_jBTConnexion_actionAdapter(FRFenetrePrincipale adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jBTConnexion_actionPerformed(e);
  }
}

class FRFenetrePrincipale_jBTDeconnexion_actionAdapter implements java.awt.event.ActionListener {
  FRFenetrePrincipale adaptee;

  FRFenetrePrincipale_jBTDeconnexion_actionAdapter(FRFenetrePrincipale adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jBTDeconnexion_actionPerformed(e);
  }
}

class FRFenetrePrincipale_jBTCreerDW_actionAdapter implements java.awt.event.ActionListener {
  FRFenetrePrincipale adaptee;

  FRFenetrePrincipale_jBTCreerDW_actionAdapter(FRFenetrePrincipale adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jBTCreerDW_actionPerformed(e);
  }
}

class FRFenetrePrincipale_jBTInfosDW_actionAdapter implements java.awt.event.ActionListener {
  FRFenetrePrincipale adaptee;

  FRFenetrePrincipale_jBTInfosDW_actionAdapter(FRFenetrePrincipale adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jBTInfosDW_actionPerformed(e);
  }
}

class FRFenetrePrincipale_jBTRemplirDW_actionAdapter implements java.awt.event.ActionListener {
  FRFenetrePrincipale adaptee;

  FRFenetrePrincipale_jBTRemplirDW_actionAdapter(FRFenetrePrincipale adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jBTRemplirDW_actionPerformed(e);
  }
}

class FRFenetrePrincipale_jBTResetDW_actionAdapter implements java.awt.event.ActionListener {
  FRFenetrePrincipale adaptee;

  FRFenetrePrincipale_jBTResetDW_actionAdapter(FRFenetrePrincipale adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jBTResetDW_actionPerformed(e);
  }
}

class FRFenetrePrincipale_jBTGenRequetes_actionAdapter implements java.awt.event.ActionListener {
  FRFenetrePrincipale adaptee;

  FRFenetrePrincipale_jBTGenRequetes_actionAdapter(FRFenetrePrincipale adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jBTGenRequetes_actionPerformed(e);
  }
}

class FRFenetrePrincipale_jBTStartRefresh_actionAdapter implements java.awt.event.ActionListener {
	  FRFenetrePrincipale adaptee;

	  FRFenetrePrincipale_jBTStartRefresh_actionAdapter(FRFenetrePrincipale adaptee) {
	    this.adaptee = adaptee;
	  }
	  public void actionPerformed(ActionEvent e) {
	    adaptee.jBTStartRefresh_actionPerformed(e);
	  }
	}
