////////////////////////////////////////////////////////////////////////////////
// DWEB - DATAWAREHOUSE ENGINEERING BENCHMARK - VERSION 0.31e - CLIENT        //
//----------------------------------------------------------------------------//
// AUTEURS : JOUBERT Bruno                                                    //
//           UNIVERSITE LYON 2 - MASTER IIDEE                                 //
//----------------------------------------------------------------------------//
// English translation by J. Darmont                                          //
// - Step 1: Interface (DONE)                                                 //
// - Step 2: Code/comments (TO DO)                                            //
//----------------------------------------------------------------------------//
// DESCRIPTION : Banc d'essai dcisionnel                                     //
//----------------------------------------------------------------------------//
// Cette application a pour but de permettre de mesurer les rponses          //
// d'un entrept synthtique                                                  //
////////////////////////////////////////////////////////////////////////////////

package dweb03client;

import java.util.GregorianCalendar ;
import java.util.Calendar ;
import java.util.Date ;

////////////////////////////////////////////////////////////////////////////////
// CLASSE Chronometre                                                         //
//----------------------------------------------------------------------------//
// Cette classe permet de faire des mesures de temps.                         //
////////////////////////////////////////////////////////////////////////////////

public class Chronometre {

////////////////////////////////////////////////////////////////////////////////
// ATTRIBUTS                                                                  //
////////////////////////////////////////////////////////////////////////////////
  Calendar start = new GregorianCalendar();
  Calendar stop = new GregorianCalendar();

////////////////////////////////////////////////////////////////////////////////
// METHODES                                                                   //
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// FONCTION start - OK                                                        //
//----------------------------------------------------------------------------//
// Dmarre le chronomtre                                                     //
////////////////////////////////////////////////////////////////////////////////
  public void start() {
    this.start.setTime(new Date());
  }

////////////////////////////////////////////////////////////////////////////////
// FONCTION stop - OK                                                         //
//----------------------------------------------------------------------------//
// Arrte le chronomtre                                                      //
////////////////////////////////////////////////////////////////////////////////
  public void stop() {
    this.stop.setTime(new Date());
  }

////////////////////////////////////////////////////////////////////////////////
// FONCTION getMilliSec - OK                                                  //
//----------------------------------------------------------------------------//
// Retourne le temps coul entre start et stop                               //
////////////////////////////////////////////////////////////////////////////////
  public long getMilliSec() {
    return (this.stop.getTimeInMillis() - this.start.getTimeInMillis());
  }

////////////////////////////////////////////////////////////////////////////////
// FONCTION getSec - OK                                                  //
//----------------------------------------------------------------------------//
// Retourne le temps coul entre start et stop                               //
////////////////////////////////////////////////////////////////////////////////
  public long getSec() {
    return (this.stop.getTimeInMillis() - this.start.getTimeInMillis())/1000;
  }

////////////////////////////////////////////////////////////////////////////////
}
