////////////////////////////////////////////////////////////////////////////////
// DWEB - DATAWAREHOUSE ENGINEERING BENCHMARK - VERSION 0.31e - CLIENT        //
//----------------------------------------------------------------------------//
// AUTEURS : JOUBERT Bruno                                                    //
//           UNIVERSITE LYON 2 - MASTER IIDEE                                 //
//----------------------------------------------------------------------------//
// English translation by J. Darmont                                          //
// - Step 1: Interface (DONE)                                                 //
// - Step 2: Code/comments (TO DO)                                            //
//----------------------------------------------------------------------------//
// DESCRIPTION : Banc d'essai dcisionnel                                     //
//----------------------------------------------------------------------------//
// Cette application a pour but de permettre de mesurer les rponses          //
// d'un entrept synthtique                                                  //
////////////////////////////////////////////////////////////////////////////////

package dweb03client;

import java.io.*;
import java.util.* ;
import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.sql.*;

import dweb03.*;

public class DLGExecuterCharge extends JDialog implements Runnable {
////////////////////////////////////////////////////////////////////////////////
  BaseDonnees maBaseDonnees;
  File monFichierRequetes;
  Vector maChargeRequetes = new Vector();
  Vector typesRequetes = new Vector();
  Vector tempsRequetes = new Vector();
  Thread thread = new Thread (this);
  boolean threadActif = true;

  DefaultListModel LResultats = new DefaultListModel();

  JPanel panel = new JPanel();
  BorderLayout borderLayout = new BorderLayout();
  BorderLayout bLInfosCharge = new BorderLayout();
  BorderLayout bLResultats = new BorderLayout();
  JPanel jPCharge = new JPanel();
  JLabel jLBChargeTitre = new JLabel();
  JPanel jPInfosCharge = new JPanel();
  JLabel jLBResultatsTitre = new JLabel();
  JPanel jPResultats = new JPanel();
  BorderLayout bLCharge = new BorderLayout();
  JLabel jLBTitreNbRequetes = new JLabel();
  JPanel jPNbRequetes = new JPanel();
  JPanel jPDetailsNbRequetes = new JPanel();
  JPanel jPExecuter = new JPanel();
  FlowLayout fLNbRequetes = new FlowLayout();
  JPanel jPNbRequetesOLAP = new JPanel();
  JPanel jPNbRequetesDD = new JPanel();
  JPanel jPNbRequetesExt = new JPanel();
  BorderLayout bLDetailsNbRequetes = new BorderLayout();
  JButton jBTExecuter = new JButton();
  FlowLayout fLExecuter = new FlowLayout();
  JLabel jLBNbRequetes = new JLabel();
  JLabel jLBTitreNbRequetesExt = new JLabel();
  JLabel jLBTitreNbRequetesOLAP = new JLabel();
  JLabel jLBNbRequetesOLAP = new JLabel();
  JLabel jLBTitreNbRequetesDD = new JLabel();
  JLabel jLBNbRequetesDD = new JLabel();
  JLabel jLBNbRequetesExt = new JLabel();
  FlowLayout fLNbRequetesExt = new FlowLayout();
  FlowLayout fLNbRequetesOLAP = new FlowLayout();
  FlowLayout fLNbRequetesDD = new FlowLayout();
  JList jListeResultats = new JList(LResultats);
  JPanel jPResultatTotal = new JPanel();
  JLabel jLBTitreResultatTotal = new JLabel();
  JLabel jLBResultatTotal = new JLabel();
  FlowLayout fLResultatTotal = new FlowLayout();
  JScrollPane jSPListeResultats = new JScrollPane();

  public DLGExecuterCharge(Frame frame, String title, boolean modal) {
    super(frame, title, modal);
    try {
      jbInit();
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  public DLGExecuterCharge() {
    this(null, "", false);
  }

  private void jbInit() throws Exception {
    panel.setLayout(borderLayout);
    this.setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
    this.setModal(true);
    this.setResizable(false);
    this.setTitle("Workload execution");
    bLInfosCharge.setHgap(0);
    bLInfosCharge.setVgap(0);
    jPCharge.setBorder(BorderFactory.createEtchedBorder());
    jPCharge.setMaximumSize(new Dimension(0, 0));
    jPCharge.setMinimumSize(new Dimension(0, 0));
    jPCharge.setPreferredSize(new Dimension(0, 170));
    jPCharge.setLayout(bLCharge);
    jLBChargeTitre.setText("Workload");
    jLBChargeTitre.setHorizontalTextPosition(SwingConstants.CENTER);
    jLBChargeTitre.setHorizontalAlignment(SwingConstants.CENTER);
    jLBChargeTitre.setPreferredSize(new Dimension(0, 20));
    jLBChargeTitre.setMinimumSize(new Dimension(0, 20));
    jLBChargeTitre.setMaximumSize(new Dimension(0, 20));
    jLBChargeTitre.setBorder(BorderFactory.createRaisedBevelBorder());
    jLBChargeTitre.setAlignmentY((float) 0.0);
    jLBChargeTitre.setAlignmentX((float) 0.0);
    jLBChargeTitre.setFont(new java.awt.Font("Arial", 1, 12));
    jPInfosCharge.setBorder(BorderFactory.createEtchedBorder());
    jPInfosCharge.setMaximumSize(new Dimension(0, 90));
    jPInfosCharge.setMinimumSize(new Dimension(0, 90));
    jPInfosCharge.setPreferredSize(new Dimension(0, 90));
    jPInfosCharge.setLayout(bLInfosCharge);
    jLBResultatsTitre.setText("Results");
    jLBResultatsTitre.setHorizontalTextPosition(SwingConstants.CENTER);
    jLBResultatsTitre.setHorizontalAlignment(SwingConstants.CENTER);
    jLBResultatsTitre.setPreferredSize(new Dimension(290, 20));
    jLBResultatsTitre.setMinimumSize(new Dimension(290, 20));
    jLBResultatsTitre.setMaximumSize(new Dimension(290, 20));
    jLBResultatsTitre.setBorder(BorderFactory.createRaisedBevelBorder());
    jLBResultatsTitre.setAlignmentY((float) 0.0);
    jLBResultatsTitre.setAlignmentX((float) 0.0);
    jLBResultatsTitre.setFont(new java.awt.Font("Arial", 1, 12));
    jPResultats.setLayout(bLResultats);
    jPResultats.setBorder(BorderFactory.createEtchedBorder());
    jPResultats.setMaximumSize(new Dimension(0, 0));
    jPResultats.setMinimumSize(new Dimension(0, 0));
    jPResultats.setPreferredSize(new Dimension(0, 0));
    jLBTitreNbRequetes.setText("Number of queries:");
    jPNbRequetes.setLayout(fLNbRequetes);
    fLNbRequetes.setAlignment(FlowLayout.LEFT);
    jPDetailsNbRequetes.setLayout(bLDetailsNbRequetes);
    jBTExecuter.setText("Execute workload");
    jBTExecuter.addActionListener(new DLGExecuterCharge_jBTExecuter_actionAdapter(this));
    jPExecuter.setLayout(fLExecuter);
    jLBTitreNbRequetesExt.setText("Number of extraction queries:");
    jLBTitreNbRequetesOLAP.setText("Number of OLAP queries:");
    jLBTitreNbRequetesDD.setText("Number of drill-downs:");
    jPNbRequetesExt.setLayout(fLNbRequetesExt);
    fLNbRequetesExt.setAlignment(FlowLayout.LEFT);
    jPNbRequetesOLAP.setLayout(fLNbRequetesOLAP);
    fLNbRequetesOLAP.setAlignment(FlowLayout.LEFT);
    jPNbRequetesDD.setLayout(fLNbRequetesDD);
    fLNbRequetesDD.setAlignment(FlowLayout.LEFT);
    jLBNbRequetes.setText("");
    jLBNbRequetesExt.setText("");
    jLBNbRequetesOLAP.setText("");
    jLBNbRequetesDD.setText("");
    jPDetailsNbRequetes.setBorder(BorderFactory.createEtchedBorder());
    jPNbRequetes.setBorder(BorderFactory.createEtchedBorder());
    panel.setMaximumSize(new Dimension(400, 500));
    panel.setMinimumSize(new Dimension(400, 500));
    panel.setPreferredSize(new Dimension(400, 500));
    jListeResultats.setEnabled(true);
    jListeResultats.setBorder(null);
    jListeResultats.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    jLBTitreResultatTotal.setText("Workload total execution time:");
    jPResultatTotal.setLayout(fLResultatTotal);
    fLResultatTotal.setAlignment(FlowLayout.LEFT);
    jLBResultatTotal.setText("");
    jSPListeResultats.setBorder(BorderFactory.createEtchedBorder());
    getContentPane().add(panel);
    jPCharge.add(jLBChargeTitre, BorderLayout.NORTH);
    jPCharge.add(jPInfosCharge, BorderLayout.CENTER);
    panel.add(jPResultats, BorderLayout.CENTER);
    jPResultats.add(jLBResultatsTitre,  BorderLayout.NORTH);
    jPResultats.add(jPResultatTotal,  BorderLayout.SOUTH);
    panel.add(jPCharge,  BorderLayout.NORTH);
    jPInfosCharge.add(jPNbRequetes,  BorderLayout.NORTH);
    jPNbRequetes.add(jLBTitreNbRequetes, null);
    jPInfosCharge.add(jPDetailsNbRequetes,  BorderLayout.CENTER);
    jPInfosCharge.add(jPExecuter,  BorderLayout.SOUTH);
    jPDetailsNbRequetes.add(jPNbRequetesExt, BorderLayout.NORTH);
    jPDetailsNbRequetes.add(jPNbRequetesOLAP,  BorderLayout.CENTER);
    jPDetailsNbRequetes.add(jPNbRequetesDD, BorderLayout.SOUTH);
    jPExecuter.add(jBTExecuter, null);
    jPNbRequetes.add(jLBNbRequetes, null);
    jPNbRequetesOLAP.add(jLBTitreNbRequetesOLAP, null);
    jPNbRequetesOLAP.add(jLBNbRequetesOLAP, null);
    jPNbRequetesExt.add(jLBTitreNbRequetesExt, null);
    jPNbRequetesExt.add(jLBNbRequetesExt, null);
    jPNbRequetesDD.add(jLBTitreNbRequetesDD, null);
    jPNbRequetesDD.add(jLBNbRequetesDD, null);
    jPResultatTotal.add(jLBTitreResultatTotal, null);
    jPResultatTotal.add(jLBResultatTotal, null);
    jPResultats.add(jSPListeResultats,  BorderLayout.CENTER);
    jSPListeResultats.getViewport().add(jListeResultats, null);
  }

  public void executerCharge () {
    thread.start ();
  }

  public void run () {
    int i;
    long temptotal = 0;
    long msec = 0;
    long sec = 0;
    long min = 0;
    String titreResultat;
    Chronometre chronorequete = new Chronometre();

    try {
      Statement statement = maBaseDonnees.getConnexion().createStatement(ResultSet.TYPE_SCROLL_INSENSITIVE, ResultSet.CONCUR_READ_ONLY);
      ResultSet rs;

      tempsRequetes.clear();
      for (i=0;i<maChargeRequetes.size();i++) {
        titreResultat = "Query #" + Integer.toString(i+1) + " (" + typesRequetes.get(i).toString() + ") : ";
        LResultats.addElement(titreResultat + " in process...");

        chronorequete.start();
        rs = statement.executeQuery(maChargeRequetes.get(i).toString());
        chronorequete.stop();

        tempsRequetes.addElement(Long.toString(chronorequete.getMilliSec()));
        temptotal += chronorequete.getMilliSec();

        LResultats.setElementAt(titreResultat + Long.toString(chronorequete.getMilliSec()) + " msec",i);
      }

      msec=temptotal%1000;
      temptotal /= 1000;

      sec=temptotal%60;
      temptotal /= 60;

      min = temptotal;

      jLBResultatTotal.setText(Long.toString(min) + "\' " + Long.toString(sec) + "\'\' " + Long.toString(msec));
      statement.close();

      if (JOptionPane.showConfirmDialog(null, "Do you want to save the results?", "Workload executed", JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION) {
        PrintWriter monFichier;
        monFichier = new PrintWriter(new BufferedWriter(new FileWriter("dweb_results.csv")));
        for (i=0;i<maChargeRequetes.size();i++) {
          monFichier.println(Integer.toString(i+1) + ";" + typesRequetes.get(i).toString() + ";" + tempsRequetes.get(i).toString());
        }
        monFichier.close();
        JOptionPane.showMessageDialog(null,"Results saved");
      }
    }
    catch (SQLException sqle) {
      JOptionPane.showMessageDialog(null,"--> Exception: " + sqle);
    }
    catch (IOException ioe) {
      JOptionPane.showMessageDialog(null,"--> Exception: " + ioe);
    }

  }

  public void setParametres (BaseDonnees pBaseDonnees, File pFichierRequetes) {
    this.maBaseDonnees = pBaseDonnees;
    this.monFichierRequetes = pFichierRequetes;
    maChargeRequetes.clear();
    typesRequetes.clear();

    try {
      int nbext = 0;
      int nbcube = 0;
      int nbrollup = 0;
      int nbdd = 0;

      String lignetitre;
      String lignerequete;

      BufferedReader reader = new BufferedReader(new FileReader(this.monFichierRequetes));

      lignetitre = reader.readLine();
      lignerequete = reader.readLine();

      while (lignetitre != null && lignerequete != null) {
        if (lignetitre.equals("-- Extraction query")) {
          nbext++;
          typesRequetes.addElement("EXTRACTION");
        }
        else if (lignetitre.equals("-- OLAP query")) {
          if (lignerequete.indexOf("CUBE") == -1) {
            nbrollup++;
            typesRequetes.addElement("OLAP ROLLUP");
          }
          else {
            nbcube++;
            typesRequetes.addElement("OLAP CUBE");
          }
        }
        else if (lignetitre.equals("-- Drill-down query")) {
          nbdd++;
          typesRequetes.addElement("OLAP DRILL DOWN");
        }

        maChargeRequetes.addElement(lignerequete);

        lignetitre = reader.readLine();
        lignerequete = reader.readLine();
      }
      reader.close();

      this.jLBNbRequetes.setText(Integer.toString(nbext+nbcube+nbrollup+nbdd));
      this.jLBNbRequetesExt.setText(Integer.toString(nbext));
      this.jLBNbRequetesOLAP.setText(Integer.toString(nbcube+nbrollup) + " (\"CUBE\" : " + Integer.toString(nbcube) + ", \"ROLLUP\" : " + Integer.toString(nbrollup) + ")");
      this.jLBNbRequetesDD.setText(Integer.toString(nbdd));
    }
    catch (Exception exceptfichier){}
  }

  void jBTExecuter_actionPerformed(ActionEvent e) {
    if (!maChargeRequetes.isEmpty())
      this.executerCharge();
    else
      JOptionPane.showMessageDialog(null,"Workload is empty!");
  }
}

class DLGExecuterCharge_jBTExecuter_actionAdapter implements java.awt.event.ActionListener {
  DLGExecuterCharge adaptee;

  DLGExecuterCharge_jBTExecuter_actionAdapter(DLGExecuterCharge adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jBTExecuter_actionPerformed(e);
  }
}
