////////////////////////////////////////////////////////////////////////////////
// DWEB - DATAWAREHOUSE ENGINEERING BENCHMARK - VERSION 0.31e - CLIENT        //
//----------------------------------------------------------------------------//
// AUTEURS : JOUBERT Bruno                                                    //
//           UNIVERSITE LYON 2 - MASTER IIDEE                                 //
//----------------------------------------------------------------------------//
// English translation by J. Darmont                                          //
// - Step 1: Interface (DONE)                                                 //
// - Step 2: Code/comments (TO DO)                                            //
//----------------------------------------------------------------------------//
// DESCRIPTION : Banc d'essai dcisionnel                                     //
//----------------------------------------------------------------------------//
// Cette application a pour but de permettre de mesurer les rponses          //
// d'un entrept synthtique                                                  //
////////////////////////////////////////////////////////////////////////////////

package dweb03client;

import java.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

import dweb03.*;

public class FRFenetrePrincipale extends JFrame {
  // La base de donnes est dfinie comme un attribut de la fentre
  BaseDonnees maBaseDonnees = new BaseDonnees();

  JPanel contentPane;
  BorderLayout borderLayout = new BorderLayout();
  JButton jBTConnexion = new JButton();
  JButton jBTDeconnexion = new JButton();
  JLabel jLBConnexionBDTitre = new JLabel();
  JPanel jPConnexionBoutons = new JPanel();
  JLabel jLBBase = new JLabel();
  JLabel jLBStatutConnexion = new JLabel();
  JTextField jTFHote = new JTextField();
  JTextField jTFNomBase = new JTextField();
  JPanel jPConnexionLabels = new JPanel();
  BorderLayout bLStatutConnexion = new BorderLayout();
  JLabel jLBPassword = new JLabel();
  JPanel jPConnexionTextFields = new JPanel();
  JLabel jLBUser = new JLabel();
  JPanel jPStatutConnexion = new JPanel();
  JLabel jLBStatutConnexionTitre = new JLabel();
  BorderLayout bLConnexionBD = new BorderLayout();
  JTextField jTFUser = new JTextField();
  JLabel jLBHote = new JLabel();
  JPanel jPConnexionBD = new JPanel();
  JPasswordField jPFPassword = new JPasswordField();
  JPanel jPCharge = new JPanel();
  JLabel jLBChargeTitre = new JLabel();
  BorderLayout bLCharge = new BorderLayout();
  JPanel jPOuvrirCharge = new JPanel();
  JButton jBTOuvrirCharge = new JButton();
  JButton jBTParcourir = new JButton();
  JTextField jTFChemin = new JTextField();
  JLabel jLBTitreChemin = new JLabel();
  BorderLayout bLOuvrirCharge = new BorderLayout();
  JPanel jPTitreChemin = new JPanel();
  JPanel jPChemin = new JPanel();
  JPanel jPOuvrir = new JPanel();
  FlowLayout fLChemin = new FlowLayout();
  FlowLayout fLTitreChemin = new FlowLayout();
  FlowLayout fLOuvrir = new FlowLayout();

  //Construct the frame
  public FRFenetrePrincipale() {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  //Component initialization
  private void jbInit() throws Exception  {
    contentPane = (JPanel) this.getContentPane();
    jPConnexionBoutons.setPreferredSize(new Dimension(105, 105));
    jPConnexionBoutons.setMinimumSize(new Dimension(105, 105));
    jPConnexionBoutons.setMaximumSize(new Dimension(105, 105));
    jPConnexionBoutons.setLayout(null);
    jLBConnexionBDTitre.setText("Database connection");
    jLBConnexionBDTitre.setHorizontalTextPosition(SwingConstants.CENTER);
    jLBConnexionBDTitre.setHorizontalAlignment(SwingConstants.CENTER);
    jLBConnexionBDTitre.setPreferredSize(new Dimension(290, 20));
    jLBConnexionBDTitre.setMinimumSize(new Dimension(290, 20));
    jLBConnexionBDTitre.setMaximumSize(new Dimension(290, 20));
    jLBConnexionBDTitre.setBorder(BorderFactory.createRaisedBevelBorder());
    jLBConnexionBDTitre.setAlignmentY((float) 0.0);
    jLBConnexionBDTitre.setAlignmentX((float) 0.0);
    jLBConnexionBDTitre.setFont(new java.awt.Font("Arial", 1, 12));
    jBTDeconnexion.setFont(new java.awt.Font("Arial", 0, 11));
    jBTDeconnexion.setFont(new java.awt.Font("Arial", 0, 11));
    jBTDeconnexion.setEnabled(false);
    jBTDeconnexion.setBounds(new Rectangle(5, 30, 96, 20));
    jBTDeconnexion.setMaximumSize(new Dimension(96, 20));
    jBTDeconnexion.setMinimumSize(new Dimension(96, 20));
    jBTDeconnexion.setPreferredSize(new Dimension(90, 20));
    jBTDeconnexion.setHorizontalTextPosition(SwingConstants.CENTER);
    jBTDeconnexion.setText("Log out");
    jBTDeconnexion.addActionListener(new FRFenetrePrincipale_jBTDeconnexion_actionAdapter(this));
    jBTConnexion.addActionListener(new FRFenetrePrincipale_jBTConnexion_actionAdapter(this));
    jBTConnexion.setText("Log in");
    jBTConnexion.setHorizontalTextPosition(SwingConstants.CENTER);
    jBTConnexion.setPreferredSize(new Dimension(96, 20));
    jBTConnexion.setMinimumSize(new Dimension(96, 20));
    jBTConnexion.setMaximumSize(new Dimension(96, 20));
    jBTConnexion.setFont(new java.awt.Font("Arial", 0, 11));
    jBTConnexion.setBounds(new Rectangle(5, 5, 96, 20));
    contentPane.setLayout(borderLayout);
    this.setDefaultCloseOperation(EXIT_ON_CLOSE);
    this.setLocale(java.util.Locale.getDefault());
    this.setResizable(false);
    this.setSize(new Dimension(320, 280));
    this.setTitle("DWEB - Workload executor");
    jLBBase.setFont(new java.awt.Font("Arial", 0, 11));
    jLBBase.setMaximumSize(new Dimension(85, 20));
    jLBBase.setMinimumSize(new Dimension(85, 20));
    jLBBase.setPreferredSize(new Dimension(74, 20));
    jLBBase.setText("Database name:");
    jLBBase.setBounds(new Rectangle(5, 30, 85, 20));
    jLBStatutConnexion.setFont(new java.awt.Font("Arial", 1, 11));
    jLBStatutConnexion.setForeground(Color.red);
    jLBStatutConnexion.setMaximumSize(new Dimension(90, 20));
    jLBStatutConnexion.setMinimumSize(new Dimension(90, 20));
    jLBStatutConnexion.setPreferredSize(new Dimension(90, 20));
    jLBStatutConnexion.setHorizontalAlignment(SwingConstants.CENTER);
    jLBStatutConnexion.setHorizontalTextPosition(SwingConstants.LEFT);
    jLBStatutConnexion.setText("Not connected");
    jTFHote.setHorizontalAlignment(SwingConstants.CENTER);
    jTFHote.setScrollOffset(0);
    jTFHote.setBounds(new Rectangle(5, 5, 105, 20));
    jTFHote.setPreferredSize(new Dimension(85, 20));
    jTFHote.setMargin(new Insets(1, 5, 2, 4));
    jTFHote.setText("");
    jTFHote.setMinimumSize(new Dimension(85, 20));
    jTFHote.setAlignmentX((float) 1.0);
    jTFHote.setBorder(BorderFactory.createLineBorder(Color.black));
    jTFNomBase.setBorder(BorderFactory.createLineBorder(Color.black));
    jTFNomBase.setMinimumSize(new Dimension(85, 20));
    jTFNomBase.setPreferredSize(new Dimension(85, 20));
    jTFNomBase.setMargin(new Insets(1, 5, 2, 4));
    jTFNomBase.setText("");
    jTFNomBase.setHorizontalAlignment(SwingConstants.CENTER);
    jTFNomBase.setBounds(new Rectangle(5, 30, 105, 20));
    jPConnexionLabels.setLayout(null);
    jPConnexionLabels.setMaximumSize(new Dimension(90, 105));
    jPConnexionLabels.setMinimumSize(new Dimension(90, 105));
    jPConnexionLabels.setPreferredSize(new Dimension(90, 105));
    jLBPassword.setFont(new java.awt.Font("Arial", 0, 11));
    jLBPassword.setMaximumSize(new Dimension(85, 20));
    jLBPassword.setMinimumSize(new Dimension(85, 20));
    jLBPassword.setPreferredSize(new Dimension(85, 20));
    jLBPassword.setText("Password:");
    jLBPassword.setBounds(new Rectangle(5, 80, 85, 20));
    jPConnexionTextFields.setLayout(null);
    jPConnexionTextFields.setMaximumSize(new Dimension(95, 105));
    jPConnexionTextFields.setMinimumSize(new Dimension(95, 105));
    jPConnexionTextFields.setPreferredSize(new Dimension(95, 105));
    jLBUser.setFont(new java.awt.Font("Arial", 0, 11));
    jLBUser.setMaximumSize(new Dimension(85, 20));
    jLBUser.setMinimumSize(new Dimension(85, 20));
    jLBUser.setPreferredSize(new Dimension(78, 20));
    jLBUser.setText("User name:");
    jLBUser.setBounds(new Rectangle(5, 55, 85, 20));
    jPStatutConnexion.setBorder(BorderFactory.createEtchedBorder());
    jPStatutConnexion.setMinimumSize(new Dimension(96, 45));
    jPStatutConnexion.setPreferredSize(new Dimension(85, 45));
    jPStatutConnexion.setBounds(new Rectangle(5, 55, 96, 45));
    jPStatutConnexion.setLayout(bLStatutConnexion);
    jLBStatutConnexionTitre.setFont(new java.awt.Font("Arial", 1, 11));
    jLBStatutConnexionTitre.setBorder(BorderFactory.createEtchedBorder());
    jLBStatutConnexionTitre.setMaximumSize(new Dimension(90, 20));
    jLBStatutConnexionTitre.setMinimumSize(new Dimension(90, 20));
    jLBStatutConnexionTitre.setPreferredSize(new Dimension(90, 20));
    jLBStatutConnexionTitre.setHorizontalAlignment(SwingConstants.CENTER);
    jLBStatutConnexionTitre.setHorizontalTextPosition(SwingConstants.CENTER);
    jLBStatutConnexionTitre.setText("Status");
    jTFUser.setBorder(BorderFactory.createLineBorder(Color.black));
    jTFUser.setMinimumSize(new Dimension(85, 20));
    jTFUser.setPreferredSize(new Dimension(85, 20));
    jTFUser.setCaretPosition(0);
    jTFUser.setMargin(new Insets(1, 5, 2, 4));
    jTFUser.setText("");
    jTFUser.setHorizontalAlignment(SwingConstants.CENTER);
    jTFUser.setBounds(new Rectangle(5, 55, 105, 20));
    jLBHote.setText("Server address:");
    jLBHote.setBounds(new Rectangle(5, 5, 85, 20));
    jLBHote.setFont(new java.awt.Font("Arial", 0, 11));
    jLBHote.setMaximumSize(new Dimension(85, 20));
    jLBHote.setMinimumSize(new Dimension(85, 20));
    jLBHote.setPreferredSize(new Dimension(85, 20));
    jPConnexionBD.setLayout(bLConnexionBD);
    jPConnexionBD.setBorder(BorderFactory.createEtchedBorder());
    jPConnexionBD.setMaximumSize(new Dimension(0, 130));
    jPConnexionBD.setMinimumSize(new Dimension(0, 130));
    jPConnexionBD.setPreferredSize(new Dimension(0, 130));
    jPFPassword.setBorder(BorderFactory.createLineBorder(Color.black));
    jPFPassword.setMinimumSize(new Dimension(85, 20));
    jPFPassword.setPreferredSize(new Dimension(85, 20));
    jPFPassword.setCaretPosition(0);
    jPFPassword.setMargin(new Insets(1, 5, 2, 4));
    jPFPassword.setHorizontalAlignment(SwingConstants.CENTER);
    jPFPassword.setEchoChar('*');
    jPFPassword.setBounds(new Rectangle(5, 80, 105, 20));
    contentPane.setMaximumSize(new Dimension(300, 400));
    contentPane.setMinimumSize(new Dimension(300, 400));
    contentPane.setPreferredSize(new Dimension(300, 400));
    jPCharge.setBorder(BorderFactory.createEtchedBorder());
    jPCharge.setMaximumSize(new Dimension(0, 130));
    jPCharge.setMinimumSize(new Dimension(0, 130));
    jPCharge.setPreferredSize(new Dimension(0, 130));
    jPCharge.setLayout(bLCharge);
    jLBChargeTitre.setText("Workload");
    jLBChargeTitre.setHorizontalTextPosition(SwingConstants.CENTER);
    jLBChargeTitre.setHorizontalAlignment(SwingConstants.CENTER);
    jLBChargeTitre.setPreferredSize(new Dimension(0, 20));
    jLBChargeTitre.setMinimumSize(new Dimension(0, 20));
    jLBChargeTitre.setMaximumSize(new Dimension(0, 20));
    jLBChargeTitre.setBorder(BorderFactory.createRaisedBevelBorder());
    jLBChargeTitre.setAlignmentY((float) 0.0);
    jLBChargeTitre.setAlignmentX((float) 0.0);
    jLBChargeTitre.setFont(new java.awt.Font("Arial", 1, 12));
    jPOuvrirCharge.setBorder(BorderFactory.createEtchedBorder());
    jPOuvrirCharge.setMaximumSize(new Dimension(0, 60));
    jPOuvrirCharge.setMinimumSize(new Dimension(0, 60));
    jPOuvrirCharge.setPreferredSize(new Dimension(0, 60));
    jPOuvrirCharge.setLayout(bLOuvrirCharge);
    jBTOuvrirCharge.setEnabled(false);
    jBTOuvrirCharge.setMaximumSize(new Dimension(200, 25));
    jBTOuvrirCharge.setMinimumSize(new Dimension(200, 25));
    jBTOuvrirCharge.setPreferredSize(new Dimension(200, 25));
    jBTOuvrirCharge.setText("Open workload");
    jBTOuvrirCharge.addActionListener(new FRFenetrePrincipale_jBTOuvrirCharge_actionAdapter(this));
    jBTParcourir.setText("...");
    jBTParcourir.addActionListener(new FRFenetrePrincipale_jBTParcourir_actionAdapter(this));
    jTFChemin.setMaximumSize(new Dimension(250, 20));
    jTFChemin.setMinimumSize(new Dimension(250, 20));
    jTFChemin.setPreferredSize(new Dimension(250, 20));
    jTFChemin.setEditable(false);
    jTFChemin.setText("");
    jLBTitreChemin.setText("Workload filepath:");
    jPTitreChemin.setLayout(fLTitreChemin);
    bLOuvrirCharge.setHgap(0);
    bLOuvrirCharge.setVgap(0);
    jPChemin.setLayout(fLChemin);
    fLChemin.setAlignment(FlowLayout.LEFT);
    fLTitreChemin.setAlignment(FlowLayout.LEFT);
    jPOuvrir.setLayout(fLOuvrir);
    jPConnexionTextFields.add(jTFHote, null);
    jPConnexionTextFields.add(jTFNomBase, null);
    jPConnexionTextFields.add(jTFUser, null);
    jPConnexionTextFields.add(jPFPassword, null);
    jPConnexionBD.add(jPConnexionLabels, BorderLayout.WEST);
    jPConnexionBD.add(jPConnexionTextFields, BorderLayout.CENTER);
    jPConnexionLabels.add(jLBHote, null);
    jPConnexionLabels.add(jLBBase, null);
    jPConnexionLabels.add(jLBUser, null);
    jPConnexionLabels.add(jLBPassword, null);
    jPConnexionBD.add(jLBConnexionBDTitre, BorderLayout.NORTH);
    jPConnexionBD.add(jPConnexionBoutons, BorderLayout.EAST);
    jPConnexionBoutons.add(jBTConnexion, null);
    jPConnexionBoutons.add(jBTDeconnexion, null);
    jPConnexionBoutons.add(jPStatutConnexion, null);
    jPStatutConnexion.add(jLBStatutConnexionTitre, BorderLayout.NORTH);
    jPStatutConnexion.add(jLBStatutConnexion, BorderLayout.SOUTH);
    contentPane.add(jPCharge, BorderLayout.CENTER);
    jPCharge.add(jLBChargeTitre,  BorderLayout.NORTH);
    contentPane.add(jPConnexionBD,  BorderLayout.NORTH);
    jPCharge.add(jPOuvrirCharge,  BorderLayout.CENTER);
    jPOuvrirCharge.add(jPTitreChemin,  BorderLayout.NORTH);
    jPTitreChemin.add(jLBTitreChemin, null);
    jPOuvrirCharge.add(jPChemin, BorderLayout.CENTER);
    jPChemin.add(jTFChemin, null);
    jPChemin.add(jBTParcourir, null);
    jPOuvrirCharge.add(jPOuvrir, BorderLayout.SOUTH);
    jPOuvrir.add(jBTOuvrirCharge, null);
  }

  //Overridden so we can exit when window is closed
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      System.exit(0);
    }
  }

  ////////////////////////////////////////////////////////////////////////////////
// Action sur le bouton connexion                                             //
////////////////////////////////////////////////////////////////////////////////
  public void jBTConnexion_actionPerformed(ActionEvent e) {
    int i;
    String[] message = new String[1];
    String mdp = "";

    // on rcupre le mot de passe
    for (i=0; i < jPFPassword.getPassword().length; i++) {
      mdp += jPFPassword.getPassword()[i];
    }
    // on vide le champ mot de passe
    jPFPassword.setText("");

    // tentative de connexion
    if (maBaseDonnees.connexionBD(jTFHote.getText(), jTFNomBase.getText(), jTFUser.getText(), mdp, message))
    {
      // si connexion ok
      // on change le statut
      jLBStatutConnexion.setForeground(Color.green);
      jLBStatutConnexion.setText("Connected");
      // on active le bouton deconnexion et on desactive le bouton connexion
      jBTConnexion.setEnabled(false);
      jBTDeconnexion.setEnabled(true);
      jBTOuvrirCharge.setEnabled(true);
    }
    JOptionPane.showMessageDialog(null,message[0]);
  }

////////////////////////////////////////////////////////////////////////////////
// Action sur le bouton connexion                                             //
////////////////////////////////////////////////////////////////////////////////
  public void jBTDeconnexion_actionPerformed(ActionEvent e) {
    String[] message = new String[1];

    if (maBaseDonnees.deconnexionBD(message))
    {
      // si deconnexion ok
      // changement du statut
      jLBStatutConnexion.setForeground(Color.red);
      jLBStatutConnexion.setText("Not connected");
      // activation du bouton connexion
      jBTConnexion.setEnabled(true);
      // desactivation de tous les boutons
      jBTDeconnexion.setEnabled(false);
      jBTOuvrirCharge.setEnabled(false);
    }
    JOptionPane.showMessageDialog(null,message[0]);
  }

  void jBTParcourir_actionPerformed(ActionEvent e) {
    int retourJFC;
    // On construit un filtre pour la boite de dialogue d'ouverture de fichier
    FiltreFichiersSQL filtreSQL = new FiltreFichiersSQL();
    // On construit l'objet qui va permettre de choisir le fichier  ouvrir
    JFileChooser choixfichier = new JFileChooser();
    choixfichier.setAcceptAllFileFilterUsed(false);
    // On lui donne le filtre dfini ci-dessus pour filtrer les fichiers *.sql
    choixfichier.addChoosableFileFilter(filtreSQL);
    // Affichage de la boite de dialogue d'ouverture de fichier
    retourJFC = choixfichier.showOpenDialog(this);

    // Si l'utilisateur clique sur "Ouvrir" ou valide et que le fichier slectionn est un fichier xml
    if (retourJFC == choixfichier.APPROVE_OPTION) {
      if (choixfichier.getSelectedFile().canRead())
        jTFChemin.setText(choixfichier.getSelectedFile().getAbsolutePath());
    }
  }

  void jBTOuvrirCharge_actionPerformed(ActionEvent e) {
    File monFichierRequetes = new File(jTFChemin.getText());
    if (monFichierRequetes.canRead()) {
      // on cr la fenetre de remplissage
      DLGExecuterCharge dlgExecuterCharge = new DLGExecuterCharge(this, "", true);
      // on passe les parametres a la fenetre
      dlgExecuterCharge.setParametres(maBaseDonnees,monFichierRequetes);
      // on affiche la fenetre
      dlgExecuterCharge.setLocationRelativeTo(this);
      dlgExecuterCharge.setVisible(true);
    }
    else
      JOptionPane.showMessageDialog(null,"Slectionnez le fichier contenant la charge  excuter !");
  }
}
////////////////////////////////////////////////////////////////////////////////

class FRFenetrePrincipale_jBTConnexion_actionAdapter implements java.awt.event.ActionListener {
  FRFenetrePrincipale adaptee;

  FRFenetrePrincipale_jBTConnexion_actionAdapter(FRFenetrePrincipale adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jBTConnexion_actionPerformed(e);
  }
}

class FRFenetrePrincipale_jBTDeconnexion_actionAdapter implements java.awt.event.ActionListener {
  FRFenetrePrincipale adaptee;

  FRFenetrePrincipale_jBTDeconnexion_actionAdapter(FRFenetrePrincipale adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jBTDeconnexion_actionPerformed(e);
  }
}

class FRFenetrePrincipale_jBTParcourir_actionAdapter implements java.awt.event.ActionListener {
  FRFenetrePrincipale adaptee;

  FRFenetrePrincipale_jBTParcourir_actionAdapter(FRFenetrePrincipale adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jBTParcourir_actionPerformed(e);
  }
}

class FRFenetrePrincipale_jBTOuvrirCharge_actionAdapter implements java.awt.event.ActionListener {
  FRFenetrePrincipale adaptee;

  FRFenetrePrincipale_jBTOuvrirCharge_actionAdapter(FRFenetrePrincipale adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jBTOuvrirCharge_actionPerformed(e);
  }
}
